/* PanelPropertiesWindow.c generated by valac 0.56.16, the Vala compiler
 * generated from PanelPropertiesWindow.vala, do not modify */

/* This code was mostly imported from elementary: https://github.com/elementary/scratch/blob/master/src/Dialogs/PropertiesDialog.vala
 *
 * Copyright (c) 2011-2017 elementary LLC (https://elementary.io)
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Giulio Collura <random.cpp@gmail.com>
 *              Mario Guerriero <mario@elementaryos.org>
 *              Fabio Zaramella <ffabio.96.x@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <stdio.h>

#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILEINFO _ ("Properties")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILENAME _ ("Name")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_LOCATION _ ("Location")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_CONTENTTYPE _ ("Type")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_TARGET _ ("Target")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_CONTENT _ ("Content")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_TOTALSIZE _ ("Total size")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_N_ITEMS _ ("items")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_FILESIZE _ ("File size")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_EXECUTE _ ("Execute")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_ALLOWEXECUTE _ ("Allow execution")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_LASTUSED _ ("Used")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_LASTMODIFIED _ ("Modified")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_UNKNOWN _ ("Unknown")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_PROPERTIES _ ("This Panel")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_GENERAL _ ("General")
#define DESKTOP_FOLDER_VERSION "1.1.3"
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_CLOSE _ ("Close")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_BEHAVIOR _ ("Behavior")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT _ ("Icon arrangement:")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_FREE _ ("Free")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_GRID _ ("Grid")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_MANAGED _ ("Let app manage")
#define DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_LOCK_ITEMS _ ("Lock icons:")
#define DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_LOCK_PANEL _ ("Lock panel:")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_APPEARANCE _ ("Appearance")
#define DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_TEXT_SHADOW _ ("Text shadow:")
#define DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_TEXT_BOLD _ ("Text bold:")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_PADDING _ ("Icon spacing:")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_DESKTOP_ICONS _ ("Icons on desktop:")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY _ ("When changing resolution:")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_NONE _ ("Do nothing")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_SCALE _ ("Scale to new resolution")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_STORE _ ("Store per resolution")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_DESCRIPTION _ ("This is how panels, notes and photos will resize when you change the s" \
"creen resolution")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ICONS _ ("Icons")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_DEFAULT _ ("Default icon arrangement:")
#define DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_PADDING_DEFAULT _ ("Default icon spacing:")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO (desktop_folder_dialogs_show_info_get_type ())
#define DESKTOP_FOLDER_DIALOGS_SHOW_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO, DesktopFolderDialogsShowInfo))
#define DESKTOP_FOLDER_DIALOGS_SHOW_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO, DesktopFolderDialogsShowInfoClass))
#define DESKTOP_FOLDER_DIALOGS_IS_SHOW_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO))
#define DESKTOP_FOLDER_DIALOGS_IS_SHOW_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO))
#define DESKTOP_FOLDER_DIALOGS_SHOW_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO, DesktopFolderDialogsShowInfoClass))

typedef struct _DesktopFolderDialogsShowInfo DesktopFolderDialogsShowInfo;
typedef struct _DesktopFolderDialogsShowInfoClass DesktopFolderDialogsShowInfoClass;
typedef struct _DesktopFolderDialogsShowInfoPrivate DesktopFolderDialogsShowInfoPrivate;
enum  {
	DESKTOP_FOLDER_DIALOGS_SHOW_INFO_0_PROPERTY,
	DESKTOP_FOLDER_DIALOGS_SHOW_INFO_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_dialogs_show_info_properties[DESKTOP_FOLDER_DIALOGS_SHOW_INFO_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define DESKTOP_FOLDER_DIALOGS_TYPE_OPEN_WITH (desktop_folder_dialogs_open_with_get_type ())
#define DESKTOP_FOLDER_DIALOGS_OPEN_WITH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_OPEN_WITH, DesktopFolderDialogsOpenWith))
#define DESKTOP_FOLDER_DIALOGS_OPEN_WITH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_DIALOGS_TYPE_OPEN_WITH, DesktopFolderDialogsOpenWithClass))
#define DESKTOP_FOLDER_DIALOGS_IS_OPEN_WITH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_OPEN_WITH))
#define DESKTOP_FOLDER_DIALOGS_IS_OPEN_WITH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_DIALOGS_TYPE_OPEN_WITH))
#define DESKTOP_FOLDER_DIALOGS_OPEN_WITH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_OPEN_WITH, DesktopFolderDialogsOpenWithClass))

typedef struct _DesktopFolderDialogsOpenWith DesktopFolderDialogsOpenWith;
typedef struct _DesktopFolderDialogsOpenWithClass DesktopFolderDialogsOpenWithClass;
typedef struct _DesktopFolderDialogsOpenWithPrivate DesktopFolderDialogsOpenWithPrivate;
enum  {
	DESKTOP_FOLDER_DIALOGS_OPEN_WITH_0_PROPERTY,
	DESKTOP_FOLDER_DIALOGS_OPEN_WITH_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_dialogs_open_with_properties[DESKTOP_FOLDER_DIALOGS_OPEN_WITH_NUM_PROPERTIES];

#define DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES (desktop_folder_dialogs_panel_properties_get_type ())
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES, DesktopFolderDialogsPanelProperties))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES, DesktopFolderDialogsPanelPropertiesClass))
#define DESKTOP_FOLDER_DIALOGS_IS_PANEL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES))
#define DESKTOP_FOLDER_DIALOGS_IS_PANEL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES, DesktopFolderDialogsPanelPropertiesClass))

typedef struct _DesktopFolderDialogsPanelProperties DesktopFolderDialogsPanelProperties;
typedef struct _DesktopFolderDialogsPanelPropertiesClass DesktopFolderDialogsPanelPropertiesClass;
typedef struct _DesktopFolderDialogsPanelPropertiesPrivate DesktopFolderDialogsPanelPropertiesPrivate;

#define DESKTOP_FOLDER_TYPE_FOLDER_WINDOW (desktop_folder_folder_window_get_type ())
#define DESKTOP_FOLDER_FOLDER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow))
#define DESKTOP_FOLDER_FOLDER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindowClass))
#define DESKTOP_FOLDER_IS_FOLDER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW))
#define DESKTOP_FOLDER_IS_FOLDER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW))
#define DESKTOP_FOLDER_FOLDER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindowClass))

typedef struct _DesktopFolderFolderWindow DesktopFolderFolderWindow;
typedef struct _DesktopFolderFolderWindowClass DesktopFolderFolderWindowClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_MANAGER (desktop_folder_folder_manager_get_type ())
#define DESKTOP_FOLDER_FOLDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManager))
#define DESKTOP_FOLDER_FOLDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManagerClass))
#define DESKTOP_FOLDER_IS_FOLDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER))
#define DESKTOP_FOLDER_IS_FOLDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER))
#define DESKTOP_FOLDER_FOLDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManagerClass))

typedef struct _DesktopFolderFolderManager DesktopFolderFolderManager;
typedef struct _DesktopFolderFolderManagerClass DesktopFolderFolderManagerClass;
enum  {
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_0_PROPERTY,
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_dialogs_panel_properties_properties[DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_NUM_PROPERTIES];
typedef enum  {
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_NONE,
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_SCALE,
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_STORE
} DesktopFolderDialogsPanelPropertiesResolutionStrategy;

#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_RESOLUTION_STRATEGY (desktop_folder_dialogs_panel_properties_resolution_strategy_get_type ())
typedef struct _Block34Data Block34Data;

#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_HEADER (desktop_folder_dialogs_panel_properties_settings_header_get_type ())
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_HEADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_HEADER, DesktopFolderDialogsPanelPropertiesSettingsHeader))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_HEADER, DesktopFolderDialogsPanelPropertiesSettingsHeaderClass))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_IS_SETTINGS_HEADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_HEADER))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_IS_SETTINGS_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_HEADER))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_HEADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_HEADER, DesktopFolderDialogsPanelPropertiesSettingsHeaderClass))

typedef struct _DesktopFolderDialogsPanelPropertiesSettingsHeader DesktopFolderDialogsPanelPropertiesSettingsHeader;
typedef struct _DesktopFolderDialogsPanelPropertiesSettingsHeaderClass DesktopFolderDialogsPanelPropertiesSettingsHeaderClass;

#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_LABEL (desktop_folder_dialogs_panel_properties_settings_label_get_type ())
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_LABEL, DesktopFolderDialogsPanelPropertiesSettingsLabel))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_LABEL, DesktopFolderDialogsPanelPropertiesSettingsLabelClass))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_IS_SETTINGS_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_LABEL))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_IS_SETTINGS_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_LABEL))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_LABEL, DesktopFolderDialogsPanelPropertiesSettingsLabelClass))

typedef struct _DesktopFolderDialogsPanelPropertiesSettingsLabel DesktopFolderDialogsPanelPropertiesSettingsLabel;
typedef struct _DesktopFolderDialogsPanelPropertiesSettingsLabelClass DesktopFolderDialogsPanelPropertiesSettingsLabelClass;

#define DESKTOP_FOLDER_TYPE_POSITION_SETTINGS (desktop_folder_position_settings_get_type ())
#define DESKTOP_FOLDER_POSITION_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettings))
#define DESKTOP_FOLDER_POSITION_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettingsClass))
#define DESKTOP_FOLDER_IS_POSITION_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS))
#define DESKTOP_FOLDER_IS_POSITION_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS))
#define DESKTOP_FOLDER_POSITION_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettingsClass))

typedef struct _DesktopFolderPositionSettings DesktopFolderPositionSettings;
typedef struct _DesktopFolderPositionSettingsClass DesktopFolderPositionSettingsClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS (desktop_folder_folder_settings_get_type ())
#define DESKTOP_FOLDER_FOLDER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettings))
#define DESKTOP_FOLDER_FOLDER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettingsClass))
#define DESKTOP_FOLDER_IS_FOLDER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS))
#define DESKTOP_FOLDER_IS_FOLDER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS))
#define DESKTOP_FOLDER_FOLDER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettingsClass))

typedef struct _DesktopFolderFolderSettings DesktopFolderFolderSettings;
typedef struct _DesktopFolderFolderSettingsClass DesktopFolderFolderSettingsClass;

#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_SWITCH (desktop_folder_dialogs_panel_properties_settings_switch_get_type ())
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_SWITCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_SWITCH, DesktopFolderDialogsPanelPropertiesSettingsSwitch))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_SWITCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_SWITCH, DesktopFolderDialogsPanelPropertiesSettingsSwitchClass))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_IS_SETTINGS_SWITCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_SWITCH))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_IS_SETTINGS_SWITCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_SWITCH))
#define DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_SWITCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_SWITCH, DesktopFolderDialogsPanelPropertiesSettingsSwitchClass))

typedef struct _DesktopFolderDialogsPanelPropertiesSettingsSwitch DesktopFolderDialogsPanelPropertiesSettingsSwitch;
typedef struct _DesktopFolderDialogsPanelPropertiesSettingsSwitchClass DesktopFolderDialogsPanelPropertiesSettingsSwitchClass;

#define DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW (desktop_folder_desktop_window_get_type ())
#define DESKTOP_FOLDER_DESKTOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindow))
#define DESKTOP_FOLDER_DESKTOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindowClass))
#define DESKTOP_FOLDER_IS_DESKTOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW))
#define DESKTOP_FOLDER_IS_DESKTOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW))
#define DESKTOP_FOLDER_DESKTOP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindowClass))

typedef struct _DesktopFolderDesktopWindow DesktopFolderDesktopWindow;
typedef struct _DesktopFolderDesktopWindowClass DesktopFolderDesktopWindowClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT (desktop_folder_folder_arrangement_get_type ())
#define DESKTOP_FOLDER_FOLDER_ARRANGEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT, DesktopFolderFolderArrangement))
#define DESKTOP_FOLDER_IS_FOLDER_ARRANGEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT))
#define DESKTOP_FOLDER_FOLDER_ARRANGEMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT, DesktopFolderFolderArrangementIface))

typedef struct _DesktopFolderFolderArrangement DesktopFolderFolderArrangement;
typedef struct _DesktopFolderFolderArrangementIface DesktopFolderFolderArrangementIface;

#define DESKTOP_FOLDER_TYPE_ITEM_VIEW (desktop_folder_item_view_get_type ())
#define DESKTOP_FOLDER_ITEM_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemView))
#define DESKTOP_FOLDER_ITEM_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemViewClass))
#define DESKTOP_FOLDER_IS_ITEM_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW))
#define DESKTOP_FOLDER_IS_ITEM_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_ITEM_VIEW))
#define DESKTOP_FOLDER_ITEM_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemViewClass))

typedef struct _DesktopFolderItemView DesktopFolderItemView;
typedef struct _DesktopFolderItemViewClass DesktopFolderItemViewClass;

#define TYPE_DESKTOP_FOLDER_APP (desktop_folder_app_get_type ())
#define DESKTOP_FOLDER_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP_FOLDER_APP, DesktopFolderApp))
#define DESKTOP_FOLDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP_FOLDER_APP, DesktopFolderAppClass))
#define IS_DESKTOP_FOLDER_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP_FOLDER_APP))
#define IS_DESKTOP_FOLDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP_FOLDER_APP))
#define DESKTOP_FOLDER_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP_FOLDER_APP, DesktopFolderAppClass))

typedef struct _DesktopFolderApp DesktopFolderApp;
typedef struct _DesktopFolderAppClass DesktopFolderAppClass;
typedef struct _Block35Data Block35Data;
typedef struct _DesktopFolderDialogsPanelPropertiesSettingsHeaderPrivate DesktopFolderDialogsPanelPropertiesSettingsHeaderPrivate;
enum  {
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_HEADER_0_PROPERTY,
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_HEADER_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_dialogs_panel_properties_settings_header_properties[DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_HEADER_NUM_PROPERTIES];
typedef struct _DesktopFolderDialogsPanelPropertiesSettingsLabelPrivate DesktopFolderDialogsPanelPropertiesSettingsLabelPrivate;
enum  {
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_LABEL_0_PROPERTY,
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_LABEL_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_dialogs_panel_properties_settings_label_properties[DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_LABEL_NUM_PROPERTIES];
typedef struct _DesktopFolderDialogsPanelPropertiesSettingsSwitchPrivate DesktopFolderDialogsPanelPropertiesSettingsSwitchPrivate;
enum  {
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_SWITCH_0_PROPERTY,
	DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_SWITCH_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_dialogs_panel_properties_settings_switch_properties[DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_SETTINGS_SWITCH_NUM_PROPERTIES];

struct _DesktopFolderDialogsShowInfo {
	GtkWindow parent_instance;
	DesktopFolderDialogsShowInfoPrivate * priv;
};

struct _DesktopFolderDialogsShowInfoClass {
	GtkWindowClass parent_class;
};

struct _DesktopFolderDialogsShowInfoPrivate {
	gchar* filepath;
	GFile* file;
	GFileInfo* general_info;
};

struct _DesktopFolderDialogsOpenWith {
	GtkAppChooserDialog parent_instance;
	DesktopFolderDialogsOpenWithPrivate * priv;
};

struct _DesktopFolderDialogsOpenWithClass {
	GtkAppChooserDialogClass parent_class;
};

struct _DesktopFolderDialogsPanelProperties {
	GtkDialog parent_instance;
	DesktopFolderDialogsPanelPropertiesPrivate * priv;
};

struct _DesktopFolderDialogsPanelPropertiesClass {
	GtkDialogClass parent_class;
};

struct _DesktopFolderDialogsPanelPropertiesPrivate {
	GtkStack* main_stack;
	DesktopFolderFolderWindow* window;
	DesktopFolderFolderManager* manager;
	GtkWidget* properties_grid;
};

struct _Block34Data {
	int _ref_count_;
	DesktopFolderDialogsPanelProperties* self;
	GtkComboBoxText* arrangement_combo;
	GtkSpinButton* scale;
};

struct _DesktopFolderFolderArrangementIface {
	GTypeInterface parent_iface;
	gboolean (*have_margin) (DesktopFolderFolderArrangement* self);
	gboolean (*can_drag) (DesktopFolderFolderArrangement* self);
	gint (*get_sensitivity) (DesktopFolderFolderArrangement* self);
	gboolean (*can_organize) (DesktopFolderFolderArrangement* self);
	gboolean (*force_organization) (DesktopFolderFolderArrangement* self);
	void (*start_drag) (DesktopFolderFolderArrangement* self, DesktopFolderItemView* view);
	void (*motion_drag) (DesktopFolderFolderArrangement* self, gint x, gint y);
	void (*end_drag) (DesktopFolderFolderArrangement* self);
};

struct _Block35Data {
	int _ref_count_;
	DesktopFolderDialogsPanelProperties* self;
	GSettings* settings;
	GtkSpinButton* scale;
};

struct _DesktopFolderDialogsPanelPropertiesSettingsHeader {
	GtkLabel parent_instance;
	DesktopFolderDialogsPanelPropertiesSettingsHeaderPrivate * priv;
};

struct _DesktopFolderDialogsPanelPropertiesSettingsHeaderClass {
	GtkLabelClass parent_class;
};

struct _DesktopFolderDialogsPanelPropertiesSettingsLabel {
	GtkLabel parent_instance;
	DesktopFolderDialogsPanelPropertiesSettingsLabelPrivate * priv;
};

struct _DesktopFolderDialogsPanelPropertiesSettingsLabelClass {
	GtkLabelClass parent_class;
};

struct _DesktopFolderDialogsPanelPropertiesSettingsSwitch {
	GtkSwitch parent_instance;
	DesktopFolderDialogsPanelPropertiesSettingsSwitchPrivate * priv;
};

struct _DesktopFolderDialogsPanelPropertiesSettingsSwitchClass {
	GtkSwitchClass parent_class;
};

static gint DesktopFolderDialogsShowInfo_private_offset;
static gpointer desktop_folder_dialogs_show_info_parent_class = NULL;
static gpointer desktop_folder_dialogs_open_with_parent_class = NULL;
static gint DesktopFolderDialogsPanelProperties_private_offset;
static gpointer desktop_folder_dialogs_panel_properties_parent_class = NULL;
VALA_EXTERN gint desktop_folder_folder_arrangement_ARRANGEMENT_TYPE_FREE;
VALA_EXTERN gint desktop_folder_folder_arrangement_ARRANGEMENT_TYPE_GRID;
VALA_EXTERN gint desktop_folder_folder_arrangement_ARRANGEMENT_TYPE_MANAGED;
static gpointer desktop_folder_dialogs_panel_properties_settings_header_parent_class = NULL;
static gpointer desktop_folder_dialogs_panel_properties_settings_label_parent_class = NULL;
static gpointer desktop_folder_dialogs_panel_properties_settings_switch_parent_class = NULL;

VALA_EXTERN GType desktop_folder_dialogs_show_info_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDialogsShowInfo, g_object_unref)
VALA_EXTERN DesktopFolderDialogsShowInfo* desktop_folder_dialogs_show_info_new (const gchar* fpath,
                                                                    const gchar* fname);
VALA_EXTERN DesktopFolderDialogsShowInfo* desktop_folder_dialogs_show_info_construct (GType object_type,
                                                                          const gchar* fpath,
                                                                          const gchar* fname);
static GtkImage* desktop_folder_dialogs_show_info_get_fileicon (DesktopFolderDialogsShowInfo* self);
static gchar* desktop_folder_dialogs_show_info_get_filetype (DesktopFolderDialogsShowInfo* self);
static void _vala_array_add4 (GtkLabel** * array,
                       gint* length,
                       gint* size,
                       GtkLabel* value);
static void _vala_array_add5 (GtkLabel** * array,
                       gint* length,
                       gint* size,
                       GtkLabel* value);
static gint64* desktop_folder_dialogs_show_info_get_folderdata (DesktopFolderDialogsShowInfo* self,
                                                         gint* result_length1);
static void _vala_array_add6 (GtkLabel** * array,
                       gint* length,
                       gint* size,
                       GtkLabel* value);
static void _vala_array_add7 (GtkLabel** * array,
                       gint* length,
                       gint* size,
                       GtkLabel* value);
static void _vala_array_add8 (GtkLabel** * array,
                       gint* length,
                       gint* size,
                       GtkLabel* value);
VALA_EXTERN gchar* desktop_folder_dialogs_show_info_get_readablesize (DesktopFolderDialogsShowInfo* self,
                                                          gint64 bytes);
static void _vala_array_add9 (GtkLabel** * array,
                       gint* length,
                       gint* size,
                       GtkLabel* value);
static void _vala_array_add10 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
static void _vala_array_add11 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
static void desktop_folder_dialogs_show_info_toggle_executable (DesktopFolderDialogsShowInfo* self,
                                                         GtkToggleButton* button);
static void _desktop_folder_dialogs_show_info_toggle_executable_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                                    gpointer self);
static void _vala_array_add12 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
static void _vala_array_add13 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
static gchar** desktop_folder_dialogs_show_info_get_filetime (DesktopFolderDialogsShowInfo* self,
                                                       gint* result_length1);
static void _vala_array_add14 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
static void _vala_array_add15 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
static void _vala_array_add16 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
static void _vala_array_add17 (GtkLabel** * array,
                        gint* length,
                        gint* size,
                        GtkLabel* value);
VALA_EXTERN void desktop_folder_util_show_error_dialog (const gchar* title,
                                            const gchar* message);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
static void desktop_folder_dialogs_show_info_finalize (GObject * obj);
static GType desktop_folder_dialogs_show_info_get_type_once (void);
VALA_EXTERN GType desktop_folder_dialogs_open_with_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDialogsOpenWith, g_object_unref)
VALA_EXTERN DesktopFolderDialogsOpenWith* desktop_folder_dialogs_open_with_new (const gchar* content_type,
                                                                    const gchar* path);
VALA_EXTERN DesktopFolderDialogsOpenWith* desktop_folder_dialogs_open_with_construct (GType object_type,
                                                                          const gchar* content_type,
                                                                          const gchar* path);
static GType desktop_folder_dialogs_open_with_get_type_once (void);
VALA_EXTERN GType desktop_folder_dialogs_panel_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDialogsPanelProperties, g_object_unref)
VALA_EXTERN GType desktop_folder_folder_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderWindow, g_object_unref)
VALA_EXTERN GType desktop_folder_folder_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderManager, g_object_unref)
static GType desktop_folder_dialogs_panel_properties_resolution_strategy_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN DesktopFolderDialogsPanelProperties* desktop_folder_dialogs_panel_properties_new (DesktopFolderFolderWindow* window);
VALA_EXTERN DesktopFolderDialogsPanelProperties* desktop_folder_dialogs_panel_properties_construct (GType object_type,
                                                                                        DesktopFolderFolderWindow* window);
VALA_EXTERN DesktopFolderFolderManager* desktop_folder_folder_window_get_manager (DesktopFolderFolderWindow* self);
static void desktop_folder_dialogs_panel_properties_build (DesktopFolderDialogsPanelProperties* self);
static GtkWidget* desktop_folder_dialogs_panel_properties_get_properties_box (DesktopFolderDialogsPanelProperties* self);
static GtkWidget* desktop_folder_dialogs_panel_properties_get_general_box (DesktopFolderDialogsPanelProperties* self);
static void __lambda107_ (DesktopFolderDialogsPanelProperties* self);
static void ___lambda107__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static DesktopFolderDialogsPanelPropertiesSettingsHeader* desktop_folder_dialogs_panel_properties_settings_header_new (const gchar* text);
static DesktopFolderDialogsPanelPropertiesSettingsHeader* desktop_folder_dialogs_panel_properties_settings_header_construct (GType object_type,
                                                                                                                      const gchar* text);
static GType desktop_folder_dialogs_panel_properties_settings_header_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDialogsPanelPropertiesSettingsHeader, g_object_unref)
static DesktopFolderDialogsPanelPropertiesSettingsLabel* desktop_folder_dialogs_panel_properties_settings_label_new (const gchar* text);
static DesktopFolderDialogsPanelPropertiesSettingsLabel* desktop_folder_dialogs_panel_properties_settings_label_construct (GType object_type,
                                                                                                                    const gchar* text);
static GType desktop_folder_dialogs_panel_properties_settings_label_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDialogsPanelPropertiesSettingsLabel, g_object_unref)
VALA_EXTERN GType desktop_folder_position_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderPositionSettings, g_object_unref)
VALA_EXTERN GType desktop_folder_folder_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderSettings, g_object_unref)
VALA_EXTERN DesktopFolderFolderSettings* desktop_folder_folder_manager_get_settings (DesktopFolderFolderManager* self);
VALA_EXTERN gint desktop_folder_folder_settings_get_arrangement_type (DesktopFolderFolderSettings* self);
static void __lambda103_ (Block34Data* _data34_);
VALA_EXTERN void desktop_folder_folder_manager_on_arrange_change (DesktopFolderFolderManager* self,
                                                      gint type);
static void ___lambda103__gtk_combo_box_changed (GtkComboBox* _sender,
                                          gpointer self);
static GType desktop_folder_dialogs_panel_properties_settings_switch_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDialogsPanelPropertiesSettingsSwitch, g_object_unref)
static DesktopFolderDialogsPanelPropertiesSettingsSwitch* desktop_folder_dialogs_panel_properties_settings_switch_new (const gchar* setting);
static DesktopFolderDialogsPanelPropertiesSettingsSwitch* desktop_folder_dialogs_panel_properties_settings_switch_construct (GType object_type,
                                                                                                                      const gchar* setting);
VALA_EXTERN gboolean desktop_folder_folder_settings_get_lockitems (DesktopFolderFolderSettings* self);
VALA_EXTERN void desktop_folder_folder_window_on_toggle_lockitems (DesktopFolderFolderWindow* self);
static void _desktop_folder_folder_window_on_toggle_lockitems_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
VALA_EXTERN GType desktop_folder_desktop_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDesktopWindow, g_object_unref)
VALA_EXTERN gboolean desktop_folder_folder_settings_get_lockpanel (DesktopFolderFolderSettings* self);
VALA_EXTERN void desktop_folder_folder_window_on_toggle_lockpanel (DesktopFolderFolderWindow* self);
static void _desktop_folder_folder_window_on_toggle_lockpanel_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
VALA_EXTERN gboolean desktop_folder_folder_settings_get_textshadow (DesktopFolderFolderSettings* self);
VALA_EXTERN void desktop_folder_folder_window_on_toggle_shadow (DesktopFolderFolderWindow* self);
static void _desktop_folder_folder_window_on_toggle_shadow_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
VALA_EXTERN gboolean desktop_folder_folder_settings_get_textbold (DesktopFolderFolderSettings* self);
VALA_EXTERN void desktop_folder_folder_window_on_toggle_bold (DesktopFolderFolderWindow* self);
static void _desktop_folder_folder_window_on_toggle_bold_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
VALA_EXTERN gint desktop_folder_folder_settings_get_arrangement_padding (DesktopFolderFolderSettings* self);
static void __lambda104_ (Block34Data* _data34_);
VALA_EXTERN void desktop_folder_folder_settings_set_arrangement_padding (DesktopFolderFolderSettings* self,
                                                             gint value);
VALA_EXTERN GType desktop_folder_item_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderItemView, g_object_unref)
VALA_EXTERN GType desktop_folder_folder_arrangement_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderArrangement, g_object_unref)
VALA_EXTERN DesktopFolderFolderArrangement* desktop_folder_folder_manager_get_arrangement (DesktopFolderFolderManager* self);
VALA_EXTERN gboolean desktop_folder_folder_arrangement_force_organization (DesktopFolderFolderArrangement* self);
VALA_EXTERN void desktop_folder_folder_manager_organize_panel_items (DesktopFolderFolderManager* self);
static void ___lambda104__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                  gpointer self);
VALA_EXTERN GType desktop_folder_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderApp, g_object_unref)
VALA_EXTERN DesktopFolderApp* desktop_folder_folder_manager_get_application (DesktopFolderFolderManager* self);
VALA_EXTERN gboolean desktop_folder_app_get_desktoppanel_enabled (DesktopFolderApp* self);
VALA_EXTERN gboolean desktop_folder_app_get_desktopicons_enabled (DesktopFolderApp* self);
static void desktop_folder_dialogs_panel_properties_set_property_page_sensitivity (DesktopFolderDialogsPanelProperties* self,
                                                                            gboolean sensitivity);
static Block35Data* block35_data_ref (Block35Data* _data35_);
static void block35_data_unref (void * _userdata_);
static void __lambda105_ (Block35Data* _data35_);
static void ___lambda105__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda106_ (Block35Data* _data35_);
static void ___lambda106__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                  gpointer self);
static GType desktop_folder_dialogs_panel_properties_settings_header_get_type_once (void);
static GType desktop_folder_dialogs_panel_properties_settings_label_get_type_once (void);
static GType desktop_folder_dialogs_panel_properties_settings_switch_get_type_once (void);
static void desktop_folder_dialogs_panel_properties_finalize (GObject * obj);
static GType desktop_folder_dialogs_panel_properties_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
desktop_folder_dialogs_show_info_get_instance_private (DesktopFolderDialogsShowInfo* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopFolderDialogsShowInfo_private_offset);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_array_add4 (GtkLabel** * array,
                  gint* length,
                  gint* size,
                  GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (GtkLabel** * array,
                  gint* length,
                  gint* size,
                  GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add6 (GtkLabel** * array,
                  gint* length,
                  gint* size,
                  GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add7 (GtkLabel** * array,
                  gint* length,
                  gint* size,
                  GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add8 (GtkLabel** * array,
                  gint* length,
                  gint* size,
                  GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add9 (GtkLabel** * array,
                  gint* length,
                  gint* size,
                  GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add10 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add11 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_desktop_folder_dialogs_show_info_toggle_executable_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                               gpointer self)
{
	desktop_folder_dialogs_show_info_toggle_executable ((DesktopFolderDialogsShowInfo*) self, _sender);
}

static void
_vala_array_add12 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add13 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add14 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add15 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add16 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add17 (GtkLabel** * array,
                   gint* length,
                   gint* size,
                   GtkLabel* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GtkLabel*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

DesktopFolderDialogsShowInfo*
desktop_folder_dialogs_show_info_construct (GType object_type,
                                            const gchar* fpath,
                                            const gchar* fname)
{
	DesktopFolderDialogsShowInfo * self = NULL;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (fpath != NULL, NULL);
	g_return_val_if_fail (fname != NULL, NULL);
	self = (DesktopFolderDialogsShowInfo*) g_object_new (object_type, NULL);
	{
		gchar* _tmp0_;
		const gchar* _tmp1_;
		GFile* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		gboolean is_a_link = FALSE;
		const gchar* _tmp7_;
		gboolean is_a_folder = FALSE;
		const gchar* _tmp8_;
		GtkImage* fileicon = NULL;
		GtkImage* _tmp9_;
		GtkGrid* maingrid = NULL;
		GtkGrid* _tmp10_;
		GtkGrid* _tmp11_;
		GtkImage* _tmp12_;
		GtkGrid* _tmp13_;
		GtkGrid* _tmp14_;
		GtkGrid* _tmp15_;
		GtkLabel* _tmp16_;
		GtkLabel* _tmp17_;
		GtkGrid* _tmp18_;
		GtkLabel* _tmp19_;
		GtkLabel* _tmp20_;
		GtkLabel* name_label = NULL;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkLabel* _tmp23_;
		GtkLabel* _tmp24_;
		GtkLabel* name_value = NULL;
		GtkLabel* _tmp25_;
		gchar* location = NULL;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		GtkLabel* location_label = NULL;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GtkLabel* _tmp33_;
		GtkLabel* _tmp34_;
		GtkLabel* location_value = NULL;
		const gchar* _tmp35_;
		GtkLabel* _tmp36_;
		GtkLabel* content_label = NULL;
		gchar* _tmp37_;
		gchar* _tmp38_;
		GtkLabel* _tmp39_;
		GtkLabel* _tmp40_;
		GtkLabel* content_value = NULL;
		GtkLabel* _tmp41_;
		GtkLabel** labels = NULL;
		GtkLabel* _tmp42_;
		GtkLabel* _tmp43_;
		GtkLabel* _tmp44_;
		GtkLabel* _tmp45_;
		GtkLabel* _tmp46_;
		GtkLabel* _tmp47_;
		GtkLabel** _tmp48_;
		gint labels_length1;
		gint _labels_size_;
		GtkLabel** values = NULL;
		GtkLabel* _tmp49_;
		GtkLabel* _tmp50_;
		GtkLabel* _tmp51_;
		GtkLabel* _tmp52_;
		GtkLabel* _tmp53_;
		GtkLabel* _tmp54_;
		GtkLabel** _tmp55_;
		gint values_length1;
		gint _values_size_;
		gchar* content = NULL;
		gchar* _tmp56_;
		GtkLabel* _tmp133_;
		const gchar* _tmp134_;
		GtkLabel* _tmp135_;
		GtkLabel* _tmp136_;
		gchar** timedata = NULL;
		gint _tmp137_ = 0;
		gchar** _tmp138_;
		gint timedata_length1;
		gint _timedata_size_;
		GtkLabel* last_modified_label = NULL;
		gchar* _tmp150_;
		gchar* _tmp151_;
		GtkLabel* _tmp152_;
		GtkLabel* _tmp153_;
		GtkLabel* _tmp154_;
		GtkLabel* _tmp155_;
		GtkLabel* last_modified_value = NULL;
		gchar** _tmp156_;
		gint _tmp156__length1;
		const gchar* _tmp157_;
		GtkLabel* _tmp158_;
		GtkLabel* _tmp159_;
		GtkLabel* _tmp160_;
		gint labelpos = 0;
		GtkLabel** _tmp161_;
		gint _tmp161__length1;
		gint valuepos = 0;
		GtkLabel** _tmp166_;
		gint _tmp166__length1;
		GtkGrid* _tmp173_;
		GtkGrid* _tmp174_;
		_tmp0_ = g_strdup (fpath);
		_g_free0 (self->priv->filepath);
		self->priv->filepath = _tmp0_;
		_tmp1_ = self->priv->filepath;
		_tmp2_ = g_file_new_for_commandline_arg (_tmp1_);
		_g_object_unref0 (self->priv->file);
		self->priv->file = _tmp2_;
		_tmp4_ = self->priv->file;
		_tmp5_ = g_file_query_info (_tmp4_, "*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp6_ = _tmp3_;
		_tmp3_ = NULL;
		_g_object_unref0 (self->priv->general_info);
		self->priv->general_info = _tmp6_;
		_tmp7_ = self->priv->filepath;
		is_a_link = g_file_test (_tmp7_, G_FILE_TEST_IS_SYMLINK);
		_tmp8_ = self->priv->filepath;
		is_a_folder = g_file_test (_tmp8_, G_FILE_TEST_IS_DIR);
		gtk_window_set_title ((GtkWindow*) self, DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILEINFO);
		gtk_window_set_modal ((GtkWindow*) self, TRUE);
		gtk_window_set_default_size ((GtkWindow*) self, 400, 200);
		_tmp9_ = desktop_folder_dialogs_show_info_get_fileicon (self);
		fileicon = _tmp9_;
		_tmp10_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp10_);
		maingrid = _tmp10_;
		_tmp11_ = maingrid;
		_tmp12_ = fileicon;
		gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 1, 1, 1, 2);
		_tmp13_ = maingrid;
		gtk_grid_set_column_spacing (_tmp13_, (guint) 20);
		_tmp14_ = maingrid;
		gtk_grid_set_row_spacing (_tmp14_, (guint) 10);
		_tmp15_ = maingrid;
		_tmp16_ = (GtkLabel*) gtk_label_new ("");
		g_object_ref_sink (_tmp16_);
		_tmp17_ = _tmp16_;
		gtk_grid_attach (_tmp15_, (GtkWidget*) _tmp17_, 0, 0, 1, 1);
		_g_object_unref0 (_tmp17_);
		_tmp18_ = maingrid;
		_tmp19_ = (GtkLabel*) gtk_label_new ("");
		g_object_ref_sink (_tmp19_);
		_tmp20_ = _tmp19_;
		gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp20_, 100, 100, 1, 1);
		_g_object_unref0 (_tmp20_);
		_tmp21_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILENAME, ":", NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = (GtkLabel*) gtk_label_new (_tmp22_);
		g_object_ref_sink (_tmp23_);
		_tmp24_ = _tmp23_;
		_g_free0 (_tmp22_);
		name_label = _tmp24_;
		_tmp25_ = (GtkLabel*) gtk_label_new (fname);
		g_object_ref_sink (_tmp25_);
		name_value = _tmp25_;
		_tmp26_ = self->priv->filepath;
		_tmp27_ = g_strconcat ("/", fname, NULL);
		_tmp28_ = _tmp27_;
		_tmp29_ = string_replace (_tmp26_, _tmp28_, "");
		_tmp30_ = _tmp29_;
		_g_free0 (_tmp28_);
		location = _tmp30_;
		_tmp31_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_LOCATION, ":", NULL);
		_tmp32_ = _tmp31_;
		_tmp33_ = (GtkLabel*) gtk_label_new (_tmp32_);
		g_object_ref_sink (_tmp33_);
		_tmp34_ = _tmp33_;
		_g_free0 (_tmp32_);
		location_label = _tmp34_;
		_tmp35_ = location;
		_tmp36_ = (GtkLabel*) gtk_label_new (_tmp35_);
		g_object_ref_sink (_tmp36_);
		location_value = _tmp36_;
		_tmp37_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_CONTENTTYPE, ":", NULL);
		_tmp38_ = _tmp37_;
		_tmp39_ = (GtkLabel*) gtk_label_new (_tmp38_);
		g_object_ref_sink (_tmp39_);
		_tmp40_ = _tmp39_;
		_g_free0 (_tmp38_);
		content_label = _tmp40_;
		_tmp41_ = (GtkLabel*) gtk_label_new ("");
		g_object_ref_sink (_tmp41_);
		content_value = _tmp41_;
		_tmp42_ = name_label;
		_tmp43_ = _g_object_ref0 (_tmp42_);
		_tmp44_ = location_label;
		_tmp45_ = _g_object_ref0 (_tmp44_);
		_tmp46_ = content_label;
		_tmp47_ = _g_object_ref0 (_tmp46_);
		_tmp48_ = g_new0 (GtkLabel*, 3 + 1);
		_tmp48_[0] = _tmp43_;
		_tmp48_[1] = _tmp45_;
		_tmp48_[2] = _tmp47_;
		labels = _tmp48_;
		labels_length1 = 3;
		_labels_size_ = labels_length1;
		_tmp49_ = name_value;
		_tmp50_ = _g_object_ref0 (_tmp49_);
		_tmp51_ = location_value;
		_tmp52_ = _g_object_ref0 (_tmp51_);
		_tmp53_ = content_value;
		_tmp54_ = _g_object_ref0 (_tmp53_);
		_tmp55_ = g_new0 (GtkLabel*, 3 + 1);
		_tmp55_[0] = _tmp50_;
		_tmp55_[1] = _tmp52_;
		_tmp55_[2] = _tmp54_;
		values = _tmp55_;
		values_length1 = 3;
		_values_size_ = values_length1;
		_tmp56_ = desktop_folder_dialogs_show_info_get_filetype (self);
		content = _tmp56_;
		if (is_a_link) {
			gchar* _tmp57_;
			GtkLabel* target_label = NULL;
			gchar* _tmp58_;
			gchar* _tmp59_;
			GtkLabel* _tmp60_;
			GtkLabel* _tmp61_;
			GtkLabel* _tmp62_;
			GtkLabel* _tmp63_;
			gchar* target = NULL;
			GFileInfo* _tmp64_;
			const gchar* _tmp65_;
			gchar* _tmp66_;
			GtkLabel* target_value = NULL;
			const gchar* _tmp67_;
			GtkLabel* _tmp68_;
			GtkLabel* _tmp69_;
			GtkLabel* _tmp70_;
			_tmp57_ = g_strdup ("inode/symlink");
			_g_free0 (content);
			content = _tmp57_;
			_tmp58_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_TARGET, ":", NULL);
			_tmp59_ = _tmp58_;
			_tmp60_ = (GtkLabel*) gtk_label_new (_tmp59_);
			g_object_ref_sink (_tmp60_);
			_tmp61_ = _tmp60_;
			_g_free0 (_tmp59_);
			target_label = _tmp61_;
			_tmp62_ = target_label;
			_tmp63_ = _g_object_ref0 (_tmp62_);
			_vala_array_add4 (&labels, &labels_length1, &_labels_size_, _tmp63_);
			_tmp64_ = self->priv->general_info;
			_tmp65_ = g_file_info_get_symlink_target (_tmp64_);
			_tmp66_ = g_strdup (_tmp65_);
			target = _tmp66_;
			_tmp67_ = target;
			_tmp68_ = (GtkLabel*) gtk_label_new (_tmp67_);
			g_object_ref_sink (_tmp68_);
			target_value = _tmp68_;
			_tmp69_ = target_value;
			_tmp70_ = _g_object_ref0 (_tmp69_);
			_vala_array_add5 (&values, &values_length1, &_values_size_, _tmp70_);
			_g_object_unref0 (target_value);
			_g_free0 (target);
			_g_object_unref0 (target_label);
		} else {
			if (is_a_folder) {
				gint64* folderdata = NULL;
				gint _tmp71_ = 0;
				gint64* _tmp72_;
				gint folderdata_length1;
				gint _folderdata_size_;
				GtkLabel* n_items_label = NULL;
				gchar* _tmp73_;
				gchar* _tmp74_;
				GtkLabel* _tmp75_;
				GtkLabel* _tmp76_;
				GtkLabel* _tmp77_;
				GtkLabel* _tmp78_;
				GtkLabel* total_size_label = NULL;
				gchar* _tmp79_;
				gchar* _tmp80_;
				GtkLabel* _tmp81_;
				GtkLabel* _tmp82_;
				GtkLabel* _tmp83_;
				GtkLabel* _tmp84_;
				gchar* n_items = NULL;
				gint64* _tmp85_;
				gint _tmp85__length1;
				gint64 _tmp86_;
				gchar* _tmp87_;
				gchar* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				GtkLabel* n_items_value = NULL;
				const gchar* _tmp91_;
				GtkLabel* _tmp92_;
				GtkLabel* _tmp93_;
				GtkLabel* _tmp94_;
				gchar* totalsize = NULL;
				gint64* _tmp95_;
				gint _tmp95__length1;
				gint64 _tmp96_;
				gchar* _tmp97_;
				GtkLabel* total_size_value = NULL;
				const gchar* _tmp98_;
				GtkLabel* _tmp99_;
				GtkLabel* _tmp100_;
				GtkLabel* _tmp101_;
				gint64* _tmp102_;
				gint _tmp102__length1;
				gint64 _tmp103_;
				_tmp72_ = desktop_folder_dialogs_show_info_get_folderdata (self, &_tmp71_);
				folderdata = _tmp72_;
				folderdata_length1 = _tmp71_;
				_folderdata_size_ = folderdata_length1;
				_tmp73_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_CONTENT, ":", NULL);
				_tmp74_ = _tmp73_;
				_tmp75_ = (GtkLabel*) gtk_label_new (_tmp74_);
				g_object_ref_sink (_tmp75_);
				_tmp76_ = _tmp75_;
				_g_free0 (_tmp74_);
				n_items_label = _tmp76_;
				_tmp77_ = n_items_label;
				_tmp78_ = _g_object_ref0 (_tmp77_);
				_vala_array_add6 (&labels, &labels_length1, &_labels_size_, _tmp78_);
				_tmp79_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_TOTALSIZE, ":", NULL);
				_tmp80_ = _tmp79_;
				_tmp81_ = (GtkLabel*) gtk_label_new (_tmp80_);
				g_object_ref_sink (_tmp81_);
				_tmp82_ = _tmp81_;
				_g_free0 (_tmp80_);
				total_size_label = _tmp82_;
				_tmp83_ = total_size_label;
				_tmp84_ = _g_object_ref0 (_tmp83_);
				_vala_array_add7 (&labels, &labels_length1, &_labels_size_, _tmp84_);
				_tmp85_ = folderdata;
				_tmp85__length1 = folderdata_length1;
				_tmp86_ = _tmp85_[0];
				_tmp87_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp86_);
				_tmp88_ = _tmp87_;
				_tmp89_ = g_strconcat (_tmp88_, " ", DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_N_ITEMS, NULL);
				_tmp90_ = _tmp89_;
				_g_free0 (_tmp88_);
				n_items = _tmp90_;
				_tmp91_ = n_items;
				_tmp92_ = (GtkLabel*) gtk_label_new (_tmp91_);
				g_object_ref_sink (_tmp92_);
				n_items_value = _tmp92_;
				_tmp93_ = n_items_value;
				_tmp94_ = _g_object_ref0 (_tmp93_);
				_vala_array_add8 (&values, &values_length1, &_values_size_, _tmp94_);
				_tmp95_ = folderdata;
				_tmp95__length1 = folderdata_length1;
				_tmp96_ = _tmp95_[1];
				_tmp97_ = desktop_folder_dialogs_show_info_get_readablesize (self, _tmp96_);
				totalsize = _tmp97_;
				_tmp98_ = totalsize;
				_tmp99_ = (GtkLabel*) gtk_label_new (_tmp98_);
				g_object_ref_sink (_tmp99_);
				total_size_value = _tmp99_;
				_tmp100_ = total_size_value;
				_tmp101_ = _g_object_ref0 (_tmp100_);
				_vala_array_add9 (&values, &values_length1, &_values_size_, _tmp101_);
				_tmp102_ = folderdata;
				_tmp102__length1 = folderdata_length1;
				_tmp103_ = _tmp102_[0];
				if (_tmp103_ == ((gint64) -1)) {
					GtkLabel* _tmp104_;
					GtkLabel* _tmp105_;
					_tmp104_ = n_items_value;
					gtk_label_set_text (_tmp104_, "?");
					_tmp105_ = total_size_value;
					gtk_label_set_text (_tmp105_, "?");
				}
				_g_object_unref0 (total_size_value);
				_g_free0 (totalsize);
				_g_object_unref0 (n_items_value);
				_g_free0 (n_items);
				_g_object_unref0 (total_size_label);
				_g_object_unref0 (n_items_label);
				folderdata = (g_free (folderdata), NULL);
			} else {
				GtkLabel* filesize_label = NULL;
				gchar* _tmp106_;
				gchar* _tmp107_;
				GtkLabel* _tmp108_;
				GtkLabel* _tmp109_;
				GtkLabel* _tmp110_;
				GtkLabel* _tmp111_;
				gchar* filesize = NULL;
				GFileInfo* _tmp112_;
				gchar* _tmp113_;
				GtkLabel* filesize_value = NULL;
				const gchar* _tmp114_;
				GtkLabel* _tmp115_;
				GtkLabel* _tmp116_;
				GtkLabel* _tmp117_;
				GtkGrid* _tmp118_;
				GtkLabel* _tmp119_;
				GtkLabel* _tmp120_;
				GtkLabel* executable_label = NULL;
				gchar* _tmp121_;
				gchar* _tmp122_;
				GtkLabel* _tmp123_;
				GtkLabel* _tmp124_;
				GtkGrid* _tmp125_;
				GtkLabel* _tmp126_;
				GtkCheckButton* executable_value = NULL;
				GtkCheckButton* _tmp127_;
				gboolean isexec = FALSE;
				const gchar* _tmp128_;
				GtkCheckButton* _tmp129_;
				GtkGrid* _tmp130_;
				GtkCheckButton* _tmp131_;
				GtkCheckButton* _tmp132_;
				_tmp106_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_FILESIZE, ":", NULL);
				_tmp107_ = _tmp106_;
				_tmp108_ = (GtkLabel*) gtk_label_new (_tmp107_);
				g_object_ref_sink (_tmp108_);
				_tmp109_ = _tmp108_;
				_g_free0 (_tmp107_);
				filesize_label = _tmp109_;
				_tmp110_ = filesize_label;
				_tmp111_ = _g_object_ref0 (_tmp110_);
				_vala_array_add10 (&labels, &labels_length1, &_labels_size_, _tmp111_);
				_tmp112_ = self->priv->general_info;
				_tmp113_ = desktop_folder_dialogs_show_info_get_readablesize (self, g_file_info_get_size (_tmp112_));
				filesize = _tmp113_;
				_tmp114_ = filesize;
				_tmp115_ = (GtkLabel*) gtk_label_new (_tmp114_);
				g_object_ref_sink (_tmp115_);
				filesize_value = _tmp115_;
				_tmp116_ = filesize_value;
				_tmp117_ = _g_object_ref0 (_tmp116_);
				_vala_array_add11 (&values, &values_length1, &_values_size_, _tmp117_);
				_tmp118_ = maingrid;
				_tmp119_ = (GtkLabel*) gtk_label_new ("");
				g_object_ref_sink (_tmp119_);
				_tmp120_ = _tmp119_;
				gtk_grid_attach (_tmp118_, (GtkWidget*) _tmp120_, 1, 10, 1, 1);
				_g_object_unref0 (_tmp120_);
				_tmp121_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_MENU_EXECUTE, ":", NULL);
				_tmp122_ = _tmp121_;
				_tmp123_ = (GtkLabel*) gtk_label_new (_tmp122_);
				g_object_ref_sink (_tmp123_);
				_tmp124_ = _tmp123_;
				_g_free0 (_tmp122_);
				executable_label = _tmp124_;
				_tmp125_ = maingrid;
				_tmp126_ = executable_label;
				gtk_grid_attach (_tmp125_, (GtkWidget*) _tmp126_, 2, 11, 1, 1);
				_tmp127_ = (GtkCheckButton*) gtk_check_button_new_with_label (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_ALLOWEXECUTE);
				g_object_ref_sink (_tmp127_);
				executable_value = _tmp127_;
				_tmp128_ = self->priv->filepath;
				isexec = g_file_test (_tmp128_, G_FILE_TEST_IS_EXECUTABLE);
				_tmp129_ = executable_value;
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp129_, isexec);
				_tmp130_ = maingrid;
				_tmp131_ = executable_value;
				gtk_grid_attach (_tmp130_, (GtkWidget*) _tmp131_, 3, 11, 1, 1);
				_tmp132_ = executable_value;
				g_signal_connect_object ((GtkToggleButton*) _tmp132_, "toggled", (GCallback) _desktop_folder_dialogs_show_info_toggle_executable_gtk_toggle_button_toggled, self, 0);
				_g_object_unref0 (executable_value);
				_g_object_unref0 (executable_label);
				_g_object_unref0 (filesize_value);
				_g_free0 (filesize);
				_g_object_unref0 (filesize_label);
			}
		}
		_tmp133_ = content_value;
		_tmp134_ = content;
		gtk_label_set_text (_tmp133_, _tmp134_);
		_tmp135_ = (GtkLabel*) gtk_label_new ("");
		g_object_ref_sink (_tmp135_);
		_vala_array_add12 (&labels, &labels_length1, &_labels_size_, _tmp135_);
		_tmp136_ = (GtkLabel*) gtk_label_new ("");
		g_object_ref_sink (_tmp136_);
		_vala_array_add13 (&values, &values_length1, &_values_size_, _tmp136_);
		_tmp138_ = desktop_folder_dialogs_show_info_get_filetime (self, &_tmp137_);
		timedata = _tmp138_;
		timedata_length1 = _tmp137_;
		_timedata_size_ = timedata_length1;
		if (!is_a_folder) {
			GtkLabel* last_accessed_label = NULL;
			gchar* _tmp139_;
			gchar* _tmp140_;
			GtkLabel* _tmp141_;
			GtkLabel* _tmp142_;
			GtkLabel* _tmp143_;
			GtkLabel* _tmp144_;
			GtkLabel* last_accessed_value = NULL;
			gchar** _tmp145_;
			gint _tmp145__length1;
			const gchar* _tmp146_;
			GtkLabel* _tmp147_;
			GtkLabel* _tmp148_;
			GtkLabel* _tmp149_;
			_tmp139_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_LASTUSED, ":", NULL);
			_tmp140_ = _tmp139_;
			_tmp141_ = (GtkLabel*) gtk_label_new (_tmp140_);
			g_object_ref_sink (_tmp141_);
			_tmp142_ = _tmp141_;
			_g_free0 (_tmp140_);
			last_accessed_label = _tmp142_;
			_tmp143_ = last_accessed_label;
			_tmp144_ = _g_object_ref0 (_tmp143_);
			_vala_array_add14 (&labels, &labels_length1, &_labels_size_, _tmp144_);
			_tmp145_ = timedata;
			_tmp145__length1 = timedata_length1;
			_tmp146_ = _tmp145_[0];
			_tmp147_ = (GtkLabel*) gtk_label_new (_tmp146_);
			g_object_ref_sink (_tmp147_);
			last_accessed_value = _tmp147_;
			_tmp148_ = last_accessed_value;
			_tmp149_ = _g_object_ref0 (_tmp148_);
			_vala_array_add15 (&values, &values_length1, &_values_size_, _tmp149_);
			_g_object_unref0 (last_accessed_value);
			_g_object_unref0 (last_accessed_label);
		}
		_tmp150_ = g_strconcat (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_LASTMODIFIED, ":", NULL);
		_tmp151_ = _tmp150_;
		_tmp152_ = (GtkLabel*) gtk_label_new (_tmp151_);
		g_object_ref_sink (_tmp152_);
		_tmp153_ = _tmp152_;
		_g_free0 (_tmp151_);
		last_modified_label = _tmp153_;
		_tmp154_ = last_modified_label;
		_tmp155_ = _g_object_ref0 (_tmp154_);
		_vala_array_add16 (&labels, &labels_length1, &_labels_size_, _tmp155_);
		_tmp156_ = timedata;
		_tmp156__length1 = timedata_length1;
		_tmp157_ = _tmp156_[1];
		_tmp158_ = (GtkLabel*) gtk_label_new (_tmp157_);
		g_object_ref_sink (_tmp158_);
		last_modified_value = _tmp158_;
		_tmp159_ = last_modified_value;
		_tmp160_ = _g_object_ref0 (_tmp159_);
		_vala_array_add17 (&values, &values_length1, &_values_size_, _tmp160_);
		labelpos = 1;
		_tmp161_ = labels;
		_tmp161__length1 = labels_length1;
		{
			GtkLabel** l_collection = NULL;
			gint l_collection_length1 = 0;
			gint _l_collection_size_ = 0;
			gint l_it = 0;
			l_collection = _tmp161_;
			l_collection_length1 = _tmp161__length1;
			for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
				GtkLabel* _tmp162_;
				GtkLabel* l = NULL;
				_tmp162_ = _g_object_ref0 (l_collection[l_it]);
				l = _tmp162_;
				{
					GtkLabel* _tmp163_;
					GtkGrid* _tmp164_;
					GtkLabel* _tmp165_;
					_tmp163_ = l;
					gtk_label_set_xalign (_tmp163_, (gfloat) 0);
					_tmp164_ = maingrid;
					_tmp165_ = l;
					gtk_grid_attach (_tmp164_, (GtkWidget*) _tmp165_, 2, labelpos, 1, 1);
					labelpos += 1;
					_g_object_unref0 (l);
				}
			}
		}
		valuepos = 1;
		_tmp166_ = values;
		_tmp166__length1 = values_length1;
		{
			GtkLabel** l_collection = NULL;
			gint l_collection_length1 = 0;
			gint _l_collection_size_ = 0;
			gint l_it = 0;
			l_collection = _tmp166_;
			l_collection_length1 = _tmp166__length1;
			for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
				GtkLabel* _tmp167_;
				GtkLabel* l = NULL;
				_tmp167_ = _g_object_ref0 (l_collection[l_it]);
				l = _tmp167_;
				{
					GtkLabel* _tmp168_;
					GtkLabel* _tmp169_;
					GtkLabel* _tmp170_;
					GtkGrid* _tmp171_;
					GtkLabel* _tmp172_;
					_tmp168_ = l;
					gtk_label_set_xalign (_tmp168_, (gfloat) 0);
					_tmp169_ = l;
					gtk_label_set_ellipsize (_tmp169_, PANGO_ELLIPSIZE_END);
					_tmp170_ = l;
					gtk_label_set_selectable (_tmp170_, TRUE);
					_tmp171_ = maingrid;
					_tmp172_ = l;
					gtk_grid_attach (_tmp171_, (GtkWidget*) _tmp172_, 3, valuepos, 1, 1);
					valuepos += 1;
					_g_object_unref0 (l);
				}
			}
		}
		_tmp173_ = maingrid;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp173_);
		_tmp174_ = maingrid;
		gtk_widget_show_all ((GtkWidget*) _tmp174_);
		_g_object_unref0 (last_modified_value);
		_g_object_unref0 (last_modified_label);
		timedata = (_vala_array_free (timedata, timedata_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (content);
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_object_unref), NULL);
		labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_object_unref), NULL);
		_g_object_unref0 (content_value);
		_g_object_unref0 (content_label);
		_g_object_unref0 (location_value);
		_g_object_unref0 (location_label);
		_g_free0 (location);
		_g_object_unref0 (name_value);
		_g_object_unref0 (name_label);
		_g_object_unref0 (maingrid);
		_g_object_unref0 (fileicon);
		_g_object_unref0 (_tmp3_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp175_;
		GError* _tmp176_;
		const gchar* _tmp177_;
		GError* _tmp178_;
		const gchar* _tmp179_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp175_ = stderr;
		_tmp176_ = e;
		_tmp177_ = _tmp176_->message;
		fprintf (_tmp175_, "Error: %s\n", _tmp177_);
		_tmp178_ = e;
		_tmp179_ = _tmp178_->message;
		desktop_folder_util_show_error_dialog ("Error", _tmp179_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	gtk_widget_show_all ((GtkWidget*) self);
	return self;
}

DesktopFolderDialogsShowInfo*
desktop_folder_dialogs_show_info_new (const gchar* fpath,
                                      const gchar* fname)
{
	return desktop_folder_dialogs_show_info_construct (DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO, fpath, fname);
}

gchar*
desktop_folder_dialogs_show_info_get_readablesize (DesktopFolderDialogsShowInfo* self,
                                                   gint64 bytes)
{
	gchar* unit = NULL;
	gdouble size = 0.0;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (bytes >= 1000000000000LL) {
		gchar* _tmp0_;
		size = bytes / 1000000000000.0;
		_tmp0_ = g_strdup ("TB");
		_g_free0 (unit);
		unit = _tmp0_;
	} else {
		if (bytes >= ((gint64) 1000000000)) {
			gchar* _tmp1_;
			size = bytes / 1000000000.0;
			_tmp1_ = g_strdup ("GB");
			_g_free0 (unit);
			unit = _tmp1_;
		} else {
			if (bytes >= ((gint64) 1000000)) {
				gchar* _tmp2_;
				size = bytes / 1000000.0;
				_tmp2_ = g_strdup ("MB");
				_g_free0 (unit);
				unit = _tmp2_;
			} else {
				if (bytes >= ((gint64) 1000)) {
					gchar* _tmp3_;
					size = bytes / 1000.0;
					_tmp3_ = g_strdup ("kB");
					_g_free0 (unit);
					unit = _tmp3_;
				} else {
					gchar* _tmp4_;
					size = (gdouble) bytes;
					_tmp4_ = g_strdup ("byte");
					_g_free0 (unit);
					unit = _tmp4_;
				}
			}
		}
	}
	_tmp5_ = g_strdup_printf ("%.1f", size);
	_tmp6_ = _tmp5_;
	_tmp7_ = string_replace (_tmp6_, ".0", "");
	_tmp8_ = _tmp7_;
	_tmp9_ = string_replace (_tmp8_, ",0", "");
	_tmp10_ = _tmp9_;
	_tmp11_ = unit;
	_tmp12_ = g_strconcat (_tmp10_, " ", _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	result = _tmp13_;
	_g_free0 (unit);
	return result;
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static gint64*
desktop_folder_dialogs_show_info_get_folderdata (DesktopFolderDialogsShowInfo* self,
                                                 gint* result_length1)
{
	gchar* cmd = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* output = NULL;
	GError* _inner_error0_ = NULL;
	gint64* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->filepath;
	_tmp1_ = g_strconcat ("find \"", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "\"", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	cmd = _tmp4_;
	{
		gchar* _tmp5_ = NULL;
		gchar** all_lines = NULL;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint all_lines_length1;
		gint _all_lines_size_;
		gchar** real_files = NULL;
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar** _tmp9_;
		gint _tmp9__length1;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gint real_files_length1;
		gint _real_files_size_;
		gint64 totalsize = 0LL;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gint lines = 0;
		gchar** _tmp18_;
		gint _tmp18__length1;
		gint64* _tmp19_;
		gint64* _tmp20_;
		gint _tmp20__length1;
		g_spawn_command_line_sync (cmd, &_tmp5_, NULL, NULL, &_inner_error0_);
		_g_free0 (output);
		output = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch0_g_spawn_error;
			}
			_g_free0 (output);
			_g_free0 (cmd);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp7_ = _tmp6_ = g_strsplit (output, "\n", 0);
		all_lines = _tmp7_;
		all_lines_length1 = _vala_array_length (_tmp6_);
		_all_lines_size_ = all_lines_length1;
		_tmp8_ = all_lines;
		_tmp8__length1 = all_lines_length1;
		_tmp9_ = all_lines;
		_tmp9__length1 = all_lines_length1;
		_tmp10_ = (_tmp8_ != NULL) ? _vala_array_dup5 (_tmp8_ + 1, (_tmp9__length1 - 1) - 1) : _tmp8_;
		_tmp10__length1 = (_tmp9__length1 - 1) - 1;
		real_files = _tmp10_;
		real_files_length1 = _tmp10__length1;
		_real_files_size_ = real_files_length1;
		totalsize = (gint64) 0;
		_tmp11_ = real_files;
		_tmp11__length1 = real_files_length1;
		{
			gchar** l_collection = NULL;
			gint l_collection_length1 = 0;
			gint _l_collection_size_ = 0;
			gint l_it = 0;
			l_collection = _tmp11_;
			l_collection_length1 = _tmp11__length1;
			for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
				gchar* _tmp12_;
				gchar* l = NULL;
				_tmp12_ = g_strdup (l_collection[l_it]);
				l = _tmp12_;
				{
					GFile* file = NULL;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					_tmp13_ = l;
					_tmp14_ = g_file_new_for_path (_tmp13_);
					file = _tmp14_;
					{
						GFileInfo* _tmp15_ = NULL;
						GFile* _tmp16_;
						GFileInfo* _tmp17_;
						gint64 size = 0LL;
						_tmp16_ = file;
						_tmp17_ = g_file_query_info (_tmp16_, "*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
						_tmp15_ = _tmp17_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch1_g_error;
						}
						size = g_file_info_get_size (_tmp15_);
						totalsize += size;
						_g_object_unref0 (_tmp15_);
					}
					goto __finally1;
					__catch1_g_error:
					{
						g_clear_error (&_inner_error0_);
						totalsize += (gint64) 0;
					}
					__finally1:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (file);
						_g_free0 (l);
						real_files = (_vala_array_free (real_files, real_files_length1, (GDestroyNotify) g_free), NULL);
						all_lines = (_vala_array_free (all_lines, all_lines_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error0_->domain == G_SPAWN_ERROR) {
							goto __catch0_g_spawn_error;
						}
						_g_free0 (output);
						_g_free0 (cmd);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
					_g_object_unref0 (file);
					_g_free0 (l);
				}
			}
		}
		_tmp18_ = real_files;
		_tmp18__length1 = real_files_length1;
		lines = _tmp18__length1;
		_tmp19_ = g_new0 (gint64, 2);
		_tmp19_[0] = (gint64) lines;
		_tmp19_[1] = totalsize;
		_tmp20_ = _tmp19_;
		_tmp20__length1 = 2;
		if (result_length1) {
			*result_length1 = _tmp20__length1;
		}
		result = _tmp20_;
		real_files = (_vala_array_free (real_files, real_files_length1, (GDestroyNotify) g_free), NULL);
		all_lines = (_vala_array_free (all_lines, all_lines_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (output);
		_g_free0 (cmd);
		return result;
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		gint64* _tmp21_;
		gint64* _tmp22_;
		gint _tmp22__length1;
		g_clear_error (&_inner_error0_);
		_tmp21_ = g_new0 (gint64, 2);
		_tmp21_[0] = (gint64) -1;
		_tmp21_[1] = (gint64) -1;
		_tmp22_ = _tmp21_;
		_tmp22__length1 = 2;
		if (result_length1) {
			*result_length1 = _tmp22__length1;
		}
		result = _tmp22_;
		_g_free0 (output);
		_g_free0 (cmd);
		return result;
	}
	__finally0:
	_g_free0 (output);
	_g_free0 (cmd);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

static gchar**
desktop_folder_dialogs_show_info_get_filetime (DesktopFolderDialogsShowInfo* self,
                                               gint* result_length1)
{
	gint64 last_edit = 0LL;
	GFileInfo* _tmp0_;
	gint64 last_access = 0LL;
	GFileInfo* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gchar* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->general_info;
	last_edit = (gint64) g_file_info_get_attribute_uint64 (_tmp0_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
	_tmp1_ = self->priv->general_info;
	last_access = (gint64) g_file_info_get_attribute_uint64 (_tmp1_, G_FILE_ATTRIBUTE_TIME_ACCESS);
	_tmp2_ = g_date_time_new_from_unix_local (last_access);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_date_time_to_string (_tmp3_);
	_tmp5_ = g_date_time_new_from_unix_local (last_edit);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_date_time_to_string (_tmp6_);
	_tmp8_ = g_new0 (gchar*, 2 + 1);
	_tmp8_[0] = _tmp4_;
	_tmp8_[1] = _tmp7_;
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 2;
	_g_date_time_unref0 (_tmp6_);
	_g_date_time_unref0 (_tmp3_);
	_tmp10_ = _tmp9_;
	_tmp10__length1 = _tmp9__length1;
	if (result_length1) {
		*result_length1 = _tmp10__length1;
	}
	result = _tmp10_;
	return result;
}

static void
desktop_folder_dialogs_show_info_toggle_executable (DesktopFolderDialogsShowInfo* self,
                                                    GtkToggleButton* button)
{
	gboolean ex = FALSE;
	gchar* cmd = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	ex = gtk_toggle_button_get_active (button);
	_tmp0_ = self->priv->filepath;
	_tmp1_ = g_strconcat ("chmod +x \"", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "\"", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	cmd = _tmp4_;
	if (!ex) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp5_ = self->priv->filepath;
		_tmp6_ = g_strconcat ("chmod -x \"", _tmp5_, NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat (_tmp7_, "\"", NULL);
		_g_free0 (cmd);
		cmd = _tmp8_;
		_g_free0 (_tmp7_);
	}
	{
		const gchar* _tmp9_;
		_tmp9_ = cmd;
		g_spawn_command_line_async (_tmp9_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch0_g_spawn_error;
			}
			_g_free0 (cmd);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (cmd);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (cmd);
}

static GtkImage*
desktop_folder_dialogs_show_info_get_fileicon (DesktopFolderDialogsShowInfo* self)
{
	gchar* icon_name = NULL;
	gchar* _tmp0_;
	GtkImage* fileicon = NULL;
	const gchar* _tmp18_;
	GtkImage* _tmp19_;
	GError* _inner_error0_ = NULL;
	GtkImage* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("unknown");
	icon_name = _tmp0_;
	{
		gchar** icondata = NULL;
		GFileInfo* _tmp1_;
		GIcon* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gint icondata_length1;
		gint _icondata_size_;
		gint len_icons = 0;
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp15_;
		_tmp1_ = self->priv->general_info;
		_tmp2_ = g_file_info_get_icon (_tmp1_);
		_tmp3_ = g_icon_to_string (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, " ", 0);
		_tmp7_ = _tmp6_;
		_tmp7__length1 = _vala_array_length (_tmp5_);
		_g_free0 (_tmp4_);
		icondata = _tmp7_;
		icondata_length1 = _tmp7__length1;
		_icondata_size_ = icondata_length1;
		_tmp8_ = icondata;
		_tmp8__length1 = icondata_length1;
		len_icons = _tmp8__length1;
		_tmp9_ = icondata;
		_tmp9__length1 = icondata_length1;
		_tmp10_ = _tmp9_[len_icons - 1];
		_tmp11_ = g_strdup (_tmp10_);
		_g_free0 (icon_name);
		icon_name = _tmp11_;
		if (len_icons >= 4) {
			gchar** _tmp12_;
			gint _tmp12__length1;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp12_ = icondata;
			_tmp12__length1 = icondata_length1;
			_tmp13_ = _tmp12_[3];
			_tmp14_ = g_strdup (_tmp13_);
			_g_free0 (icon_name);
			icon_name = _tmp14_;
		}
		_tmp15_ = icon_name;
		g_print ("%s\n", _tmp15_);
		icondata = (_vala_array_free (icondata, icondata_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp16_ = _error_;
		_tmp17_ = _tmp16_->message;
		g_print ("Error: %s\n", _tmp17_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (icon_name);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp18_ = icon_name;
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp18_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp19_);
	fileicon = _tmp19_;
	result = fileicon;
	_g_free0 (icon_name);
	return result;
}

static gchar*
desktop_folder_dialogs_show_info_get_filetype (DesktopFolderDialogsShowInfo* self)
{
	gchar* ftype = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_UNKNOWN);
	ftype = _tmp0_;
	{
		GFileInfo* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp1_ = self->priv->general_info;
		_tmp2_ = g_file_info_get_content_type (_tmp1_);
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (ftype);
		ftype = _tmp3_;
		_tmp4_ = ftype;
		g_print ("%s\n", _tmp4_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = _error_;
		_tmp6_ = _tmp5_->message;
		g_print ("Error: %s\n", _tmp6_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (ftype);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = ftype;
	return result;
}

static void
desktop_folder_dialogs_show_info_class_init (DesktopFolderDialogsShowInfoClass * klass,
                                             gpointer klass_data)
{
	desktop_folder_dialogs_show_info_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DesktopFolderDialogsShowInfo_private_offset);
	G_OBJECT_CLASS (klass)->finalize = desktop_folder_dialogs_show_info_finalize;
}

static void
desktop_folder_dialogs_show_info_instance_init (DesktopFolderDialogsShowInfo * self,
                                                gpointer klass)
{
	self->priv = desktop_folder_dialogs_show_info_get_instance_private (self);
}

static void
desktop_folder_dialogs_show_info_finalize (GObject * obj)
{
	DesktopFolderDialogsShowInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_FOLDER_DIALOGS_TYPE_SHOW_INFO, DesktopFolderDialogsShowInfo);
	_g_free0 (self->priv->filepath);
	_g_object_unref0 (self->priv->file);
	_g_object_unref0 (self->priv->general_info);
	G_OBJECT_CLASS (desktop_folder_dialogs_show_info_parent_class)->finalize (obj);
}

static GType
desktop_folder_dialogs_show_info_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderDialogsShowInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_dialogs_show_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderDialogsShowInfo), 0, (GInstanceInitFunc) desktop_folder_dialogs_show_info_instance_init, NULL };
	GType desktop_folder_dialogs_show_info_type_id;
	desktop_folder_dialogs_show_info_type_id = g_type_register_static (gtk_window_get_type (), "DesktopFolderDialogsShowInfo", &g_define_type_info, 0);
	DesktopFolderDialogsShowInfo_private_offset = g_type_add_instance_private (desktop_folder_dialogs_show_info_type_id, sizeof (DesktopFolderDialogsShowInfoPrivate));
	return desktop_folder_dialogs_show_info_type_id;
}

GType
desktop_folder_dialogs_show_info_get_type (void)
{
	static volatile gsize desktop_folder_dialogs_show_info_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dialogs_show_info_type_id__once)) {
		GType desktop_folder_dialogs_show_info_type_id;
		desktop_folder_dialogs_show_info_type_id = desktop_folder_dialogs_show_info_get_type_once ();
		g_once_init_leave (&desktop_folder_dialogs_show_info_type_id__once, desktop_folder_dialogs_show_info_type_id);
	}
	return desktop_folder_dialogs_show_info_type_id__once;
}

DesktopFolderDialogsOpenWith*
desktop_folder_dialogs_open_with_construct (GType object_type,
                                            const gchar* content_type,
                                            const gchar* path)
{
	DesktopFolderDialogsOpenWith * self = NULL;
	gchar* cleaned_path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkAppChooserDialog* dialog = NULL;
	GtkAppChooserDialog* _tmp6_;
	GtkAppChooserDialog* _tmp7_;
	GtkAppChooserDialog* _tmp18_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (content_type != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	self = (DesktopFolderDialogsOpenWith*) g_object_new (object_type, NULL);
	_tmp0_ = string_replace (path, "'", "'\\''");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat ("'", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "'", NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	cleaned_path = _tmp5_;
	_tmp6_ = (GtkAppChooserDialog*) gtk_app_chooser_dialog_new_for_content_type ((GtkWindow*) self, 0, content_type);
	g_object_ref_sink (_tmp6_);
	dialog = _tmp6_;
	_tmp7_ = dialog;
	if (gtk_dialog_run ((GtkDialog*) _tmp7_) == ((gint) GTK_RESPONSE_OK)) {
		GAppInfo* info = NULL;
		GtkAppChooserDialog* _tmp8_;
		GAppInfo* _tmp9_;
		GAppInfo* _tmp10_;
		_tmp8_ = dialog;
		_tmp9_ = gtk_app_chooser_get_app_info ((GtkAppChooser*) _tmp8_);
		info = _tmp9_;
		_tmp10_ = info;
		if (_tmp10_ != NULL) {
			{
				GAppInfo* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				_tmp11_ = info;
				_tmp12_ = g_app_info_get_executable (_tmp11_);
				_tmp13_ = g_strconcat (_tmp12_, " ", NULL);
				_tmp14_ = _tmp13_;
				_tmp15_ = cleaned_path;
				_tmp16_ = g_strconcat (_tmp14_, _tmp15_, NULL);
				_tmp17_ = _tmp16_;
				g_spawn_command_line_async (_tmp17_, &_inner_error0_);
				_g_free0 (_tmp17_);
				_g_free0 (_tmp14_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_SPAWN_ERROR) {
						goto __catch0_g_spawn_error;
					}
					_g_object_unref0 (info);
					_g_object_unref0 (dialog);
					_g_free0 (cleaned_path);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			goto __finally0;
			__catch0_g_spawn_error:
			{
				g_clear_error (&_inner_error0_);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (info);
				_g_object_unref0 (dialog);
				_g_free0 (cleaned_path);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_g_object_unref0 (info);
	}
	_tmp18_ = dialog;
	g_signal_emit_by_name ((GtkDialog*) _tmp18_, "close");
	_g_object_unref0 (dialog);
	_g_free0 (cleaned_path);
	return self;
}

DesktopFolderDialogsOpenWith*
desktop_folder_dialogs_open_with_new (const gchar* content_type,
                                      const gchar* path)
{
	return desktop_folder_dialogs_open_with_construct (DESKTOP_FOLDER_DIALOGS_TYPE_OPEN_WITH, content_type, path);
}

static void
desktop_folder_dialogs_open_with_class_init (DesktopFolderDialogsOpenWithClass * klass,
                                             gpointer klass_data)
{
	desktop_folder_dialogs_open_with_parent_class = g_type_class_peek_parent (klass);
}

static void
desktop_folder_dialogs_open_with_instance_init (DesktopFolderDialogsOpenWith * self,
                                                gpointer klass)
{
}

static GType
desktop_folder_dialogs_open_with_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderDialogsOpenWithClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_dialogs_open_with_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderDialogsOpenWith), 0, (GInstanceInitFunc) desktop_folder_dialogs_open_with_instance_init, NULL };
	GType desktop_folder_dialogs_open_with_type_id;
	desktop_folder_dialogs_open_with_type_id = g_type_register_static (gtk_app_chooser_dialog_get_type (), "DesktopFolderDialogsOpenWith", &g_define_type_info, 0);
	return desktop_folder_dialogs_open_with_type_id;
}

GType
desktop_folder_dialogs_open_with_get_type (void)
{
	static volatile gsize desktop_folder_dialogs_open_with_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dialogs_open_with_type_id__once)) {
		GType desktop_folder_dialogs_open_with_type_id;
		desktop_folder_dialogs_open_with_type_id = desktop_folder_dialogs_open_with_get_type_once ();
		g_once_init_leave (&desktop_folder_dialogs_open_with_type_id__once, desktop_folder_dialogs_open_with_type_id);
	}
	return desktop_folder_dialogs_open_with_type_id__once;
}

static inline gpointer
desktop_folder_dialogs_panel_properties_get_instance_private (DesktopFolderDialogsPanelProperties* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopFolderDialogsPanelProperties_private_offset);
}

static GType
desktop_folder_dialogs_panel_properties_resolution_strategy_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_NONE, "DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_NONE", "none"}, {DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_SCALE, "DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_SCALE", "scale"}, {DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_STORE, "DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_RESOLUTION_STRATEGY_STORE", "store"}, {0, NULL, NULL}};
	GType desktop_folder_dialogs_panel_properties_resolution_strategy_type_id;
	desktop_folder_dialogs_panel_properties_resolution_strategy_type_id = g_enum_register_static ("DesktopFolderDialogsPanelPropertiesResolutionStrategy", values);
	return desktop_folder_dialogs_panel_properties_resolution_strategy_type_id;
}

static GType
desktop_folder_dialogs_panel_properties_resolution_strategy_get_type (void)
{
	static volatile gsize desktop_folder_dialogs_panel_properties_resolution_strategy_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dialogs_panel_properties_resolution_strategy_type_id__once)) {
		GType desktop_folder_dialogs_panel_properties_resolution_strategy_type_id;
		desktop_folder_dialogs_panel_properties_resolution_strategy_type_id = desktop_folder_dialogs_panel_properties_resolution_strategy_get_type_once ();
		g_once_init_leave (&desktop_folder_dialogs_panel_properties_resolution_strategy_type_id__once, desktop_folder_dialogs_panel_properties_resolution_strategy_type_id);
	}
	return desktop_folder_dialogs_panel_properties_resolution_strategy_type_id__once;
}

DesktopFolderDialogsPanelProperties*
desktop_folder_dialogs_panel_properties_construct (GType object_type,
                                                   DesktopFolderFolderWindow* window)
{
	DesktopFolderDialogsPanelProperties * self = NULL;
	DesktopFolderFolderWindow* _tmp0_;
	DesktopFolderFolderWindow* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	g_return_val_if_fail (window != NULL, NULL);
	self = (DesktopFolderDialogsPanelProperties*) g_object_new (object_type, "border-width", 5, "deletable", FALSE, "resizable", FALSE, "modal", TRUE, "title", DESKTOP_FOLDER_LANG_PANELPROPERTIES_PROPERTIES, NULL);
	_tmp0_ = _g_object_ref0 (window);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp0_;
	_tmp1_ = self->priv->window;
	_tmp2_ = desktop_folder_folder_window_get_manager (_tmp1_);
	_g_object_unref0 (self->priv->manager);
	self->priv->manager = _tmp2_;
	desktop_folder_dialogs_panel_properties_build (self);
	return self;
}

DesktopFolderDialogsPanelProperties*
desktop_folder_dialogs_panel_properties_new (DesktopFolderFolderWindow* window)
{
	return desktop_folder_dialogs_panel_properties_construct (DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES, window);
}

/**
         * @name build
         * @description build the window components
         */
static void
__lambda107_ (DesktopFolderDialogsPanelProperties* self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
___lambda107__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda107_ ((DesktopFolderDialogsPanelProperties*) self);
}

static void
desktop_folder_dialogs_panel_properties_build (DesktopFolderDialogsPanelProperties* self)
{
	GtkStack* _tmp0_;
	GtkStack* _tmp1_;
	GtkStack* _tmp2_;
	GtkStack* _tmp3_;
	GtkWidget* _tmp4_;
	GtkStack* _tmp5_;
	GtkWidget* _tmp6_;
	GtkStack* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_;
	GtkLabel* version_label = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkStackSwitcher* main_stackswitcher = NULL;
	GtkStackSwitcher* _tmp16_;
	GtkStack* _tmp17_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp18_;
	GtkStack* _tmp19_;
	GtkBox* _tmp20_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->main_stack);
	self->priv->main_stack = _tmp0_;
	_tmp1_ = self->priv->main_stack;
	g_object_set ((GtkWidget*) _tmp1_, "margin", 12, NULL);
	_tmp2_ = self->priv->main_stack;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp2_, 18);
	_tmp3_ = self->priv->main_stack;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp3_, 24);
	_tmp4_ = desktop_folder_dialogs_panel_properties_get_properties_box (self);
	_g_object_unref0 (self->priv->properties_grid);
	self->priv->properties_grid = _tmp4_;
	_tmp5_ = self->priv->main_stack;
	_tmp6_ = self->priv->properties_grid;
	gtk_stack_add_titled (_tmp5_, _tmp6_, "properties", DESKTOP_FOLDER_LANG_PANELPROPERTIES_PROPERTIES);
	_tmp7_ = self->priv->main_stack;
	_tmp8_ = desktop_folder_dialogs_panel_properties_get_general_box (self);
	_tmp9_ = _tmp8_;
	gtk_stack_add_titled (_tmp7_, _tmp9_, "general", DESKTOP_FOLDER_LANG_PANELPROPERTIES_GENERAL);
	_g_object_unref0 (_tmp9_);
	_tmp10_ = g_utf8_strup (DESKTOP_FOLDER_VERSION, (gssize) -1);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat ("Version ", _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = (GtkLabel*) gtk_label_new (_tmp13_);
	g_object_ref_sink (_tmp14_);
	_tmp15_ = _tmp14_;
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	version_label = _tmp15_;
	gtk_widget_set_size_request ((GtkWidget*) version_label, 250, -1);
	gtk_label_set_xalign (version_label, (gfloat) 0);
	_tmp16_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
	g_object_ref_sink (_tmp16_);
	main_stackswitcher = _tmp16_;
	_tmp17_ = self->priv->main_stack;
	gtk_stack_switcher_set_stack (main_stackswitcher, _tmp17_);
	gtk_box_set_homogeneous ((GtkBox*) main_stackswitcher, TRUE);
	gtk_widget_set_margin_start ((GtkWidget*) main_stackswitcher, 12);
	gtk_widget_set_margin_end ((GtkWidget*) main_stackswitcher, 12);
	_tmp18_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp18_);
	main_grid = _tmp18_;
	gtk_grid_attach (main_grid, (GtkWidget*) main_stackswitcher, 0, 0, 1, 1);
	_tmp19_ = self->priv->main_stack;
	gtk_grid_attach (main_grid, (GtkWidget*) _tmp19_, 0, 1, 1, 1);
	_tmp20_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) main_grid);
	_tmp21_ = (GtkButton*) gtk_button_new_with_label (DESKTOP_FOLDER_LANG_PANELPROPERTIES_CLOSE);
	g_object_ref_sink (_tmp21_);
	close_button = _tmp21_;
	g_signal_connect_object (close_button, "clicked", (GCallback) ___lambda107__gtk_button_clicked, self, 0);
	gtk_dialog_add_action_widget ((GtkDialog*) self, (GtkWidget*) version_label, 1);
	gtk_dialog_add_action_widget ((GtkDialog*) self, (GtkWidget*) close_button, 0);
	_g_object_unref0 (close_button);
	_g_object_unref0 (main_grid);
	_g_object_unref0 (main_stackswitcher);
	_g_object_unref0 (version_label);
}

/**
         * @name get_properties_box
         * @description build the properties section
         * @return {Gtk.Widget} the built Gtk.Grid widget
         */
static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
	g_atomic_int_inc (&_data34_->_ref_count_);
	return _data34_;
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
		DesktopFolderDialogsPanelProperties* self;
		self = _data34_->self;
		_g_object_unref0 (_data34_->scale);
		_g_object_unref0 (_data34_->arrangement_combo);
		_g_object_unref0 (self);
		g_slice_free (Block34Data, _data34_);
	}
}

static void
__lambda103_ (Block34Data* _data34_)
{
	DesktopFolderDialogsPanelProperties* self;
	GtkComboBoxText* _tmp0_;
	const gchar* _tmp1_;
	self = _data34_->self;
	_tmp0_ = _data34_->arrangement_combo;
	_tmp1_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp0_);
	if (g_strcmp0 (_tmp1_, "FREE") == 0) {
		DesktopFolderFolderManager* _tmp2_;
		_tmp2_ = self->priv->manager;
		desktop_folder_folder_manager_on_arrange_change (_tmp2_, desktop_folder_folder_arrangement_ARRANGEMENT_TYPE_FREE);
	} else {
		GtkComboBoxText* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = _data34_->arrangement_combo;
		_tmp4_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp3_);
		if (g_strcmp0 (_tmp4_, "GRID") == 0) {
			DesktopFolderFolderManager* _tmp5_;
			_tmp5_ = self->priv->manager;
			desktop_folder_folder_manager_on_arrange_change (_tmp5_, desktop_folder_folder_arrangement_ARRANGEMENT_TYPE_GRID);
		} else {
			DesktopFolderFolderManager* _tmp6_;
			_tmp6_ = self->priv->manager;
			desktop_folder_folder_manager_on_arrange_change (_tmp6_, desktop_folder_folder_arrangement_ARRANGEMENT_TYPE_MANAGED);
		}
	}
}

static void
___lambda103__gtk_combo_box_changed (GtkComboBox* _sender,
                                     gpointer self)
{
	__lambda103_ (self);
}

static void
_desktop_folder_folder_window_on_toggle_lockitems_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
	desktop_folder_folder_window_on_toggle_lockitems ((DesktopFolderFolderWindow*) self);
}

static void
_desktop_folder_folder_window_on_toggle_lockpanel_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
	desktop_folder_folder_window_on_toggle_lockpanel ((DesktopFolderFolderWindow*) self);
}

static void
_desktop_folder_folder_window_on_toggle_shadow_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
	desktop_folder_folder_window_on_toggle_shadow ((DesktopFolderFolderWindow*) self);
}

static void
_desktop_folder_folder_window_on_toggle_bold_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
	desktop_folder_folder_window_on_toggle_bold ((DesktopFolderFolderWindow*) self);
}

static void
__lambda104_ (Block34Data* _data34_)
{
	DesktopFolderDialogsPanelProperties* self;
	DesktopFolderFolderManager* _tmp0_;
	DesktopFolderFolderSettings* _tmp1_;
	DesktopFolderFolderSettings* _tmp2_;
	GtkSpinButton* _tmp3_;
	DesktopFolderFolderManager* _tmp4_;
	DesktopFolderFolderArrangement* _tmp5_;
	DesktopFolderFolderArrangement* _tmp6_;
	gboolean _tmp7_;
	self = _data34_->self;
	_tmp0_ = self->priv->manager;
	_tmp1_ = desktop_folder_folder_manager_get_settings (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _data34_->scale;
	desktop_folder_folder_settings_set_arrangement_padding (_tmp2_, (gint) gtk_spin_button_get_value (_tmp3_));
	_g_object_unref0 (_tmp2_);
	_tmp4_ = self->priv->manager;
	_tmp5_ = desktop_folder_folder_manager_get_arrangement (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = desktop_folder_folder_arrangement_force_organization (_tmp6_);
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		DesktopFolderFolderManager* _tmp8_;
		_tmp8_ = self->priv->manager;
		desktop_folder_folder_manager_organize_panel_items (_tmp8_);
	}
}

static void
___lambda104__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                             gpointer self)
{
	__lambda104_ (self);
}

static GtkWidget*
desktop_folder_dialogs_panel_properties_get_properties_box (DesktopFolderDialogsPanelProperties* self)
{
	Block34Data* _data34_;
	GtkGrid* general_grid = NULL;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp4_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp5_;
	GtkGrid* _tmp6_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp7_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp8_;
	GtkComboBoxText* _tmp9_;
	GtkComboBoxText* _tmp10_;
	GtkComboBoxText* _tmp11_;
	GtkComboBoxText* _tmp12_;
	GtkComboBoxText* _tmp13_;
	DesktopFolderFolderManager* _tmp14_;
	DesktopFolderFolderSettings* _tmp15_;
	DesktopFolderFolderSettings* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GtkComboBoxText* _tmp19_;
	GtkComboBoxText* _tmp20_;
	GtkGrid* _tmp21_;
	GtkComboBoxText* _tmp22_;
	GtkGrid* _tmp23_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp24_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp25_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* settings_switch = NULL;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp26_;
	GtkGrid* _tmp27_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp28_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp29_;
	DesktopFolderFolderManager* _tmp30_;
	DesktopFolderFolderSettings* _tmp31_;
	DesktopFolderFolderSettings* _tmp32_;
	gboolean _tmp33_;
	gboolean _tmp34_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp35_;
	DesktopFolderFolderWindow* _tmp36_;
	gint top_offset = 0;
	DesktopFolderFolderWindow* _tmp37_;
	GtkGrid* _tmp52_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp53_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp54_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp55_;
	GtkGrid* _tmp56_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp57_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp58_;
	GtkGrid* _tmp59_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp60_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp61_;
	DesktopFolderFolderManager* _tmp62_;
	DesktopFolderFolderSettings* _tmp63_;
	DesktopFolderFolderSettings* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp67_;
	DesktopFolderFolderWindow* _tmp68_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp69_;
	GtkGrid* _tmp70_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp71_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp72_;
	GtkGrid* _tmp73_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp74_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp75_;
	DesktopFolderFolderManager* _tmp76_;
	DesktopFolderFolderSettings* _tmp77_;
	DesktopFolderFolderSettings* _tmp78_;
	gboolean _tmp79_;
	gboolean _tmp80_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp81_;
	DesktopFolderFolderWindow* _tmp82_;
	GtkGrid* _tmp83_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp84_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp85_;
	GtkSpinButton* _tmp86_;
	GtkSpinButton* _tmp87_;
	DesktopFolderFolderManager* _tmp88_;
	DesktopFolderFolderSettings* _tmp89_;
	DesktopFolderFolderSettings* _tmp90_;
	gint _tmp91_;
	gint _tmp92_;
	GtkSpinButton* _tmp93_;
	GtkGrid* _tmp94_;
	GtkSpinButton* _tmp95_;
	gboolean _tmp96_ = FALSE;
	DesktopFolderFolderWindow* _tmp97_;
	GtkWidget* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data34_ = g_slice_new0 (Block34Data);
	_data34_->_ref_count_ = 1;
	_data34_->self = g_object_ref (self);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	general_grid = _tmp0_;
	_tmp1_ = general_grid;
	gtk_grid_set_row_spacing (_tmp1_, 6);
	_tmp2_ = general_grid;
	gtk_grid_set_column_spacing (_tmp2_, 12);
	_tmp3_ = general_grid;
	_tmp4_ = desktop_folder_dialogs_panel_properties_settings_header_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_BEHAVIOR);
	g_object_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	gtk_grid_attach (_tmp3_, (GtkWidget*) _tmp5_, 0, 0, 2, 1);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = general_grid;
	_tmp7_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT);
	g_object_ref_sink (_tmp7_);
	_tmp8_ = _tmp7_;
	gtk_grid_attach (_tmp6_, (GtkWidget*) _tmp8_, 0, 1, 1, 1);
	_g_object_unref0 (_tmp8_);
	_tmp9_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp9_);
	_data34_->arrangement_combo = _tmp9_;
	_tmp10_ = _data34_->arrangement_combo;
	gtk_combo_box_text_append (_tmp10_, "FREE", DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_FREE);
	_tmp11_ = _data34_->arrangement_combo;
	gtk_combo_box_text_append (_tmp11_, "GRID", DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_GRID);
	_tmp12_ = _data34_->arrangement_combo;
	gtk_combo_box_text_append (_tmp12_, "MANAGED", DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_MANAGED);
	_tmp13_ = _data34_->arrangement_combo;
	_tmp14_ = self->priv->manager;
	_tmp15_ = desktop_folder_folder_manager_get_settings (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = desktop_folder_folder_settings_get_arrangement_type (_tmp16_);
	_tmp18_ = _tmp17_;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp13_, _tmp18_ - 1);
	_g_object_unref0 (_tmp16_);
	_tmp19_ = _data34_->arrangement_combo;
	g_signal_connect_data ((GtkComboBox*) _tmp19_, "changed", (GCallback) ___lambda103__gtk_combo_box_changed, block34_data_ref (_data34_), (GClosureNotify) block34_data_unref, 0);
	_tmp20_ = _data34_->arrangement_combo;
	g_object_set ((GtkWidget*) _tmp20_, "expand", TRUE, NULL);
	_tmp21_ = general_grid;
	_tmp22_ = _data34_->arrangement_combo;
	gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, 1, 1, 1, 1);
	_tmp23_ = general_grid;
	_tmp24_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_LOCK_ITEMS);
	g_object_ref_sink (_tmp24_);
	_tmp25_ = _tmp24_;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp25_, 0, 2, 1, 1);
	_g_object_unref0 (_tmp25_);
	_tmp26_ = desktop_folder_dialogs_panel_properties_settings_switch_new ("lock_items");
	g_object_ref_sink (_tmp26_);
	settings_switch = _tmp26_;
	_tmp27_ = general_grid;
	_tmp28_ = settings_switch;
	gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 1, 2, 1, 1);
	_tmp29_ = settings_switch;
	_tmp30_ = self->priv->manager;
	_tmp31_ = desktop_folder_folder_manager_get_settings (_tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = desktop_folder_folder_settings_get_lockitems (_tmp32_);
	_tmp34_ = _tmp33_;
	gtk_switch_set_active ((GtkSwitch*) _tmp29_, _tmp34_);
	_g_object_unref0 (_tmp32_);
	_tmp35_ = settings_switch;
	_tmp36_ = self->priv->window;
	g_signal_connect_object ((GObject*) _tmp35_, "notify::active", (GCallback) _desktop_folder_folder_window_on_toggle_lockitems_g_object_notify, _tmp36_, 0);
	top_offset = -1;
	_tmp37_ = self->priv->window;
	if (G_TYPE_FROM_INSTANCE ((GObject*) _tmp37_) != DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW) {
		GtkGrid* _tmp38_;
		DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp39_;
		DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp40_;
		DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp41_;
		GtkGrid* _tmp42_;
		DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp43_;
		DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp44_;
		DesktopFolderFolderManager* _tmp45_;
		DesktopFolderFolderSettings* _tmp46_;
		DesktopFolderFolderSettings* _tmp47_;
		gboolean _tmp48_;
		gboolean _tmp49_;
		DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp50_;
		DesktopFolderFolderWindow* _tmp51_;
		top_offset = 0;
		_tmp38_ = general_grid;
		_tmp39_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_LOCK_PANEL);
		g_object_ref_sink (_tmp39_);
		_tmp40_ = _tmp39_;
		gtk_grid_attach (_tmp38_, (GtkWidget*) _tmp40_, 0, 3, 1, 1);
		_g_object_unref0 (_tmp40_);
		_tmp41_ = desktop_folder_dialogs_panel_properties_settings_switch_new ("lock_panel");
		g_object_ref_sink (_tmp41_);
		_g_object_unref0 (settings_switch);
		settings_switch = _tmp41_;
		_tmp42_ = general_grid;
		_tmp43_ = settings_switch;
		gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 1, 3, 1, 1);
		_tmp44_ = settings_switch;
		_tmp45_ = self->priv->manager;
		_tmp46_ = desktop_folder_folder_manager_get_settings (_tmp45_);
		_tmp47_ = _tmp46_;
		_tmp48_ = desktop_folder_folder_settings_get_lockpanel (_tmp47_);
		_tmp49_ = _tmp48_;
		gtk_switch_set_active ((GtkSwitch*) _tmp44_, _tmp49_);
		_g_object_unref0 (_tmp47_);
		_tmp50_ = settings_switch;
		_tmp51_ = self->priv->window;
		g_signal_connect_object ((GObject*) _tmp50_, "notify::active", (GCallback) _desktop_folder_folder_window_on_toggle_lockpanel_g_object_notify, _tmp51_, 0);
	}
	_tmp52_ = general_grid;
	_tmp53_ = desktop_folder_dialogs_panel_properties_settings_header_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_APPEARANCE);
	g_object_ref_sink (_tmp53_);
	_tmp54_ = _tmp53_;
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp54_, 0, 4 + top_offset, 2, 1);
	_g_object_unref0 (_tmp54_);
	_tmp55_ = desktop_folder_dialogs_panel_properties_settings_switch_new ("text_shadow");
	g_object_ref_sink (_tmp55_);
	_g_object_unref0 (settings_switch);
	settings_switch = _tmp55_;
	_tmp56_ = general_grid;
	_tmp57_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_TEXT_SHADOW);
	g_object_ref_sink (_tmp57_);
	_tmp58_ = _tmp57_;
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp58_, 0, 5 + top_offset, 1, 1);
	_g_object_unref0 (_tmp58_);
	_tmp59_ = general_grid;
	_tmp60_ = settings_switch;
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 1, 5 + top_offset, 1, 1);
	_tmp61_ = settings_switch;
	_tmp62_ = self->priv->manager;
	_tmp63_ = desktop_folder_folder_manager_get_settings (_tmp62_);
	_tmp64_ = _tmp63_;
	_tmp65_ = desktop_folder_folder_settings_get_textshadow (_tmp64_);
	_tmp66_ = _tmp65_;
	gtk_switch_set_active ((GtkSwitch*) _tmp61_, _tmp66_);
	_g_object_unref0 (_tmp64_);
	_tmp67_ = settings_switch;
	_tmp68_ = self->priv->window;
	g_signal_connect_object ((GObject*) _tmp67_, "notify::active", (GCallback) _desktop_folder_folder_window_on_toggle_shadow_g_object_notify, _tmp68_, 0);
	_tmp69_ = desktop_folder_dialogs_panel_properties_settings_switch_new ("text_bold");
	g_object_ref_sink (_tmp69_);
	_g_object_unref0 (settings_switch);
	settings_switch = _tmp69_;
	_tmp70_ = general_grid;
	_tmp71_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_TEXT_BOLD);
	g_object_ref_sink (_tmp71_);
	_tmp72_ = _tmp71_;
	gtk_grid_attach (_tmp70_, (GtkWidget*) _tmp72_, 0, 6 + top_offset, 1, 1);
	_g_object_unref0 (_tmp72_);
	_tmp73_ = general_grid;
	_tmp74_ = settings_switch;
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 1, 6 + top_offset, 1, 1);
	_tmp75_ = settings_switch;
	_tmp76_ = self->priv->manager;
	_tmp77_ = desktop_folder_folder_manager_get_settings (_tmp76_);
	_tmp78_ = _tmp77_;
	_tmp79_ = desktop_folder_folder_settings_get_textbold (_tmp78_);
	_tmp80_ = _tmp79_;
	gtk_switch_set_active ((GtkSwitch*) _tmp75_, _tmp80_);
	_g_object_unref0 (_tmp78_);
	_tmp81_ = settings_switch;
	_tmp82_ = self->priv->window;
	g_signal_connect_object ((GObject*) _tmp81_, "notify::active", (GCallback) _desktop_folder_folder_window_on_toggle_bold_g_object_notify, _tmp82_, 0);
	_tmp83_ = general_grid;
	_tmp84_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_PADDING);
	g_object_ref_sink (_tmp84_);
	_tmp85_ = _tmp84_;
	gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp85_, 0, 7 + top_offset, 1, 1);
	_g_object_unref0 (_tmp85_);
	_tmp86_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 50, (gdouble) 1);
	g_object_ref_sink (_tmp86_);
	_data34_->scale = _tmp86_;
	_tmp87_ = _data34_->scale;
	_tmp88_ = self->priv->manager;
	_tmp89_ = desktop_folder_folder_manager_get_settings (_tmp88_);
	_tmp90_ = _tmp89_;
	_tmp91_ = desktop_folder_folder_settings_get_arrangement_padding (_tmp90_);
	_tmp92_ = _tmp91_;
	gtk_spin_button_set_value (_tmp87_, (gdouble) _tmp92_);
	_g_object_unref0 (_tmp90_);
	_tmp93_ = _data34_->scale;
	g_signal_connect_data (_tmp93_, "value-changed", (GCallback) ___lambda104__gtk_spin_button_value_changed, block34_data_ref (_data34_), (GClosureNotify) block34_data_unref, 0);
	_tmp94_ = general_grid;
	_tmp95_ = _data34_->scale;
	gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 1, 7 + top_offset, 1, 1);
	_tmp97_ = self->priv->window;
	if (G_TYPE_FROM_INSTANCE ((GObject*) _tmp97_) == DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW) {
		gboolean _tmp98_ = FALSE;
		DesktopFolderFolderManager* _tmp99_;
		DesktopFolderApp* _tmp100_;
		DesktopFolderApp* _tmp101_;
		gboolean _tmp102_;
		_tmp99_ = self->priv->manager;
		_tmp100_ = desktop_folder_folder_manager_get_application (_tmp99_);
		_tmp101_ = _tmp100_;
		_tmp102_ = !desktop_folder_app_get_desktoppanel_enabled (_tmp101_);
		_g_object_unref0 (_tmp101_);
		if (_tmp102_) {
			_tmp98_ = TRUE;
		} else {
			DesktopFolderFolderManager* _tmp103_;
			DesktopFolderApp* _tmp104_;
			DesktopFolderApp* _tmp105_;
			_tmp103_ = self->priv->manager;
			_tmp104_ = desktop_folder_folder_manager_get_application (_tmp103_);
			_tmp105_ = _tmp104_;
			_tmp98_ = !desktop_folder_app_get_desktopicons_enabled (_tmp105_);
			_g_object_unref0 (_tmp105_);
		}
		_tmp96_ = _tmp98_;
	} else {
		_tmp96_ = FALSE;
	}
	if (_tmp96_) {
		GtkGrid* _tmp106_;
		_tmp106_ = general_grid;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp106_, FALSE);
	}
	result = (GtkWidget*) general_grid;
	_g_object_unref0 (settings_switch);
	block34_data_unref (_data34_);
	_data34_ = NULL;
	return result;
}

/**
         * @name set_property_page_sensitivity
         * @description set sensitivity of properties page items
         */
static void
desktop_folder_dialogs_panel_properties_set_property_page_sensitivity (DesktopFolderDialogsPanelProperties* self,
                                                                       gboolean sensitivity)
{
	GtkWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->properties_grid;
	if (_tmp0_ != NULL) {
		GtkWidget* _tmp1_;
		_tmp1_ = self->priv->properties_grid;
		gtk_widget_set_sensitive (_tmp1_, sensitivity);
	}
}

/**
         * @name get_general_box
         * @description build the general section
         * @return {Gtk.Widget} the built Gtk.Grid widget
         */
static Block35Data*
block35_data_ref (Block35Data* _data35_)
{
	g_atomic_int_inc (&_data35_->_ref_count_);
	return _data35_;
}

static void
block35_data_unref (void * _userdata_)
{
	Block35Data* _data35_;
	_data35_ = (Block35Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data35_->_ref_count_)) {
		DesktopFolderDialogsPanelProperties* self;
		self = _data35_->self;
		_g_object_unref0 (_data35_->scale);
		_g_object_unref0 (_data35_->settings);
		_g_object_unref0 (self);
		g_slice_free (Block35Data, _data35_);
	}
}

static void
__lambda105_ (Block35Data* _data35_)
{
	DesktopFolderDialogsPanelProperties* self;
	gboolean desktopicons_enabled = FALSE;
	DesktopFolderFolderWindow* _tmp0_;
	self = _data35_->self;
	desktopicons_enabled = g_settings_get_boolean (_data35_->settings, "icons-on-desktop");
	g_settings_set_boolean (_data35_->settings, "icons-on-desktop", !desktopicons_enabled);
	_tmp0_ = self->priv->window;
	if (G_TYPE_FROM_INSTANCE ((GObject*) _tmp0_) == DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW) {
		desktop_folder_dialogs_panel_properties_set_property_page_sensitivity (self, !desktopicons_enabled);
	}
}

static void
___lambda105__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	__lambda105_ (self);
}

static void
__lambda106_ (Block35Data* _data35_)
{
	DesktopFolderDialogsPanelProperties* self;
	self = _data35_->self;
	g_settings_set_int (_data35_->settings, "default-arrangement-padding", (gint) gtk_spin_button_get_value (_data35_->scale));
}

static void
___lambda106__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                             gpointer self)
{
	__lambda106_ (self);
}

static GtkWidget*
desktop_folder_dialogs_panel_properties_get_general_box (DesktopFolderDialogsPanelProperties* self)
{
	Block35Data* _data35_;
	GtkGrid* general_grid = NULL;
	GtkGrid* _tmp0_;
	GSettings* _tmp1_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp2_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp3_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp4_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp5_;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* settings_switch = NULL;
	DesktopFolderDialogsPanelPropertiesSettingsSwitch* _tmp6_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp7_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp8_;
	GtkComboBoxText* strategy_combo = NULL;
	GtkComboBoxText* _tmp9_;
	GtkImage* resolution_strategy_help = NULL;
	GtkImage* _tmp10_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp11_;
	DesktopFolderDialogsPanelPropertiesSettingsHeader* _tmp12_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp13_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp14_;
	GtkComboBoxText* arrangement_combo = NULL;
	GtkComboBoxText* _tmp15_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp16_;
	DesktopFolderDialogsPanelPropertiesSettingsLabel* _tmp17_;
	GtkSpinButton* _tmp18_;
	GtkWidget* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data35_ = g_slice_new0 (Block35Data);
	_data35_->_ref_count_ = 1;
	_data35_->self = g_object_ref (self);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	general_grid = _tmp0_;
	gtk_grid_set_row_spacing (general_grid, 6);
	gtk_grid_set_column_spacing (general_grid, 12);
	_tmp1_ = g_settings_new ("com.github.spheras.desktopfolder");
	_data35_->settings = _tmp1_;
	_tmp2_ = desktop_folder_dialogs_panel_properties_settings_header_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_GENERAL);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	gtk_grid_attach (general_grid, (GtkWidget*) _tmp3_, 0, 0, 2, 1);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_DESKTOP_ICONS);
	g_object_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	gtk_grid_attach (general_grid, (GtkWidget*) _tmp5_, 0, 1, 1, 1);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = desktop_folder_dialogs_panel_properties_settings_switch_new ("icons-on-desktop");
	g_object_ref_sink (_tmp6_);
	settings_switch = _tmp6_;
	gtk_widget_set_halign ((GtkWidget*) settings_switch, GTK_ALIGN_START);
	gtk_widget_set_margin_end ((GtkWidget*) settings_switch, 8);
	gtk_grid_attach (general_grid, (GtkWidget*) settings_switch, 1, 1, 1, 1);
	gtk_switch_set_active ((GtkSwitch*) settings_switch, g_settings_get_boolean (_data35_->settings, "icons-on-desktop"));
	g_signal_connect_data ((GObject*) settings_switch, "notify::active", (GCallback) ___lambda105__g_object_notify, block35_data_ref (_data35_), (GClosureNotify) block35_data_unref, 0);
	_tmp7_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY);
	g_object_ref_sink (_tmp7_);
	_tmp8_ = _tmp7_;
	gtk_grid_attach (general_grid, (GtkWidget*) _tmp8_, 0, 3, 1, 1);
	_g_object_unref0 (_tmp8_);
	_tmp9_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp9_);
	strategy_combo = _tmp9_;
	gtk_combo_box_text_append (strategy_combo, "NONE", DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_NONE);
	gtk_combo_box_text_append (strategy_combo, "SCALE", DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_SCALE);
	gtk_combo_box_text_append (strategy_combo, "STORE", DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_STORE);
	g_settings_bind (_data35_->settings, "resolution-strategy", (GObject*) strategy_combo, "active-id", G_SETTINGS_BIND_DEFAULT);
	gtk_widget_set_margin_end ((GtkWidget*) strategy_combo, 8);
	gtk_grid_attach (general_grid, (GtkWidget*) strategy_combo, 1, 3, 1, 1);
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("help-info-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp10_);
	resolution_strategy_help = _tmp10_;
	gtk_widget_set_halign ((GtkWidget*) resolution_strategy_help, GTK_ALIGN_START);
	gtk_widget_set_hexpand ((GtkWidget*) resolution_strategy_help, TRUE);
	gtk_widget_set_tooltip_text ((GtkWidget*) resolution_strategy_help, DESKTOP_FOLDER_LANG_PANELPROPERTIES_RESOLUTION_STRATEGY_DESCRIPTION);
	gtk_grid_attach (general_grid, (GtkWidget*) resolution_strategy_help, 2, 3, 1, 1);
	_tmp11_ = desktop_folder_dialogs_panel_properties_settings_header_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_ICONS);
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	gtk_grid_attach (general_grid, (GtkWidget*) _tmp12_, 0, 4, 2, 1);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_DEFAULT);
	g_object_ref_sink (_tmp13_);
	_tmp14_ = _tmp13_;
	gtk_grid_attach (general_grid, (GtkWidget*) _tmp14_, 0, 5, 1, 1);
	_g_object_unref0 (_tmp14_);
	_tmp15_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp15_);
	arrangement_combo = _tmp15_;
	gtk_combo_box_text_append (arrangement_combo, "FREE", DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_FREE);
	gtk_combo_box_text_append (arrangement_combo, "GRID", DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_GRID);
	gtk_combo_box_text_append (arrangement_combo, "MANAGED", DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_MANAGED);
	g_settings_bind (_data35_->settings, "default-arrangement", (GObject*) arrangement_combo, "active-id", G_SETTINGS_BIND_DEFAULT);
	gtk_widget_set_margin_end ((GtkWidget*) arrangement_combo, 8);
	gtk_grid_attach (general_grid, (GtkWidget*) arrangement_combo, 1, 5, 1, 1);
	_tmp16_ = desktop_folder_dialogs_panel_properties_settings_label_new (DESKTOP_FOLDER_LANG_PANELPROPERTIES_ARRANGEMENT_PADDING_DEFAULT);
	g_object_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	gtk_grid_attach (general_grid, (GtkWidget*) _tmp17_, 0, 6, 1, 1);
	_g_object_unref0 (_tmp17_);
	_tmp18_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 50, (gdouble) 1);
	g_object_ref_sink (_tmp18_);
	_data35_->scale = _tmp18_;
	gtk_spin_button_set_value (_data35_->scale, (gdouble) g_settings_get_int (_data35_->settings, "default-arrangement-padding"));
	g_signal_connect_data (_data35_->scale, "value-changed", (GCallback) ___lambda106__gtk_spin_button_value_changed, block35_data_ref (_data35_), (GClosureNotify) block35_data_unref, 0);
	gtk_grid_attach (general_grid, (GtkWidget*) _data35_->scale, 1, 6, 1, 1);
	result = (GtkWidget*) general_grid;
	_g_object_unref0 (arrangement_combo);
	_g_object_unref0 (resolution_strategy_help);
	_g_object_unref0 (strategy_combo);
	_g_object_unref0 (settings_switch);
	block35_data_unref (_data35_);
	_data35_ = NULL;
	return result;
}

static DesktopFolderDialogsPanelPropertiesSettingsHeader*
desktop_folder_dialogs_panel_properties_settings_header_construct (GType object_type,
                                                                   const gchar* text)
{
	DesktopFolderDialogsPanelPropertiesSettingsHeader * self = NULL;
	GtkStyleContext* _tmp0_;
	g_return_val_if_fail (text != NULL, NULL);
	self = (DesktopFolderDialogsPanelPropertiesSettingsHeader*) g_object_new (object_type, NULL);
	gtk_label_set_label ((GtkLabel*) self, text);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "h4");
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_START);
	return self;
}

static DesktopFolderDialogsPanelPropertiesSettingsHeader*
desktop_folder_dialogs_panel_properties_settings_header_new (const gchar* text)
{
	return desktop_folder_dialogs_panel_properties_settings_header_construct (DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_HEADER, text);
}

static void
desktop_folder_dialogs_panel_properties_settings_header_class_init (DesktopFolderDialogsPanelPropertiesSettingsHeaderClass * klass,
                                                                    gpointer klass_data)
{
	desktop_folder_dialogs_panel_properties_settings_header_parent_class = g_type_class_peek_parent (klass);
}

static void
desktop_folder_dialogs_panel_properties_settings_header_instance_init (DesktopFolderDialogsPanelPropertiesSettingsHeader * self,
                                                                       gpointer klass)
{
}

static GType
desktop_folder_dialogs_panel_properties_settings_header_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderDialogsPanelPropertiesSettingsHeaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_dialogs_panel_properties_settings_header_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderDialogsPanelPropertiesSettingsHeader), 0, (GInstanceInitFunc) desktop_folder_dialogs_panel_properties_settings_header_instance_init, NULL };
	GType desktop_folder_dialogs_panel_properties_settings_header_type_id;
	desktop_folder_dialogs_panel_properties_settings_header_type_id = g_type_register_static (gtk_label_get_type (), "DesktopFolderDialogsPanelPropertiesSettingsHeader", &g_define_type_info, 0);
	return desktop_folder_dialogs_panel_properties_settings_header_type_id;
}

static GType
desktop_folder_dialogs_panel_properties_settings_header_get_type (void)
{
	static volatile gsize desktop_folder_dialogs_panel_properties_settings_header_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dialogs_panel_properties_settings_header_type_id__once)) {
		GType desktop_folder_dialogs_panel_properties_settings_header_type_id;
		desktop_folder_dialogs_panel_properties_settings_header_type_id = desktop_folder_dialogs_panel_properties_settings_header_get_type_once ();
		g_once_init_leave (&desktop_folder_dialogs_panel_properties_settings_header_type_id__once, desktop_folder_dialogs_panel_properties_settings_header_type_id);
	}
	return desktop_folder_dialogs_panel_properties_settings_header_type_id__once;
}

static DesktopFolderDialogsPanelPropertiesSettingsLabel*
desktop_folder_dialogs_panel_properties_settings_label_construct (GType object_type,
                                                                  const gchar* text)
{
	DesktopFolderDialogsPanelPropertiesSettingsLabel * self = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	self = (DesktopFolderDialogsPanelPropertiesSettingsLabel*) g_object_new (object_type, NULL);
	gtk_label_set_label ((GtkLabel*) self, text);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_END);
	gtk_widget_set_margin_start ((GtkWidget*) self, 12);
	return self;
}

static DesktopFolderDialogsPanelPropertiesSettingsLabel*
desktop_folder_dialogs_panel_properties_settings_label_new (const gchar* text)
{
	return desktop_folder_dialogs_panel_properties_settings_label_construct (DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_LABEL, text);
}

static void
desktop_folder_dialogs_panel_properties_settings_label_class_init (DesktopFolderDialogsPanelPropertiesSettingsLabelClass * klass,
                                                                   gpointer klass_data)
{
	desktop_folder_dialogs_panel_properties_settings_label_parent_class = g_type_class_peek_parent (klass);
}

static void
desktop_folder_dialogs_panel_properties_settings_label_instance_init (DesktopFolderDialogsPanelPropertiesSettingsLabel * self,
                                                                      gpointer klass)
{
}

static GType
desktop_folder_dialogs_panel_properties_settings_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderDialogsPanelPropertiesSettingsLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_dialogs_panel_properties_settings_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderDialogsPanelPropertiesSettingsLabel), 0, (GInstanceInitFunc) desktop_folder_dialogs_panel_properties_settings_label_instance_init, NULL };
	GType desktop_folder_dialogs_panel_properties_settings_label_type_id;
	desktop_folder_dialogs_panel_properties_settings_label_type_id = g_type_register_static (gtk_label_get_type (), "DesktopFolderDialogsPanelPropertiesSettingsLabel", &g_define_type_info, 0);
	return desktop_folder_dialogs_panel_properties_settings_label_type_id;
}

static GType
desktop_folder_dialogs_panel_properties_settings_label_get_type (void)
{
	static volatile gsize desktop_folder_dialogs_panel_properties_settings_label_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dialogs_panel_properties_settings_label_type_id__once)) {
		GType desktop_folder_dialogs_panel_properties_settings_label_type_id;
		desktop_folder_dialogs_panel_properties_settings_label_type_id = desktop_folder_dialogs_panel_properties_settings_label_get_type_once ();
		g_once_init_leave (&desktop_folder_dialogs_panel_properties_settings_label_type_id__once, desktop_folder_dialogs_panel_properties_settings_label_type_id);
	}
	return desktop_folder_dialogs_panel_properties_settings_label_type_id__once;
}

static DesktopFolderDialogsPanelPropertiesSettingsSwitch*
desktop_folder_dialogs_panel_properties_settings_switch_construct (GType object_type,
                                                                   const gchar* setting)
{
	DesktopFolderDialogsPanelPropertiesSettingsSwitch * self = NULL;
	g_return_val_if_fail (setting != NULL, NULL);
	self = (DesktopFolderDialogsPanelPropertiesSettingsSwitch*) g_object_new (object_type, NULL);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_START);
	return self;
}

static DesktopFolderDialogsPanelPropertiesSettingsSwitch*
desktop_folder_dialogs_panel_properties_settings_switch_new (const gchar* setting)
{
	return desktop_folder_dialogs_panel_properties_settings_switch_construct (DESKTOP_FOLDER_DIALOGS_PANEL_PROPERTIES_TYPE_SETTINGS_SWITCH, setting);
}

static void
desktop_folder_dialogs_panel_properties_settings_switch_class_init (DesktopFolderDialogsPanelPropertiesSettingsSwitchClass * klass,
                                                                    gpointer klass_data)
{
	desktop_folder_dialogs_panel_properties_settings_switch_parent_class = g_type_class_peek_parent (klass);
}

static void
desktop_folder_dialogs_panel_properties_settings_switch_instance_init (DesktopFolderDialogsPanelPropertiesSettingsSwitch * self,
                                                                       gpointer klass)
{
}

static GType
desktop_folder_dialogs_panel_properties_settings_switch_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderDialogsPanelPropertiesSettingsSwitchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_dialogs_panel_properties_settings_switch_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderDialogsPanelPropertiesSettingsSwitch), 0, (GInstanceInitFunc) desktop_folder_dialogs_panel_properties_settings_switch_instance_init, NULL };
	GType desktop_folder_dialogs_panel_properties_settings_switch_type_id;
	desktop_folder_dialogs_panel_properties_settings_switch_type_id = g_type_register_static (gtk_switch_get_type (), "DesktopFolderDialogsPanelPropertiesSettingsSwitch", &g_define_type_info, 0);
	return desktop_folder_dialogs_panel_properties_settings_switch_type_id;
}

static GType
desktop_folder_dialogs_panel_properties_settings_switch_get_type (void)
{
	static volatile gsize desktop_folder_dialogs_panel_properties_settings_switch_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dialogs_panel_properties_settings_switch_type_id__once)) {
		GType desktop_folder_dialogs_panel_properties_settings_switch_type_id;
		desktop_folder_dialogs_panel_properties_settings_switch_type_id = desktop_folder_dialogs_panel_properties_settings_switch_get_type_once ();
		g_once_init_leave (&desktop_folder_dialogs_panel_properties_settings_switch_type_id__once, desktop_folder_dialogs_panel_properties_settings_switch_type_id);
	}
	return desktop_folder_dialogs_panel_properties_settings_switch_type_id__once;
}

static void
desktop_folder_dialogs_panel_properties_class_init (DesktopFolderDialogsPanelPropertiesClass * klass,
                                                    gpointer klass_data)
{
	desktop_folder_dialogs_panel_properties_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DesktopFolderDialogsPanelProperties_private_offset);
	G_OBJECT_CLASS (klass)->finalize = desktop_folder_dialogs_panel_properties_finalize;
}

static void
desktop_folder_dialogs_panel_properties_instance_init (DesktopFolderDialogsPanelProperties * self,
                                                       gpointer klass)
{
	self->priv = desktop_folder_dialogs_panel_properties_get_instance_private (self);
}

static void
desktop_folder_dialogs_panel_properties_finalize (GObject * obj)
{
	DesktopFolderDialogsPanelProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_FOLDER_DIALOGS_TYPE_PANEL_PROPERTIES, DesktopFolderDialogsPanelProperties);
	_g_object_unref0 (self->priv->main_stack);
	_g_object_unref0 (self->priv->window);
	_g_object_unref0 (self->priv->manager);
	_g_object_unref0 (self->priv->properties_grid);
	G_OBJECT_CLASS (desktop_folder_dialogs_panel_properties_parent_class)->finalize (obj);
}

static GType
desktop_folder_dialogs_panel_properties_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderDialogsPanelPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_dialogs_panel_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderDialogsPanelProperties), 0, (GInstanceInitFunc) desktop_folder_dialogs_panel_properties_instance_init, NULL };
	GType desktop_folder_dialogs_panel_properties_type_id;
	desktop_folder_dialogs_panel_properties_type_id = g_type_register_static (gtk_dialog_get_type (), "DesktopFolderDialogsPanelProperties", &g_define_type_info, 0);
	DesktopFolderDialogsPanelProperties_private_offset = g_type_add_instance_private (desktop_folder_dialogs_panel_properties_type_id, sizeof (DesktopFolderDialogsPanelPropertiesPrivate));
	return desktop_folder_dialogs_panel_properties_type_id;
}

GType
desktop_folder_dialogs_panel_properties_get_type (void)
{
	static volatile gsize desktop_folder_dialogs_panel_properties_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dialogs_panel_properties_type_id__once)) {
		GType desktop_folder_dialogs_panel_properties_type_id;
		desktop_folder_dialogs_panel_properties_type_id = desktop_folder_dialogs_panel_properties_get_type_once ();
		g_once_init_leave (&desktop_folder_dialogs_panel_properties_type_id__once, desktop_folder_dialogs_panel_properties_type_id);
	}
	return desktop_folder_dialogs_panel_properties_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

