/* RenameDialog.c generated by valac 0.56.16, the Vala compiler
 * generated from RenameDialog.vala, do not modify */

/*
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define DESKTOP_FOLDER_LANG_DIALOG_OK _ ("_Ok")
#define DESKTOP_FOLDER_LANG_DIALOG_CANCEL _ ("_Cancel")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_RENAME_DIALOG (rename_dialog_get_type ())
#define RENAME_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RENAME_DIALOG, RenameDialog))
#define RENAME_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RENAME_DIALOG, RenameDialogClass))
#define IS_RENAME_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RENAME_DIALOG))
#define IS_RENAME_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RENAME_DIALOG))
#define RENAME_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RENAME_DIALOG, RenameDialogClass))

typedef struct _RenameDialog RenameDialog;
typedef struct _RenameDialogClass RenameDialogClass;
typedef struct _RenameDialogPrivate RenameDialogPrivate;
enum  {
	RENAME_DIALOG_0_PROPERTY,
	RENAME_DIALOG_NUM_PROPERTIES
};
static GParamSpec* rename_dialog_properties[RENAME_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	RENAME_DIALOG_ON_RENAME_SIGNAL,
	RENAME_DIALOG_ON_CANCEL_SIGNAL,
	RENAME_DIALOG_NUM_SIGNALS
};
static guint rename_dialog_signals[RENAME_DIALOG_NUM_SIGNALS] = {0};

struct _RenameDialog {
	GtkDialog parent_instance;
	RenameDialogPrivate * priv;
};

struct _RenameDialogClass {
	GtkDialogClass parent_class;
};

struct _RenameDialogPrivate {
	GtkEntry* entry;
};

static gint RenameDialog_private_offset;
static gpointer rename_dialog_parent_class = NULL;

VALA_EXTERN GType rename_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RenameDialog, g_object_unref)
VALA_EXTERN RenameDialog* rename_dialog_new (GtkWindow* parent,
                                 const gchar* title,
                                 const gchar* label_message,
                                 const gchar* entry_text);
VALA_EXTERN RenameDialog* rename_dialog_construct (GType object_type,
                                       GtkWindow* parent,
                                       const gchar* title,
                                       const gchar* label_message,
                                       const gchar* entry_text);
static void rename_dialog_create_widgets (RenameDialog* self,
                                   const gchar* label_message,
                                   const gchar* entry_text);
static void rename_dialog_connect_signals (RenameDialog* self);
static void __lambda145_ (RenameDialog* self);
static void ___lambda145__gtk_entry_activate (GtkEntry* _sender,
                                       gpointer self);
static void rename_dialog_on_response (RenameDialog* self,
                                GtkDialog* source,
                                gint response_id);
static void _rename_dialog_on_response_gtk_dialog_response (GtkDialog* _sender,
                                                     gint response_id,
                                                     gpointer self);
static void rename_dialog_finalize (GObject * obj);
static GType rename_dialog_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rename_dialog_get_instance_private (RenameDialog* self)
{
	return G_STRUCT_MEMBER_P (self, RenameDialog_private_offset);
}

RenameDialog*
rename_dialog_construct (GType object_type,
                         GtkWindow* parent,
                         const gchar* title,
                         const gchar* label_message,
                         const gchar* entry_text)
{
	RenameDialog * self = NULL;
	GtkStyleContext* _tmp0_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (label_message != NULL, NULL);
	g_return_val_if_fail (entry_text != NULL, NULL);
	self = (RenameDialog*) g_object_new (object_type, NULL);
	if (parent != NULL) {
		gtk_window_set_transient_for ((GtkWindow*) self, parent);
	}
	gtk_window_set_title ((GtkWindow*) self, title);
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 5);
	gtk_window_set_default_size ((GtkWindow*) self, 350, 100);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "df_dialog");
	gtk_window_set_decorated ((GtkWindow*) self, TRUE);
	g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_MOUSE, NULL);
	rename_dialog_create_widgets (self, label_message, entry_text);
	rename_dialog_connect_signals (self);
	return self;
}

RenameDialog*
rename_dialog_new (GtkWindow* parent,
                   const gchar* title,
                   const gchar* label_message,
                   const gchar* entry_text)
{
	return rename_dialog_construct (TYPE_RENAME_DIALOG, parent, title, label_message, entry_text);
}

static void
__lambda145_ (RenameDialog* self)
{
	gtk_dialog_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
}

static void
___lambda145__gtk_entry_activate (GtkEntry* _sender,
                                  gpointer self)
{
	__lambda145_ ((RenameDialog*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
rename_dialog_create_widgets (RenameDialog* self,
                              const gchar* label_message,
                              const gchar* entry_text)
{
	GtkLabel* description = NULL;
	GtkLabel* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp4_;
	GtkEntry* _tmp5_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp6_;
	GtkBox* content = NULL;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label_message != NULL);
	g_return_if_fail (entry_text != NULL);
	_tmp0_ = (GtkLabel*) gtk_label_new (label_message);
	g_object_ref_sink (_tmp0_);
	description = _tmp0_;
	gtk_widget_set_halign ((GtkWidget*) description, GTK_ALIGN_START);
	_tmp1_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->entry);
	self->priv->entry = _tmp1_;
	_tmp2_ = self->priv->entry;
	g_signal_connect_object (_tmp2_, "activate", (GCallback) ___lambda145__gtk_entry_activate, self, 0);
	_tmp3_ = self->priv->entry;
	gtk_entry_set_text (_tmp3_, entry_text);
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
	g_object_ref_sink (_tmp4_);
	hbox = _tmp4_;
	gtk_box_pack_start (hbox, (GtkWidget*) description, FALSE, TRUE, (guint) 0);
	_tmp5_ = self->priv->entry;
	gtk_box_pack_start (hbox, (GtkWidget*) _tmp5_, TRUE, TRUE, (guint) 0);
	_tmp6_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp6_);
	grid = _tmp6_;
	g_object_set ((GtkWidget*) grid, "margin", 10, NULL);
	gtk_grid_attach (grid, (GtkWidget*) hbox, 0, 0, 1, 1);
	_tmp7_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_box_get_type ()) ? ((GtkBox*) _tmp7_) : NULL);
	content = _tmp8_;
	gtk_box_pack_start (content, (GtkWidget*) grid, FALSE, TRUE, (guint) 0);
	gtk_box_set_spacing (content, 10);
	gtk_dialog_add_button ((GtkDialog*) self, DESKTOP_FOLDER_LANG_DIALOG_OK, (gint) GTK_RESPONSE_OK);
	gtk_dialog_add_button ((GtkDialog*) self, DESKTOP_FOLDER_LANG_DIALOG_CANCEL, (gint) GTK_RESPONSE_CANCEL);
	_g_object_unref0 (content);
	_g_object_unref0 (grid);
	_g_object_unref0 (hbox);
	_g_object_unref0 (description);
}

static void
_rename_dialog_on_response_gtk_dialog_response (GtkDialog* _sender,
                                                gint response_id,
                                                gpointer self)
{
	rename_dialog_on_response ((RenameDialog*) self, _sender, response_id);
}

static void
rename_dialog_connect_signals (RenameDialog* self)
{
	g_return_if_fail (self != NULL);
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) _rename_dialog_on_response_gtk_dialog_response, self, 0);
}

static void
rename_dialog_on_response (RenameDialog* self,
                           GtkDialog* source,
                           gint response_id)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	switch (response_id) {
		case GTK_RESPONSE_OK:
		{
			GtkEntry* _tmp0_;
			const gchar* _tmp1_;
			_tmp0_ = self->priv->entry;
			_tmp1_ = gtk_entry_get_text (_tmp0_);
			g_signal_emit (self, rename_dialog_signals[RENAME_DIALOG_ON_RENAME_SIGNAL], 0, _tmp1_);
			gtk_widget_destroy ((GtkWidget*) self);
			break;
		}
		case GTK_RESPONSE_CANCEL:
		{
			g_signal_emit (self, rename_dialog_signals[RENAME_DIALOG_ON_CANCEL_SIGNAL], 0);
			gtk_widget_destroy ((GtkWidget*) self);
			break;
		}
		default:
		break;
	}
}

static void
rename_dialog_class_init (RenameDialogClass * klass,
                          gpointer klass_data)
{
	rename_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &RenameDialog_private_offset);
	G_OBJECT_CLASS (klass)->finalize = rename_dialog_finalize;
	rename_dialog_signals[RENAME_DIALOG_ON_RENAME_SIGNAL] = g_signal_new ("on-rename", TYPE_RENAME_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	rename_dialog_signals[RENAME_DIALOG_ON_CANCEL_SIGNAL] = g_signal_new ("on-cancel", TYPE_RENAME_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
rename_dialog_instance_init (RenameDialog * self,
                             gpointer klass)
{
	self->priv = rename_dialog_get_instance_private (self);
}

static void
rename_dialog_finalize (GObject * obj)
{
	RenameDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RENAME_DIALOG, RenameDialog);
	_g_object_unref0 (self->priv->entry);
	G_OBJECT_CLASS (rename_dialog_parent_class)->finalize (obj);
}

static GType
rename_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RenameDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rename_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RenameDialog), 0, (GInstanceInitFunc) rename_dialog_instance_init, NULL };
	GType rename_dialog_type_id;
	rename_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "RenameDialog", &g_define_type_info, 0);
	RenameDialog_private_offset = g_type_add_instance_private (rename_dialog_type_id, sizeof (RenameDialogPrivate));
	return rename_dialog_type_id;
}

GType
rename_dialog_get_type (void)
{
	static volatile gsize rename_dialog_type_id__once = 0;
	if (g_once_init_enter (&rename_dialog_type_id__once)) {
		GType rename_dialog_type_id;
		rename_dialog_type_id = rename_dialog_get_type_once ();
		g_once_init_leave (&rename_dialog_type_id__once, rename_dialog_type_id);
	}
	return rename_dialog_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

