/* Fx.c generated by valac 0.56.16, the Vala compiler
 * generated from Fx.vala, do not modify */

/*
 * Copyright (C) 2015 Rico Tzschichholz
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
     * Utility functions to calculate progress of transitions.
     * Ported from Plank: https://github.com/ricotz/plank/blob/master/lib/Drawing/Easing.vala
     */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM = 0,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST
} DesktopFolderUtilFxAnimationMode;

#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE (desktop_folder_util_fx_animation_mode_get_type ())
typedef gdouble (*DesktopFolderUtilFxEasingFunc) (gdouble t, gdouble d);

#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE_MAPPING (desktop_folder_util_fx_animation_mode_mapping_get_type ())
typedef struct _DesktopFolderUtilFxAnimationModeMapping DesktopFolderUtilFxAnimationModeMapping;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DesktopFolderUtilFxAnimationModeMapping {
	DesktopFolderUtilFxAnimationMode mode;
	DesktopFolderUtilFxEasingFunc func;
	gchar* name;
};

VALA_EXTERN GType desktop_folder_util_fx_animation_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType desktop_folder_util_fx_animation_mode_mapping_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DesktopFolderUtilFxAnimationModeMapping* desktop_folder_util_fx_animation_mode_mapping_dup (const DesktopFolderUtilFxAnimationModeMapping* self);
VALA_EXTERN void desktop_folder_util_fx_animation_mode_mapping_free (DesktopFolderUtilFxAnimationModeMapping* self);
VALA_EXTERN void desktop_folder_util_fx_animation_mode_mapping_copy (const DesktopFolderUtilFxAnimationModeMapping* self,
                                                         DesktopFolderUtilFxAnimationModeMapping* dest);
VALA_EXTERN void desktop_folder_util_fx_animation_mode_mapping_destroy (DesktopFolderUtilFxAnimationModeMapping* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DesktopFolderUtilFxAnimationModeMapping, desktop_folder_util_fx_animation_mode_mapping_destroy)
VALA_EXTERN gdouble desktop_folder_util_fx_linear (gdouble t,
                                       gdouble d);
static gdouble _desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_quad (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_quad (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_quad (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_cubic (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_cubic (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_cubic (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_quart (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_quart (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_quart (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_quint (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_quint (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_quint (gdouble t,
                                                  gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                      gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_sine (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_sine (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_sine (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_expo (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_expo (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_expo (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_circ (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_circ (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_circ (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_elastic (gdouble t,
                                                gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                    gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_elastic (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_elastic (gdouble t,
                                                    gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                        gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_back (gdouble t,
                                             gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                 gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_back (gdouble t,
                                              gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                  gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_back (gdouble t,
                                                 gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                     gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_bounce (gdouble t,
                                               gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                   gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_bounce (gdouble t,
                                                gdouble d);
static gdouble _desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                    gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_out_bounce (gdouble t,
                                                   gdouble d);
static gdouble _desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                       gdouble d);
VALA_EXTERN DesktopFolderUtilFxEasingFunc desktop_folder_util_fx_easing_func_for_mode (DesktopFolderUtilFxAnimationMode mode);
VALA_EXTERN const gchar* desktop_folder_util_fx_easing_name_for_mode (DesktopFolderUtilFxAnimationMode mode);
VALA_EXTERN gdouble desktop_folder_util_fx_easing_for_mode (DesktopFolderUtilFxAnimationMode mode,
                                                gdouble t,
                                                gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_out_bounce_internal (gdouble t,
                                                         gdouble d);
VALA_EXTERN gdouble desktop_folder_util_fx_ease_in_bounce_internal (gdouble t,
                                                        gdouble d);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const DesktopFolderUtilFxAnimationModeMapping DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[33] = {{DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM, NULL, "custom"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR, _desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func, "linear"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD, _desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func, "easeInQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD, _desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func, "easeOutQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD, _desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func, "easeInOutQuad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC, _desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func, "easeInCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC, _desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func, "easeOutCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC, _desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func, "easeInOutCubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART, _desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func, "easeInQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART, _desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func, "easeOutQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART, _desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func, "easeInOutQuart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT, _desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func, "easeInQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT, _desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func, "easeOutQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT, _desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func, "easeInOutQuint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE, _desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func, "easeInSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE, _desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func, "easeOutSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE, _desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func, "easeInOutSine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO, _desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func, "easeInExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO, _desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func, "easeOutExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO, _desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func, "easeInOutExpo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC, _desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func, "easeInCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC, _desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func, "easeOutCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC, _desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func, "easeInOutCirc"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC, _desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func, "easeInElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC, _desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func, "easeOutElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, _desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func, "easeInOutElastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK, _desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func, "easeInBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK, _desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func, "easeOutBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK, _desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func, "easeInOutBack"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE, _desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func, "easeInBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE, _desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func, "easeOutBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, _desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func, "easeInOutBounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST, NULL, "sentinel"}};

/**
     * The available animation modes
     */
static GType
desktop_folder_util_fx_animation_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM", "custom"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR", "linear"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD", "ease-in-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD", "ease-out-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD", "ease-in-out-quad"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC", "ease-in-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC", "ease-out-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC", "ease-in-out-cubic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART", "ease-in-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART", "ease-out-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART", "ease-in-out-quart"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT", "ease-in-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT", "ease-out-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT", "ease-in-out-quint"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE", "ease-in-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE", "ease-out-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE", "ease-in-out-sine"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO", "ease-in-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO", "ease-out-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO", "ease-in-out-expo"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC", "ease-in-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC", "ease-out-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC", "ease-in-out-circ"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC", "ease-in-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC", "ease-out-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC", "ease-in-out-elastic"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK", "ease-in-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK", "ease-out-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK", "ease-in-out-back"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE", "ease-in-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE", "ease-out-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE", "ease-in-out-bounce"}, {DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST, "DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST", "last"}, {0, NULL, NULL}};
	GType desktop_folder_util_fx_animation_mode_type_id;
	desktop_folder_util_fx_animation_mode_type_id = g_enum_register_static ("DesktopFolderUtilFxAnimationMode", values);
	return desktop_folder_util_fx_animation_mode_type_id;
}

GType
desktop_folder_util_fx_animation_mode_get_type (void)
{
	static volatile gsize desktop_folder_util_fx_animation_mode_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_util_fx_animation_mode_type_id__once)) {
		GType desktop_folder_util_fx_animation_mode_type_id;
		desktop_folder_util_fx_animation_mode_type_id = desktop_folder_util_fx_animation_mode_get_type_once ();
		g_once_init_leave (&desktop_folder_util_fx_animation_mode_type_id__once, desktop_folder_util_fx_animation_mode_type_id);
	}
	return desktop_folder_util_fx_animation_mode_type_id__once;
}

void
desktop_folder_util_fx_animation_mode_mapping_copy (const DesktopFolderUtilFxAnimationModeMapping* self,
                                                    DesktopFolderUtilFxAnimationModeMapping* dest)
{
	DesktopFolderUtilFxEasingFunc _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	(*dest).mode = (*self).mode;
	_tmp0_ = (*self).func;
	(*dest).func = _tmp0_;
	_tmp1_ = (*self).name;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp2_;
}

void
desktop_folder_util_fx_animation_mode_mapping_destroy (DesktopFolderUtilFxAnimationModeMapping* self)
{
	_g_free0 ((*self).name);
}

DesktopFolderUtilFxAnimationModeMapping*
desktop_folder_util_fx_animation_mode_mapping_dup (const DesktopFolderUtilFxAnimationModeMapping* self)
{
	DesktopFolderUtilFxAnimationModeMapping* dup;
	dup = g_new0 (DesktopFolderUtilFxAnimationModeMapping, 1);
	desktop_folder_util_fx_animation_mode_mapping_copy (self, dup);
	return dup;
}

void
desktop_folder_util_fx_animation_mode_mapping_free (DesktopFolderUtilFxAnimationModeMapping* self)
{
	desktop_folder_util_fx_animation_mode_mapping_destroy (self);
	g_free (self);
}

static GType
desktop_folder_util_fx_animation_mode_mapping_get_type_once (void)
{
	GType desktop_folder_util_fx_animation_mode_mapping_type_id;
	desktop_folder_util_fx_animation_mode_mapping_type_id = g_boxed_type_register_static ("DesktopFolderUtilFxAnimationModeMapping", (GBoxedCopyFunc) desktop_folder_util_fx_animation_mode_mapping_dup, (GBoxedFreeFunc) desktop_folder_util_fx_animation_mode_mapping_free);
	return desktop_folder_util_fx_animation_mode_mapping_type_id;
}

GType
desktop_folder_util_fx_animation_mode_mapping_get_type (void)
{
	static volatile gsize desktop_folder_util_fx_animation_mode_mapping_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_util_fx_animation_mode_mapping_type_id__once)) {
		GType desktop_folder_util_fx_animation_mode_mapping_type_id;
		desktop_folder_util_fx_animation_mode_mapping_type_id = desktop_folder_util_fx_animation_mode_mapping_get_type_once ();
		g_once_init_leave (&desktop_folder_util_fx_animation_mode_mapping_type_id__once, desktop_folder_util_fx_animation_mode_mapping_type_id);
	}
	return desktop_folder_util_fx_animation_mode_mapping_type_id__once;
}

static gdouble
_desktop_folder_util_fx_linear_desktop_folder_util_fx_easing_func (gdouble t,
                                                                   gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_linear (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quad (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quad (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_quad_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quad (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_cubic (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_cubic (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_cubic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_cubic (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quart (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quart (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_quart_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quart (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_quint (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_quint (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_quint_desktop_folder_util_fx_easing_func (gdouble t,
                                                                              gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_quint (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_sine (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_sine (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_sine_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_sine (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_expo (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_expo (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_expo_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_expo (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_circ (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_circ (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_circ_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_circ (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                            gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_elastic (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_elastic (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_elastic_desktop_folder_util_fx_easing_func (gdouble t,
                                                                                gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_elastic (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                         gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_back (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                          gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_back (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_back_desktop_folder_util_fx_easing_func (gdouble t,
                                                                             gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_back (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                           gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_bounce (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                            gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_bounce (t, d);
	return result;
}

static gdouble
_desktop_folder_util_fx_ease_in_out_bounce_desktop_folder_util_fx_easing_func (gdouble t,
                                                                               gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_out_bounce (t, d);
	return result;
}

DesktopFolderUtilFxEasingFunc
desktop_folder_util_fx_easing_func_for_mode (DesktopFolderUtilFxAnimationMode mode)
{
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxEasingFunc _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	DesktopFolderUtilFxEasingFunc result;
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
	_tmp0_ = (*animation).func;
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
	_tmp1_ = (*animation).func;
	result = _tmp1_;
	return result;
}

const gchar*
desktop_folder_util_fx_easing_name_for_mode (DesktopFolderUtilFxAnimationMode mode)
{
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxEasingFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* result;
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
	_tmp0_ = (*animation).func;
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
	_tmp1_ = (*animation).name;
	result = _tmp1_;
	return result;
}

/**
     * Calculate an interpolated value for selected animation-mode, and given
     * elapsed time and total duration.
     *
     * @param mode animation-mode to be used
     * @param t elapsed time
     * @param d total duration
     * @return the interpolated value, between -1.0 and 2.0
     */
gdouble
desktop_folder_util_fx_easing_for_mode (DesktopFolderUtilFxAnimationMode mode,
                                        gdouble t,
                                        gdouble d)
{
	DesktopFolderUtilFxAnimationModeMapping* animation = NULL;
	DesktopFolderUtilFxEasingFunc _tmp0_;
	DesktopFolderUtilFxEasingFunc _tmp1_;
	gdouble result;
	_vala_return_val_if_fail ((t >= 0.0) && (d > 0.0), "t >= 0.0 && d > 0.0", 0.0);
	_vala_return_val_if_fail (t <= d, "t <= d", 0.0);
	animation = &DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODES[mode];
	_vala_assert ((*animation).mode == mode, "animation.mode == mode");
	_tmp0_ = (*animation).func;
	_vala_assert (_tmp0_ != NULL, "animation.func != null");
	_tmp1_ = (*animation).func;
	result = _tmp1_ (t, d);
	_vala_warn_if_fail ((result >= (-1.0)) && (result <= 2.0), "result >= -1.0 && result <= 2.0");
	return result;
}

gdouble
desktop_folder_util_fx_linear (gdouble t,
                               gdouble d)
{
	gdouble result;
	result = t / d;
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_quad (gdouble t,
                                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	result = p * p;
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_quad (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	result = ((-1.0) * p) * (p - 2);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_quad (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / (d / 2);
	if (p < ((gdouble) 1)) {
		result = (0.5 * p) * p;
		return result;
	}
	p -= (gdouble) 1;
	result = (-0.5) * ((p * (p - 2)) - 1);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_cubic (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	result = (p * p) * p;
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_cubic (gdouble t,
                                       gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = (t / d) - 1;
	result = ((p * p) * p) + 1;
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_cubic (gdouble t,
                                          gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / (d / 2);
	if (p < ((gdouble) 1)) {
		result = ((0.5 * p) * p) * p;
		return result;
	}
	p -= (gdouble) 2;
	result = 0.5 * (((p * p) * p) + 2);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_quart (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	result = ((p * p) * p) * p;
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_quart (gdouble t,
                                       gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = (t / d) - 1;
	result = (-1.0) * ((((p * p) * p) * p) - 1);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_quart (gdouble t,
                                          gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / (d / 2);
	if (p < ((gdouble) 1)) {
		result = (((0.5 * p) * p) * p) * p;
		return result;
	}
	p -= (gdouble) 2;
	result = (-0.5) * ((((p * p) * p) * p) - 2);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_quint (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	result = (((p * p) * p) * p) * p;
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_quint (gdouble t,
                                       gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = (t / d) - 1;
	result = ((((p * p) * p) * p) * p) + 1;
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_quint (gdouble t,
                                          gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / (d / 2);
	if (p < ((gdouble) 1)) {
		result = ((((0.5 * p) * p) * p) * p) * p;
		return result;
	}
	p -= (gdouble) 2;
	result = 0.5 * (((((p * p) * p) * p) * p) + 2);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_sine (gdouble t,
                                     gdouble d)
{
	gdouble result;
	result = ((-1.0) * cos ((t / d) * G_PI_2)) + 1.0;
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_sine (gdouble t,
                                      gdouble d)
{
	gdouble result;
	result = sin ((t / d) * G_PI_2);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_sine (gdouble t,
                                         gdouble d)
{
	gdouble result;
	result = (-0.5) * (cos ((G_PI * t) / d) - 1);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_expo (gdouble t,
                                     gdouble d)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
	if (t == ((gdouble) 0)) {
		_tmp0_ = 0.0;
	} else {
		_tmp0_ = pow ((gdouble) 2, 10 * ((t / d) - 1));
	}
	result = _tmp0_;
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_expo (gdouble t,
                                      gdouble d)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
	if (t == d) {
		_tmp0_ = 1.0;
	} else {
		_tmp0_ = (-pow ((gdouble) 2, (-10 * t) / d)) + 1;
	}
	result = _tmp0_;
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_expo (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	if (t == ((gdouble) 0)) {
		result = 0.0;
		return result;
	}
	if (t == d) {
		result = 1.0;
		return result;
	}
	p = t / (d / 2);
	if (p < ((gdouble) 1)) {
		result = 0.5 * pow ((gdouble) 2, 10 * (p - 1));
		return result;
	}
	p -= (gdouble) 1;
	result = 0.5 * ((-pow ((gdouble) 2, -10 * p)) + 2);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_circ (gdouble t,
                                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	result = (-1.0) * (sqrt (1 - (p * p)) - 1);
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_circ (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = (t / d) - 1;
	result = sqrt (1 - (p * p));
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_circ (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / (d / 2);
	if (p < ((gdouble) 1)) {
		result = (-0.5) * (sqrt (1 - (p * p)) - 1);
		return result;
	}
	p -= (gdouble) 2;
	result = 0.5 * (sqrt (1 - (p * p)) + 1);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_elastic (gdouble t,
                                        gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
	p = d * 0.3;
	s = p / 4;
	q = t / d;
	if (q == ((gdouble) 1)) {
		result = 1.0;
		return result;
	}
	q -= (gdouble) 1;
	result = -(pow ((gdouble) 2, 10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p));
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_elastic (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
	p = d * 0.3;
	s = p / 4;
	q = t / d;
	if (q == ((gdouble) 1)) {
		result = 1.0;
		return result;
	}
	result = (pow ((gdouble) 2, -10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p)) + 1.0;
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_elastic (gdouble t,
                                            gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble q = 0.0;
	gdouble result;
	p = d * (0.3 * 1.5);
	s = p / 4;
	q = t / (d / 2);
	if (q == ((gdouble) 2)) {
		result = 1.0;
		return result;
	}
	if (q < ((gdouble) 1)) {
		q -= (gdouble) 1;
		result = (-0.5) * (pow ((gdouble) 2, 10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p));
		return result;
	} else {
		q -= (gdouble) 1;
		result = ((pow ((gdouble) 2, -10 * q) * sin ((((q * d) - s) * (2 * G_PI)) / p)) * 0.5) + 1.0;
		return result;
	}
}

gdouble
desktop_folder_util_fx_ease_in_back (gdouble t,
                                     gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	result = (p * p) * (((1.70158 + 1) * p) - 1.70158);
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_back (gdouble t,
                                      gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = (t / d) - 1;
	result = ((p * p) * (((1.70158 + 1) * p) + 1.70158)) + 1;
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_back (gdouble t,
                                         gdouble d)
{
	gdouble p = 0.0;
	gdouble s = 0.0;
	gdouble result;
	p = t / (d / 2);
	s = 1.70158 * 1.525;
	if (p < ((gdouble) 1)) {
		result = 0.5 * ((p * p) * (((s + 1) * p) - s));
		return result;
	}
	p -= (gdouble) 2;
	result = 0.5 * (((p * p) * (((s + 1) * p) + s)) + 2);
	return result;
}

inline gdouble
desktop_folder_util_fx_ease_out_bounce_internal (gdouble t,
                                                 gdouble d)
{
	gdouble p = 0.0;
	gdouble result;
	p = t / d;
	if (p < (1 / 2.75)) {
		result = (7.5625 * p) * p;
		return result;
	} else {
		if (p < (2 / 2.75)) {
			p -= 1.5 / 2.75;
			result = ((7.5625 * p) * p) + 0.75;
			return result;
		} else {
			if (p < (2.5 / 2.75)) {
				p -= 2.25 / 2.75;
				result = ((7.5625 * p) * p) + 0.9375;
				return result;
			} else {
				p -= 2.625 / 2.75;
				result = ((7.5625 * p) * p) + 0.984375;
				return result;
			}
		}
	}
}

inline gdouble
desktop_folder_util_fx_ease_in_bounce_internal (gdouble t,
                                                gdouble d)
{
	gdouble result;
	result = 1.0 - desktop_folder_util_fx_ease_out_bounce_internal (d - t, d);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_bounce (gdouble t,
                                       gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_in_bounce_internal (t, d);
	return result;
}

gdouble
desktop_folder_util_fx_ease_out_bounce (gdouble t,
                                        gdouble d)
{
	gdouble result;
	result = desktop_folder_util_fx_ease_out_bounce_internal (t, d);
	return result;
}

gdouble
desktop_folder_util_fx_ease_in_out_bounce (gdouble t,
                                           gdouble d)
{
	gdouble result;
	if (t < (d / 2)) {
		result = desktop_folder_util_fx_ease_in_bounce_internal (t * 2, d) * 0.5;
		return result;
	} else {
		result = (desktop_folder_util_fx_ease_out_bounce_internal ((t * 2) - d, d) * 0.5) + (1.0 * 0.5);
		return result;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

