/* DragNDrop.c generated by valac 0.56.16, the Vala compiler
 * generated from DragNDrop.vala, do not modify */

/*
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#define DESKTOP_FOLDER_DRAGN_DROP_file_drag_actions ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
#define DESKTOP_FOLDER_LANG_DRAGNDROP_FILE_OPERATIONS _ ("File Operations")
#define DESKTOP_FOLDER_LANG_DRAGNDROP_COPYING _ ("Copying")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL
} DesktopFolderDragnDropTargetType;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_TARGET_TYPE (desktop_folder_dragn_drop_target_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block5Data Block5Data;

#define DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG (desktop_folder_progress_dialog_get_type ())
#define DESKTOP_FOLDER_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialog))
#define DESKTOP_FOLDER_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialogClass))
#define DESKTOP_FOLDER_IS_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG))
#define DESKTOP_FOLDER_IS_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG))
#define DESKTOP_FOLDER_PROGRESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_PROGRESS_DIALOG, DesktopFolderProgressDialogClass))

typedef struct _DesktopFolderProgressDialog DesktopFolderProgressDialog;
typedef struct _DesktopFolderProgressDialogClass DesktopFolderProgressDialogClass;
typedef struct _Block6Data Block6Data;
typedef void (*DesktopFolderUtilFileOperationAction) (GFile* file, gpointer user_data);
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _Block5Data {
	int _ref_count_;
	GFile* f;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	GFile* final_target;
	DesktopFolderProgressDialog* pd;
	GCancellable* cancellable;
};

VALA_EXTERN GType desktop_folder_dragn_drop_target_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean desktop_folder_dragn_drop_util_is_folder (GFile* file);
VALA_EXTERN gboolean desktop_folder_dragn_drop_util_is_trashed (GFile* file);
VALA_EXTERN gchar* desktop_folder_dragn_drop_util_get_display_target_uri (GFile* file);
VALA_EXTERN gboolean desktop_folder_dragn_drop_util_same_filesystem (GFile* file_a,
                                                         GFile* file_b);
VALA_EXTERN GdkDragAction desktop_folder_dragn_drop_util_file_accepts_drop (GFile* file,
                                                                GList* file_list,
                                                                GdkDragContext* context,
                                                                GdkDragAction* suggested_action_return);
VALA_EXTERN GList* desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str);
VALA_EXTERN void desktop_folder_dragn_drop_util_copy_move (GList* files,
                                               GFile* target_dir,
                                               GdkDragAction action,
                                               GtkWidget* parent_view,
                                               GCallback done_callback,
                                               GtkWidget* done_callback_data);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN GType desktop_folder_progress_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderProgressDialog, g_object_unref)
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN DesktopFolderProgressDialog* desktop_folder_progress_dialog_new (const gchar* title,
                                                                 GtkWindow* parent);
VALA_EXTERN DesktopFolderProgressDialog* desktop_folder_progress_dialog_construct (GType object_type,
                                                                       const gchar* title,
                                                                       GtkWindow* parent);
VALA_EXTERN GCancellable* desktop_folder_progress_dialog_start (DesktopFolderProgressDialog* self);
static gint _________lambda17_ (Block6Data* _data6_);
VALA_EXTERN gboolean desktop_folder_util_copy_recursive (GFile* src,
                                             GFile* dest,
                                             GFileCopyFlags flags,
                                             GCancellable* cancellable,
                                             DesktopFolderUtilFileOperationAction listener,
                                             gpointer listener_target,
                                             GError** error);
static void ___lambda18_ (Block6Data* _data6_,
                   GFile* file);
VALA_EXTERN void desktop_folder_progress_dialog_show_action (DesktopFolderProgressDialog* self,
                                                 const gchar* action);
static void ____lambda18__desktop_folder_util_file_operation_action (GFile* file,
                                                              gpointer self);
VALA_EXTERN void desktop_folder_progress_dialog_stop (DesktopFolderProgressDialog* self);
static gpointer __________lambda17__gthread_func (gpointer self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drag_targets[2] = {{"text/plain", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING}, {"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}};
const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drop_targets[4] = {{"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}, {"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST}, {"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0}, {"_NETSCAPE_URL", (guint) GTK_TARGET_OTHER_APP, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL}};

static GType
desktop_folder_dragn_drop_target_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING", "string"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST", "text-uri-list"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0", "xdnd-direct-save0"}, {DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL, "DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL", "netscape-url"}, {0, NULL, NULL}};
	GType desktop_folder_dragn_drop_target_type_type_id;
	desktop_folder_dragn_drop_target_type_type_id = g_enum_register_static ("DesktopFolderDragnDropTargetType", values);
	return desktop_folder_dragn_drop_target_type_type_id;
}

GType
desktop_folder_dragn_drop_target_type_get_type (void)
{
	static volatile gsize desktop_folder_dragn_drop_target_type_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_dragn_drop_target_type_type_id__once)) {
		GType desktop_folder_dragn_drop_target_type_type_id;
		desktop_folder_dragn_drop_target_type_type_id = desktop_folder_dragn_drop_target_type_get_type_once ();
		g_once_init_leave (&desktop_folder_dragn_drop_target_type_type_id__once, desktop_folder_dragn_drop_target_type_type_id);
	}
	return desktop_folder_dragn_drop_target_type_type_id__once;
}

/**
         * @name is_folder
         * @description check if a certain file is a folder or not
         * @param File file the file to check
         * @return boole true->yes, the file is a folder
         */
gboolean
desktop_folder_dragn_drop_util_is_folder (GFile* file)
{
	GFileType type = 0;
	gboolean result;
	g_return_val_if_fail (file != NULL, FALSE);
	type = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
	result = type == G_FILE_TYPE_DIRECTORY;
	return result;
}

/**
         * @name is_tarshed
         * @description check whether the file is in trash or not
         * @return bool true->yes, it is in trash
         */
gboolean
desktop_folder_dragn_drop_util_is_trashed (GFile* file)
{
	gboolean result;
	g_return_val_if_fail (file != NULL, FALSE);
	result = g_file_has_uri_scheme (file, "trash");
	return result;
}

gchar*
desktop_folder_dragn_drop_util_get_display_target_uri (GFile* file)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GFileInfo* fileInfo = NULL;
		GFileInfo* _tmp0_;
		gchar* uri = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
		fileInfo = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp1_ = g_file_info_get_attribute_as_string (fileInfo, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI);
		uri = _tmp1_;
		_tmp2_ = uri;
		if (_tmp2_ == NULL) {
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp3_ = g_file_get_uri (file);
			_tmp4_ = _tmp3_;
			_tmp5_ = g_strconcat ("", _tmp4_, NULL);
			_g_free0 (uri);
			uri = _tmp5_;
			_g_free0 (_tmp4_);
		}
		result = uri;
		_g_object_unref0 (fileInfo);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = stderr;
		_tmp7_ = _error_;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
		_tmp9_ = g_strdup ("");
		result = _tmp9_;
		_g_error_free0 (_error_);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gboolean
desktop_folder_dragn_drop_util_same_filesystem (GFile* file_a,
                                                GFile* file_b)
{
	gchar* filesystem_id_a = NULL;
	gchar* filesystem_id_b = NULL;
	GFileInfo* ainfo = NULL;
	GFileInfo* binfo = NULL;
	gboolean _tmp10_ = FALSE;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GFileInfo* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (file_a != NULL, FALSE);
	g_return_val_if_fail (file_b != NULL, FALSE);
	ainfo = NULL;
	binfo = NULL;
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp1_ = g_file_query_filesystem_info (file_a, "*", NULL, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (ainfo);
		ainfo = _tmp2_;
		_tmp4_ = g_file_query_filesystem_info (file_b, "*", NULL, &_inner_error0_);
		_tmp3_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp5_ = _tmp3_;
		_tmp3_ = NULL;
		_g_object_unref0 (binfo);
		binfo = _tmp5_;
		_g_object_unref0 (_tmp3_);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = stderr;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp9_ = FALSE;
		_g_object_unref0 (binfo);
		_g_object_unref0 (ainfo);
		_g_free0 (filesystem_id_b);
		_g_free0 (filesystem_id_a);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp9_;
	}
	_tmp11_ = ainfo;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		GFileInfo* _tmp12_;
		_tmp12_ = binfo;
		_tmp10_ = _tmp12_ == NULL;
	}
	if (_tmp10_) {
		result = FALSE;
		_g_object_unref0 (binfo);
		_g_object_unref0 (ainfo);
		_g_free0 (filesystem_id_b);
		_g_free0 (filesystem_id_a);
		return result;
	}
	_tmp13_ = ainfo;
	_tmp14_ = g_file_info_get_attribute_string (_tmp13_, G_FILE_ATTRIBUTE_ID_FILESYSTEM);
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 (filesystem_id_a);
	filesystem_id_a = _tmp15_;
	_tmp16_ = binfo;
	_tmp17_ = g_file_info_get_attribute_string (_tmp16_, G_FILE_ATTRIBUTE_ID_FILESYSTEM);
	_tmp18_ = g_strdup (_tmp17_);
	_g_free0 (filesystem_id_b);
	filesystem_id_b = _tmp18_;
	_tmp19_ = filesystem_id_a;
	_tmp20_ = filesystem_id_b;
	result = g_strcmp0 (_tmp19_, _tmp20_) == 0;
	_g_object_unref0 (binfo);
	_g_object_unref0 (ainfo);
	_g_free0 (filesystem_id_b);
	_g_free0 (filesystem_id_a);
	return result;
}

/**
         * gof_file_accepts_drop (imported from thunar):
         * @file                    : a #GOFFile instance.
         * @file_list               : the list of #GFile<!---->s that will be droppped.
         * @context                 : the current #GdkDragContext, which is used for the drop.
         * @suggested_action_return : return location for the suggested #GdkDragAction or %NULL.
         *
         * Checks whether @file can accept @path_list for the given @context and
         * returns the #GdkDragAction<!---->s that can be used or 0 if no actions
         * apply.
         *
         * If any #GdkDragAction<!---->s apply and @suggested_action_return is not
         * %NULL, the suggested #GdkDragAction for this drop will be stored to the
         * location pointed to by @suggested_action_return.
         *
         * Return value: the #GdkDragAction<!---->s supported for the drop or
         *               0 if no drop is possible.
         **/
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GdkDragAction
desktop_folder_dragn_drop_util_file_accepts_drop (GFile* file,
                                                  GList* file_list,
                                                  GdkDragContext* context,
                                                  GdkDragAction* suggested_action_return)
{
	GdkDragAction _vala_suggested_action_return = 0U;
	GdkDragAction suggested_action = 0U;
	GdkDragAction actions = 0U;
	GFile* ofile = NULL;
	GFile* parent_file = NULL;
	guint n = 0U;
	gint i = 0;
	gchar* scheme = NULL;
	gchar* _tmp42_;
	const gchar* _tmp43_;
	GError* _inner_error0_ = NULL;
	GdkDragAction result;
	g_return_val_if_fail (file != NULL, 0U);
	g_return_val_if_fail (context != NULL, 0U);
	i = 0;
	_vala_suggested_action_return = GDK_ACTION_PRIVATE;
	if (file_list == NULL) {
		result = 0;
		_g_object_unref0 (parent_file);
		_g_object_unref0 (ofile);
		if (suggested_action_return) {
			*suggested_action_return = _vala_suggested_action_return;
		}
		return result;
	}
	suggested_action = gdk_drag_context_get_suggested_action (context);
	if (desktop_folder_dragn_drop_util_is_folder (file)) {
		gboolean _tmp19_ = FALSE;
		actions = gdk_drag_context_get_actions (context) & (((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK) | GDK_ACTION_ASK);
		{
			gboolean _tmp0_ = FALSE;
			n = (guint) 0;
			i = 0;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_ = FALSE;
				GFile* fi = NULL;
				GList* _tmp4_;
				gconstpointer _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				gchar* scheme = NULL;
				GFile* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GFile* _tmp18_;
				if (!_tmp0_) {
					gint _tmp1_;
					guint _tmp2_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
					_tmp2_ = n;
					n = _tmp2_ + 1;
				}
				_tmp0_ = FALSE;
				if (((guint) i) < g_list_length (file_list)) {
					_tmp3_ = n < ((guint) 100);
				} else {
					_tmp3_ = FALSE;
				}
				if (!_tmp3_) {
					break;
				}
				_tmp4_ = g_list_nth (file_list, (guint) i);
				_tmp5_ = _tmp4_->data;
				_tmp6_ = _g_object_ref0 ((GFile*) _tmp5_);
				fi = _tmp6_;
				_tmp7_ = fi;
				if (g_file_equal (file, _tmp7_)) {
					result = 0;
					_g_object_unref0 (fi);
					_g_object_unref0 (parent_file);
					_g_object_unref0 (ofile);
					if (suggested_action_return) {
						*suggested_action_return = _vala_suggested_action_return;
					}
					return result;
				}
				_tmp8_ = fi;
				_tmp9_ = g_file_get_parent (_tmp8_);
				_g_object_unref0 (parent_file);
				parent_file = _tmp9_;
				_tmp10_ = parent_file;
				if (_tmp10_ != NULL) {
					GFile* _tmp11_;
					_tmp11_ = parent_file;
					if (g_file_equal (file, _tmp11_)) {
						GFile* _tmp12_;
						_tmp12_ = parent_file;
						g_object_unref ((GObject*) _tmp12_);
						suggested_action = GDK_ACTION_COPY;
						actions = (GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK;
					} else {
						GFile* _tmp13_;
						_tmp13_ = parent_file;
						g_object_unref ((GObject*) _tmp13_);
					}
				}
				_tmp14_ = fi;
				_tmp15_ = g_file_get_uri_scheme (_tmp14_);
				_g_free0 (scheme);
				scheme = _tmp15_;
				_tmp16_ = scheme;
				if (!g_str_has_prefix (_tmp16_, "file")) {
					actions &= ~GDK_ACTION_LINK;
				}
				_tmp18_ = fi;
				if (desktop_folder_dragn_drop_util_is_trashed (_tmp18_)) {
					_tmp17_ = desktop_folder_dragn_drop_util_is_trashed (file);
				} else {
					_tmp17_ = FALSE;
				}
				if (_tmp17_) {
					result = 0;
					_g_free0 (scheme);
					_g_object_unref0 (fi);
					_g_object_unref0 (parent_file);
					_g_object_unref0 (ofile);
					if (suggested_action_return) {
						*suggested_action_return = _vala_suggested_action_return;
					}
					return result;
				}
				_g_free0 (scheme);
				_g_object_unref0 (fi);
			}
		}
		if ((actions & (GDK_ACTION_COPY | GDK_ACTION_MOVE)) != 0) {
			_tmp19_ = suggested_action == GDK_ACTION_COPY;
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			suggested_action = GDK_ACTION_MOVE;
			{
				gboolean _tmp20_ = FALSE;
				i = 0;
				n = (guint) 0;
				_tmp20_ = TRUE;
				while (TRUE) {
					gboolean _tmp23_ = FALSE;
					GFile* fi = NULL;
					GList* _tmp24_;
					gconstpointer _tmp25_;
					GFile* _tmp26_;
					GFile* _tmp27_;
					GFile* _tmp28_;
					GFile* _tmp29_;
					GFileInfo* oinfo = NULL;
					gboolean _tmp37_ = FALSE;
					gboolean _tmp38_ = FALSE;
					GFile* _tmp39_;
					if (!_tmp20_) {
						gint _tmp21_;
						guint _tmp22_;
						_tmp21_ = i;
						i = _tmp21_ + 1;
						_tmp22_ = n;
						n = _tmp22_ + 1;
					}
					_tmp20_ = FALSE;
					if (((guint) i) < g_list_length (file_list)) {
						_tmp23_ = n < ((guint) 100);
					} else {
						_tmp23_ = FALSE;
					}
					if (!_tmp23_) {
						break;
					}
					_tmp24_ = g_list_nth (file_list, (guint) i);
					_tmp25_ = _tmp24_->data;
					_tmp26_ = _g_object_ref0 ((GFile*) _tmp25_);
					fi = _tmp26_;
					_tmp27_ = fi;
					if (desktop_folder_dragn_drop_util_is_trashed (_tmp27_)) {
						_g_object_unref0 (fi);
						break;
					}
					_tmp28_ = fi;
					_tmp29_ = _g_object_ref0 (_tmp28_);
					_g_object_unref0 (ofile);
					ofile = _tmp29_;
					oinfo = NULL;
					{
						GFileInfo* _tmp30_ = NULL;
						GFile* _tmp31_;
						GFileInfo* _tmp32_;
						GFileInfo* _tmp33_;
						_tmp31_ = ofile;
						_tmp32_ = g_file_query_filesystem_info (_tmp31_, "*", NULL, &_inner_error0_);
						_tmp30_ = _tmp32_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
						_tmp33_ = _tmp30_;
						_tmp30_ = NULL;
						_g_object_unref0 (oinfo);
						oinfo = _tmp33_;
						_g_object_unref0 (_tmp30_);
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* _error_ = NULL;
						FILE* _tmp34_;
						GError* _tmp35_;
						const gchar* _tmp36_;
						_error_ = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp34_ = stderr;
						_tmp35_ = _error_;
						_tmp36_ = _tmp35_->message;
						fprintf (_tmp34_, "Error: %s\n", _tmp36_);
						_g_error_free0 (_error_);
					}
					__finally0:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (oinfo);
						_g_object_unref0 (fi);
						_g_object_unref0 (parent_file);
						_g_object_unref0 (ofile);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return 0U;
					}
					_tmp39_ = ofile;
					if (_tmp39_ == NULL) {
						_tmp38_ = TRUE;
					} else {
						GFile* _tmp40_;
						_tmp40_ = ofile;
						_tmp38_ = !desktop_folder_dragn_drop_util_same_filesystem (file, _tmp40_);
					}
					if (_tmp38_) {
						_tmp37_ = TRUE;
					} else {
						GFileInfo* _tmp41_;
						_tmp41_ = oinfo;
						_tmp37_ = _tmp41_ != NULL;
					}
					if (_tmp37_) {
						suggested_action = GDK_ACTION_COPY;
						_g_object_unref0 (oinfo);
						_g_object_unref0 (fi);
						break;
					}
					_g_object_unref0 (oinfo);
					_g_object_unref0 (fi);
				}
			}
		}
	} else {
		if (!desktop_folder_dragn_drop_util_is_folder (file)) {
			actions = gdk_drag_context_get_actions (context) & (((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK) | GDK_ACTION_PRIVATE);
		} else {
			g_debug ("DragNDrop.vala:246: Not a valid drop target");
			result = 0;
			_g_object_unref0 (parent_file);
			_g_object_unref0 (ofile);
			if (suggested_action_return) {
				*suggested_action_return = _vala_suggested_action_return;
			}
			return result;
		}
	}
	_tmp42_ = g_file_get_uri_scheme (file);
	_g_free0 (scheme);
	scheme = _tmp42_;
	_tmp43_ = scheme;
	if (!g_str_has_prefix (_tmp43_, "file")) {
		actions &= ~GDK_ACTION_LINK;
	}
	if (desktop_folder_dragn_drop_util_is_trashed (file)) {
		actions &= ~(GDK_ACTION_COPY | GDK_ACTION_LINK);
	}
	if (actions == GDK_ACTION_ASK) {
		result = 0;
		_g_free0 (scheme);
		_g_object_unref0 (parent_file);
		_g_object_unref0 (ofile);
		if (suggested_action_return) {
			*suggested_action_return = _vala_suggested_action_return;
		}
		return result;
	}
	if (actions != 0) {
		_vala_suggested_action_return = suggested_action;
	} else {
		if ((actions & GDK_ACTION_ASK) != 0) {
			_vala_suggested_action_return = GDK_ACTION_ASK;
		} else {
			if ((actions & GDK_ACTION_COPY) != 0) {
				_vala_suggested_action_return = GDK_ACTION_COPY;
			} else {
				if ((actions & GDK_ACTION_LINK) != 0) {
					_vala_suggested_action_return = GDK_ACTION_LINK;
				} else {
					if ((actions & GDK_ACTION_MOVE) != 0) {
						_vala_suggested_action_return = GDK_ACTION_MOVE;
					} else {
						_vala_suggested_action_return = GDK_ACTION_PRIVATE;
					}
				}
			}
		}
	}
	result = actions;
	_g_free0 (scheme);
	_g_object_unref0 (parent_file);
	_g_object_unref0 (ofile);
	if (suggested_action_return) {
		*suggested_action_return = _vala_suggested_action_return;
	}
	return result;
}

/**
         * eel_g_file_list_new_from_string:
         * @string : a string representation of an URI list.
         *
         * Splits an URI list conforming to the text/uri-list
         * mime type defined in RFC 2483 into individual URIs,
         * discarding any comments and whitespace. The resulting
         * list will hold one #GFile for each URI.
         *
         * If @string contains no URIs, this function
         * will return %NULL.
         *
         * Return value: the list of #GFile<!---->s or %NULL.
         **/
GList*
desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str)
{
	GList* list = NULL;
	gchar** uris = NULL;
	gint uris_length1 = 0;
	gint _uris_size_ = 0;
	gchar** _tmp0_;
	gchar** _tmp1_;
	GList* result;
	g_return_val_if_fail (str != NULL, NULL);
	list = NULL;
	_tmp1_ = _tmp0_ = g_uri_list_extract_uris (str);
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
	uris = _tmp1_;
	uris_length1 = _vala_array_length (_tmp0_);
	_uris_size_ = uris_length1;
	{
		gint n = 0;
		n = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gchar** _tmp5_;
				gint _tmp5__length1;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				GFile* _tmp10_;
				if (!_tmp2_) {
					gint _tmp3_;
					n = n + 1;
					_tmp3_ = n;
				}
				_tmp2_ = FALSE;
				_tmp5_ = uris;
				_tmp5__length1 = uris_length1;
				if (_tmp5_ != NULL) {
					gchar** _tmp6_;
					gint _tmp6__length1;
					const gchar* _tmp7_;
					_tmp6_ = uris;
					_tmp6__length1 = uris_length1;
					_tmp7_ = _tmp6_[n];
					_tmp4_ = _tmp7_ != NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
				_tmp8_ = uris;
				_tmp8__length1 = uris_length1;
				_tmp9_ = _tmp8_[n];
				_tmp10_ = g_file_new_for_uri (_tmp9_);
				list = g_list_append (list, _tmp10_);
			}
		}
	}
	result = list;
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		_g_object_unref0 (_data5_->f);
		g_slice_free (Block5Data, _data5_);
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		_g_object_unref0 (_data6_->cancellable);
		_g_object_unref0 (_data6_->pd);
		_g_object_unref0 (_data6_->final_target);
		block5_data_unref (_data6_->_data5_);
		_data6_->_data5_ = NULL;
		g_slice_free (Block6Data, _data6_);
	}
}

static void
___lambda18_ (Block6Data* _data6_,
              GFile* file)
{
	Block5Data* _data5_;
	gchar* message = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	DesktopFolderProgressDialog* _tmp7_;
	const gchar* _tmp8_;
	_data5_ = _data6_->_data5_;
	g_return_if_fail (file != NULL);
	_tmp0_ = g_strdup (DESKTOP_FOLDER_LANG_DRAGNDROP_COPYING);
	message = _tmp0_;
	_tmp1_ = message;
	_tmp2_ = g_strconcat (_tmp1_, " ", NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_file_get_path (file);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
	_g_free0 (message);
	message = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_tmp7_ = _data6_->pd;
	_tmp8_ = message;
	desktop_folder_progress_dialog_show_action (_tmp7_, _tmp8_);
	_g_free0 (message);
}

static void
____lambda18__desktop_folder_util_file_operation_action (GFile* file,
                                                         gpointer self)
{
	___lambda18_ (self, file);
}

static gint
_________lambda17_ (Block6Data* _data6_)
{
	Block5Data* _data5_;
	DesktopFolderProgressDialog* _tmp8_;
	GError* _inner_error0_ = NULL;
	gint result;
	_data5_ = _data6_->_data5_;
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
		GCancellable* _tmp2_;
		_tmp0_ = _data5_->f;
		_tmp1_ = _data6_->final_target;
		_tmp2_ = _data6_->cancellable;
		desktop_folder_util_copy_recursive (_tmp0_, _tmp1_, G_FILE_COPY_NONE, _tmp2_, ____lambda18__desktop_folder_util_file_operation_action, _data6_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GCancellable* _tmp3_;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = _data6_->cancellable;
		g_cancellable_cancel (_tmp3_);
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "Error: %s\n", _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp7_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp7_;
	}
	_tmp8_ = _data6_->pd;
	desktop_folder_progress_dialog_stop (_tmp8_);
	result = 0;
	return result;
}

static gpointer
__________lambda17__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) _________lambda17_ (self));
	block6_data_unref (self);
	return result;
}

void
desktop_folder_dragn_drop_util_copy_move (GList* files,
                                          GFile* target_dir,
                                          GdkDragAction action,
                                          GtkWidget* parent_view,
                                          GCallback done_callback,
                                          GtkWidget* done_callback_data)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (target_dir != NULL);
	if (g_file_query_exists (target_dir, NULL)) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp0_ = FALSE;
				_tmp0_ = TRUE;
				while (TRUE) {
					Block5Data* _data5_;
					gboolean _tmp2_ = FALSE;
					GList* _tmp3_;
					gconstpointer _tmp4_;
					GFile* _tmp5_;
					GFile* _tmp6_;
					_data5_ = g_slice_new0 (Block5Data);
					_data5_->_ref_count_ = 1;
					if (!_tmp0_) {
						gint _tmp1_;
						_tmp1_ = i;
						i = _tmp1_ + 1;
					}
					_tmp0_ = FALSE;
					if (files != NULL) {
						_tmp2_ = ((guint) i) < g_list_length (files);
					} else {
						_tmp2_ = FALSE;
					}
					if (!_tmp2_) {
						block5_data_unref (_data5_);
						_data5_ = NULL;
						break;
					}
					_tmp3_ = g_list_nth (files, (guint) i);
					_tmp4_ = _tmp3_->data;
					_tmp5_ = _g_object_ref0 ((GFile*) _tmp4_);
					_data5_->f = _tmp5_;
					_tmp6_ = _data5_->f;
					if (g_file_query_exists (_tmp6_, NULL)) {
						gchar* path = NULL;
						GFile* _tmp7_;
						gchar* _tmp8_;
						gchar* new_name = NULL;
						GFile* _tmp9_;
						gchar* _tmp10_;
						gchar* target_path = NULL;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						gboolean _tmp13_ = FALSE;
						gboolean _tmp14_ = FALSE;
						const gchar* _tmp15_;
						GFlagsValue* _tmp19_;
						GFile* _tmp20_;
						GFile* _tmp21_;
						GFile* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						const gchar* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						_tmp7_ = _data5_->f;
						_tmp8_ = g_file_get_path (_tmp7_);
						path = _tmp8_;
						_tmp9_ = _data5_->f;
						_tmp10_ = g_file_get_basename (_tmp9_);
						new_name = _tmp10_;
						_tmp11_ = g_file_get_path (target_dir);
						target_path = _tmp11_;
						_tmp15_ = path;
						if (g_str_has_prefix (_tmp15_, "/usr/local/share/applications/")) {
							_tmp14_ = TRUE;
						} else {
							const gchar* _tmp16_;
							_tmp16_ = path;
							_tmp14_ = g_str_has_prefix (_tmp16_, "/usr/share/");
						}
						if (_tmp14_) {
							_tmp13_ = TRUE;
						} else {
							const gchar* _tmp17_;
							_tmp17_ = path;
							_tmp13_ = string_contains (_tmp17_, "/.local/share/applications/");
						}
						if (_tmp13_) {
							const gchar* _tmp18_;
							_tmp18_ = path;
							_tmp12_ = g_str_has_suffix (_tmp18_, ".desktop");
						} else {
							_tmp12_ = FALSE;
						}
						if (_tmp12_) {
							if (action == GDK_ACTION_MOVE) {
								action = GDK_ACTION_COPY;
							}
						}
						_tmp19_ = g_flags_get_first_value (g_type_class_ref (gdk_drag_action_get_type ()), action);
						_tmp20_ = _data5_->f;
						_tmp21_ = g_file_get_parent (_tmp20_);
						_tmp22_ = _tmp21_;
						_tmp23_ = g_file_get_path (_tmp22_);
						_tmp24_ = _tmp23_;
						_tmp25_ = string_to_string (_tmp24_);
						_tmp26_ = target_path;
						_tmp27_ = string_to_string (_tmp26_);
						_tmp28_ = g_strconcat ((_tmp19_ != NULL) ? _tmp19_->value_name : NULL, ", ", _tmp25_, " -> ", _tmp27_, NULL);
						_tmp29_ = _tmp28_;
						g_debug ("DragNDrop.vala:339: %s", _tmp29_);
						_g_free0 (_tmp29_);
						_g_free0 (_tmp24_);
						_g_object_unref0 (_tmp22_);
						if (action == GDK_ACTION_COPY) {
							Block6Data* _data6_;
							const gchar* _tmp30_;
							gchar* _tmp31_;
							gchar* _tmp32_;
							GFile* _tmp33_;
							gchar* _tmp34_;
							gchar* _tmp35_;
							gchar* _tmp36_;
							gchar* _tmp37_;
							GFile* _tmp38_;
							GFile* _tmp39_;
							DesktopFolderProgressDialog* _tmp40_;
							DesktopFolderProgressDialog* _tmp41_;
							GCancellable* _tmp42_;
							_data6_ = g_slice_new0 (Block6Data);
							_data6_->_ref_count_ = 1;
							_data6_->_data5_ = block5_data_ref (_data5_);
							_tmp30_ = target_path;
							_tmp31_ = g_strconcat (_tmp30_, "/", NULL);
							_tmp32_ = _tmp31_;
							_tmp33_ = _data5_->f;
							_tmp34_ = g_file_get_basename (_tmp33_);
							_tmp35_ = _tmp34_;
							_tmp36_ = g_strconcat (_tmp32_, _tmp35_, NULL);
							_tmp37_ = _tmp36_;
							_tmp38_ = g_file_new_for_path (_tmp37_);
							_tmp39_ = _tmp38_;
							_g_free0 (_tmp37_);
							_g_free0 (_tmp35_);
							_g_free0 (_tmp32_);
							_data6_->final_target = _tmp39_;
							_tmp40_ = desktop_folder_progress_dialog_new (DESKTOP_FOLDER_LANG_DRAGNDROP_FILE_OPERATIONS, G_TYPE_CHECK_INSTANCE_CAST (parent_view, gtk_window_get_type (), GtkWindow));
							g_object_ref_sink (_tmp40_);
							_data6_->pd = _tmp40_;
							_tmp41_ = _data6_->pd;
							_tmp42_ = desktop_folder_progress_dialog_start (_tmp41_);
							_data6_->cancellable = _tmp42_;
							{
								GThread* _tmp43_;
								GThread* _tmp44_;
								_tmp43_ = g_thread_try_new ("DesktopFolder File Operation", __________lambda17__gthread_func, block6_data_ref (_data6_), &_inner_error0_);
								_tmp44_ = _tmp43_;
								_g_thread_unref0 (_tmp44_);
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									goto __catch0_g_error;
								}
								if (done_callback != NULL) {
									done_callback ();
								}
							}
							goto __finally0;
							__catch0_g_error:
							{
								GError* _error_ = NULL;
								GCancellable* _tmp45_;
								DesktopFolderProgressDialog* _tmp46_;
								FILE* _tmp47_;
								GError* _tmp48_;
								const gchar* _tmp49_;
								_error_ = _inner_error0_;
								_inner_error0_ = NULL;
								_tmp45_ = _data6_->cancellable;
								g_cancellable_cancel (_tmp45_);
								_tmp46_ = _data6_->pd;
								desktop_folder_progress_dialog_stop (_tmp46_);
								_tmp47_ = stderr;
								_tmp48_ = _error_;
								_tmp49_ = _tmp48_->message;
								fprintf (_tmp47_, "Error: %s\n", _tmp49_);
								_g_error_free0 (_error_);
							}
							__finally0:
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								block6_data_unref (_data6_);
								_data6_ = NULL;
								_g_free0 (target_path);
								_g_free0 (new_name);
								_g_free0 (path);
								block5_data_unref (_data5_);
								_data5_ = NULL;
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return;
							}
							block6_data_unref (_data6_);
							_data6_ = NULL;
						} else {
							if (action == GDK_ACTION_MOVE) {
								{
									GFile* final_target = NULL;
									const gchar* _tmp50_;
									gchar* _tmp51_;
									gchar* _tmp52_;
									GFile* _tmp53_;
									gchar* _tmp54_;
									gchar* _tmp55_;
									gchar* _tmp56_;
									gchar* _tmp57_;
									GFile* _tmp58_;
									GFile* _tmp59_;
									GFile* _tmp60_;
									GFile* _tmp61_;
									_tmp50_ = target_path;
									_tmp51_ = g_strconcat (_tmp50_, "/", NULL);
									_tmp52_ = _tmp51_;
									_tmp53_ = _data5_->f;
									_tmp54_ = g_file_get_basename (_tmp53_);
									_tmp55_ = _tmp54_;
									_tmp56_ = g_strconcat (_tmp52_, _tmp55_, NULL);
									_tmp57_ = _tmp56_;
									_tmp58_ = g_file_new_for_path (_tmp57_);
									_tmp59_ = _tmp58_;
									_g_free0 (_tmp57_);
									_g_free0 (_tmp55_);
									_g_free0 (_tmp52_);
									final_target = _tmp59_;
									_tmp60_ = _data5_->f;
									_tmp61_ = final_target;
									g_file_move (_tmp60_, _tmp61_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										_g_object_unref0 (final_target);
										goto __catch1_g_error;
									}
									if (done_callback != NULL) {
										done_callback ();
									}
									_g_object_unref0 (final_target);
								}
								goto __finally1;
								__catch1_g_error:
								{
									GError* _error_ = NULL;
									FILE* _tmp62_;
									GError* _tmp63_;
									const gchar* _tmp64_;
									_error_ = _inner_error0_;
									_inner_error0_ = NULL;
									_tmp62_ = stderr;
									_tmp63_ = _error_;
									_tmp64_ = _tmp63_->message;
									fprintf (_tmp62_, "Error: %s\n", _tmp64_);
									_g_error_free0 (_error_);
								}
								__finally1:
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									_g_free0 (target_path);
									_g_free0 (new_name);
									_g_free0 (path);
									block5_data_unref (_data5_);
									_data5_ = NULL;
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							} else {
								if (action == GDK_ACTION_LINK) {
									{
										GFile* target_file = NULL;
										const gchar* _tmp65_;
										const gchar* _tmp66_;
										const gchar* _tmp67_;
										const gchar* _tmp68_;
										gchar* _tmp69_;
										gchar* _tmp70_;
										GFile* _tmp71_;
										GFile* _tmp72_;
										GFile* _tmp73_;
										_tmp65_ = target_path;
										_tmp66_ = string_to_string (_tmp65_);
										_tmp67_ = new_name;
										_tmp68_ = string_to_string (_tmp67_);
										_tmp69_ = g_strconcat (_tmp66_, "/", _tmp68_, NULL);
										_tmp70_ = _tmp69_;
										_tmp71_ = g_file_new_for_path (_tmp70_);
										_tmp72_ = _tmp71_;
										_g_free0 (_tmp70_);
										target_file = _tmp72_;
										_tmp73_ = target_file;
										if (!g_file_query_exists (_tmp73_, NULL)) {
											gchar* command = NULL;
											GFile* _tmp74_;
											gchar* _tmp75_;
											gchar* _tmp76_;
											const gchar* _tmp77_;
											const gchar* _tmp78_;
											const gchar* _tmp79_;
											const gchar* _tmp80_;
											const gchar* _tmp81_;
											gchar* _tmp82_;
											gchar* _tmp83_;
											GAppInfo* appinfo = NULL;
											const gchar* _tmp84_;
											GAppInfo* _tmp85_;
											GAppInfo* _tmp86_;
											_tmp74_ = _data5_->f;
											_tmp75_ = g_file_get_path (_tmp74_);
											_tmp76_ = _tmp75_;
											_tmp77_ = string_to_string (_tmp76_);
											_tmp78_ = target_path;
											_tmp79_ = string_to_string (_tmp78_);
											_tmp80_ = new_name;
											_tmp81_ = string_to_string (_tmp80_);
											_tmp82_ = g_strconcat ("ln -s \"", _tmp77_, "\" \"", _tmp79_, "/", _tmp81_, "\"", NULL);
											_tmp83_ = _tmp82_;
											_g_free0 (_tmp76_);
											command = _tmp83_;
											_tmp84_ = command;
											_tmp85_ = g_app_info_create_from_commandline (_tmp84_, NULL, G_APP_INFO_CREATE_SUPPORTS_URIS, &_inner_error0_);
											appinfo = _tmp85_;
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
												_g_free0 (command);
												_g_object_unref0 (target_file);
												goto __catch2_g_error;
											}
											_tmp86_ = appinfo;
											g_app_info_launch_uris (_tmp86_, NULL, NULL, &_inner_error0_);
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
												_g_object_unref0 (appinfo);
												_g_free0 (command);
												_g_object_unref0 (target_file);
												goto __catch2_g_error;
											}
											_g_object_unref0 (appinfo);
											_g_free0 (command);
										}
										_g_object_unref0 (target_file);
									}
									goto __finally2;
									__catch2_g_error:
									{
										GError* _error_ = NULL;
										FILE* _tmp87_;
										GError* _tmp88_;
										const gchar* _tmp89_;
										_error_ = _inner_error0_;
										_inner_error0_ = NULL;
										_tmp87_ = stderr;
										_tmp88_ = _error_;
										_tmp89_ = _tmp88_->message;
										fprintf (_tmp87_, "Error: %s\n", _tmp89_);
										_g_error_free0 (_error_);
									}
									__finally2:
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										_g_free0 (target_path);
										_g_free0 (new_name);
										_g_free0 (path);
										block5_data_unref (_data5_);
										_data5_ = NULL;
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
										g_clear_error (&_inner_error0_);
										return;
									}
								} else {
									g_debug ("DragNDrop.vala:396: unknown action!");
								}
							}
						}
						_g_free0 (target_path);
						_g_free0 (new_name);
						_g_free0 (path);
					}
					block5_data_unref (_data5_);
					_data5_ = NULL;
				}
			}
		}
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

