/* ItemView.c generated by valac 0.56.16, the Vala compiler
 * generated from ItemView.vala, do not modify */

/*
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdio.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#define DESKTOP_FOLDER_ITEM_VIEW_PADDING_X 10
#define DESKTOP_FOLDER_ITEM_VIEW_PADDING_Y 44
#define DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH 48
#define DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_WIDTH 90
#define DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_HEIGHT 90
#define DESKTOP_FOLDER_ITEM_VIEW_MAX_CHARACTERS 13
#define DESKTOP_FOLDER_ICON_SIZE 48
#define DESKTOP_FOLDER_DRAGN_DROP_file_drag_actions ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
#define DESKTOP_FOLDER_ICON_DEFAULT_WIDTH 90
#define DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN _ ("Open")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_EXECUTE _ ("Execute")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN_WITH _ ("Open With Other Application...")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_CUT _ ("Cut")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_COPY _ ("Copy")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_RENAME _ ("Rename")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_TRASH _ ("Move to Trash")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_CHANGEICON _ ("Change Icon")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILEINFO _ ("Properties")
#define DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_OPEN_IN_TERMINAL _ ("Open in terminal")
#define DESKTOP_FOLDER_LANG_ITEM_DELETE_FOLDER_MESSAGE _ ("This action will DELETE the folder and ALL its content.\n" \
"<b>Are you sure?</b>")
#define DESKTOP_FOLDER_LANG_ITEM_DELETE_FILE_MESSAGE _ ("This action will DELETE the file.\n<b>Are you sure?</b>")
#define DESKTOP_FOLDER_LANG_ITEM_DELETE_LINK_MESSAGE _ ("This action will DELETE the link (just the link).\n" \
"<b>Are you sure?</b>")
#define DESKTOP_FOLDER_LANG_ITEM_CHANGEICON_MESSAGE _ ("Select the image icon to be used.")
#define DESKTOP_FOLDER_LANG_DIALOG_CANCEL _ ("_Cancel")
#define DESKTOP_FOLDER_LANG_DIALOG_SELECT _ ("_Select")
#define DESKTOP_FOLDER_WINDOW_DECORATION_MARGIN 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DESKTOP_FOLDER_TYPE_ITEM_VIEW (desktop_folder_item_view_get_type ())
#define DESKTOP_FOLDER_ITEM_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemView))
#define DESKTOP_FOLDER_ITEM_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemViewClass))
#define DESKTOP_FOLDER_IS_ITEM_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW))
#define DESKTOP_FOLDER_IS_ITEM_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_ITEM_VIEW))
#define DESKTOP_FOLDER_ITEM_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemViewClass))

typedef struct _DesktopFolderItemView DesktopFolderItemView;
typedef struct _DesktopFolderItemViewClass DesktopFolderItemViewClass;
typedef struct _DesktopFolderItemViewPrivate DesktopFolderItemViewPrivate;

#define DESKTOP_FOLDER_TYPE_ITEM_MANAGER (desktop_folder_item_manager_get_type ())
#define DESKTOP_FOLDER_ITEM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_ITEM_MANAGER, DesktopFolderItemManager))
#define DESKTOP_FOLDER_ITEM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_ITEM_MANAGER, DesktopFolderItemManagerClass))
#define DESKTOP_FOLDER_IS_ITEM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_ITEM_MANAGER))
#define DESKTOP_FOLDER_IS_ITEM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_ITEM_MANAGER))
#define DESKTOP_FOLDER_ITEM_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_ITEM_MANAGER, DesktopFolderItemManagerClass))

typedef struct _DesktopFolderItemManager DesktopFolderItemManager;
typedef struct _DesktopFolderItemManagerClass DesktopFolderItemManagerClass;

#define DESKTOP_FOLDER_TYPE_EDITABLE_LABEL (desktop_folder_editable_label_get_type ())
#define DESKTOP_FOLDER_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL, DesktopFolderEditableLabel))
#define DESKTOP_FOLDER_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL, DesktopFolderEditableLabelClass))
#define DESKTOP_FOLDER_IS_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL))
#define DESKTOP_FOLDER_IS_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL))
#define DESKTOP_FOLDER_EDITABLE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL, DesktopFolderEditableLabelClass))

typedef struct _DesktopFolderEditableLabel DesktopFolderEditableLabel;
typedef struct _DesktopFolderEditableLabelClass DesktopFolderEditableLabelClass;
enum  {
	DESKTOP_FOLDER_ITEM_VIEW_0_PROPERTY,
	DESKTOP_FOLDER_ITEM_VIEW_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_item_view_properties[DESKTOP_FOLDER_ITEM_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DESKTOP_FOLDER_TYPE_FOLDER_MANAGER (desktop_folder_folder_manager_get_type ())
#define DESKTOP_FOLDER_FOLDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManager))
#define DESKTOP_FOLDER_FOLDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManagerClass))
#define DESKTOP_FOLDER_IS_FOLDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER))
#define DESKTOP_FOLDER_IS_FOLDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER))
#define DESKTOP_FOLDER_FOLDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManagerClass))

typedef struct _DesktopFolderFolderManager DesktopFolderFolderManager;
typedef struct _DesktopFolderFolderManagerClass DesktopFolderFolderManagerClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_WINDOW (desktop_folder_folder_window_get_type ())
#define DESKTOP_FOLDER_FOLDER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow))
#define DESKTOP_FOLDER_FOLDER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindowClass))
#define DESKTOP_FOLDER_IS_FOLDER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW))
#define DESKTOP_FOLDER_IS_FOLDER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW))
#define DESKTOP_FOLDER_FOLDER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindowClass))

typedef struct _DesktopFolderFolderWindow DesktopFolderFolderWindow;
typedef struct _DesktopFolderFolderWindowClass DesktopFolderFolderWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_DESKTOP_FOLDER_APP (desktop_folder_app_get_type ())
#define DESKTOP_FOLDER_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP_FOLDER_APP, DesktopFolderApp))
#define DESKTOP_FOLDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP_FOLDER_APP, DesktopFolderAppClass))
#define IS_DESKTOP_FOLDER_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP_FOLDER_APP))
#define IS_DESKTOP_FOLDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP_FOLDER_APP))
#define DESKTOP_FOLDER_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP_FOLDER_APP, DesktopFolderAppClass))

typedef struct _DesktopFolderApp DesktopFolderApp;
typedef struct _DesktopFolderAppClass DesktopFolderAppClass;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW (desktop_folder_dragn_drop_dnd_view_get_type ())
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndView))
#define DESKTOP_FOLDER_DRAGN_DROP_IS_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW))
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndViewIface))

typedef struct _DesktopFolderDragnDropDndView DesktopFolderDragnDropDndView;
typedef struct _DesktopFolderDragnDropDndViewIface DesktopFolderDragnDropDndViewIface;

#define DESKTOP_FOLDER_TYPE_ITEM_SETTINGS (desktop_folder_item_settings_get_type ())
#define DESKTOP_FOLDER_ITEM_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS, DesktopFolderItemSettings))
#define DESKTOP_FOLDER_ITEM_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS, DesktopFolderItemSettingsClass))
#define DESKTOP_FOLDER_IS_ITEM_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS))
#define DESKTOP_FOLDER_IS_ITEM_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS))
#define DESKTOP_FOLDER_ITEM_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS, DesktopFolderItemSettingsClass))

typedef struct _DesktopFolderItemSettings DesktopFolderItemSettings;
typedef struct _DesktopFolderItemSettingsClass DesktopFolderItemSettingsClass;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef enum  {
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL
} DesktopFolderDragnDropTargetType;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_TARGET_TYPE (desktop_folder_dragn_drop_target_type_get_type ())
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))
typedef enum  {
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM = 0,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST
} DesktopFolderUtilFxAnimationMode;

#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE (desktop_folder_util_fx_animation_mode_get_type ())

#define DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW (desktop_folder_desktop_window_get_type ())
#define DESKTOP_FOLDER_DESKTOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindow))
#define DESKTOP_FOLDER_DESKTOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindowClass))
#define DESKTOP_FOLDER_IS_DESKTOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW))
#define DESKTOP_FOLDER_IS_DESKTOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW))
#define DESKTOP_FOLDER_DESKTOP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindowClass))

typedef struct _DesktopFolderDesktopWindow DesktopFolderDesktopWindow;
typedef struct _DesktopFolderDesktopWindowClass DesktopFolderDesktopWindowClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT (desktop_folder_folder_arrangement_get_type ())
#define DESKTOP_FOLDER_FOLDER_ARRANGEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT, DesktopFolderFolderArrangement))
#define DESKTOP_FOLDER_IS_FOLDER_ARRANGEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT))
#define DESKTOP_FOLDER_FOLDER_ARRANGEMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT, DesktopFolderFolderArrangementIface))

typedef struct _DesktopFolderFolderArrangement DesktopFolderFolderArrangement;
typedef struct _DesktopFolderFolderArrangementIface DesktopFolderFolderArrangementIface;

#define DESKTOP_FOLDER_TYPE_POSITION_SETTINGS (desktop_folder_position_settings_get_type ())
#define DESKTOP_FOLDER_POSITION_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettings))
#define DESKTOP_FOLDER_POSITION_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettingsClass))
#define DESKTOP_FOLDER_IS_POSITION_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS))
#define DESKTOP_FOLDER_IS_POSITION_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS))
#define DESKTOP_FOLDER_POSITION_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettingsClass))

typedef struct _DesktopFolderPositionSettings DesktopFolderPositionSettings;
typedef struct _DesktopFolderPositionSettingsClass DesktopFolderPositionSettingsClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS (desktop_folder_folder_settings_get_type ())
#define DESKTOP_FOLDER_FOLDER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettings))
#define DESKTOP_FOLDER_FOLDER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettingsClass))
#define DESKTOP_FOLDER_IS_FOLDER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS))
#define DESKTOP_FOLDER_IS_FOLDER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS))
#define DESKTOP_FOLDER_FOLDER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettingsClass))

typedef struct _DesktopFolderFolderSettings DesktopFolderFolderSettings;
typedef struct _DesktopFolderFolderSettingsClass DesktopFolderFolderSettingsClass;
typedef struct _Block24Data Block24Data;

#define DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR (desktop_folder_menu_item_separator_get_type ())
#define DESKTOP_FOLDER_MENU_ITEM_SEPARATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR, DesktopFolderMenuItemSeparator))
#define DESKTOP_FOLDER_MENU_ITEM_SEPARATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR, DesktopFolderMenuItemSeparatorClass))
#define DESKTOP_FOLDER_IS_MENU_ITEM_SEPARATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR))
#define DESKTOP_FOLDER_IS_MENU_ITEM_SEPARATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR))
#define DESKTOP_FOLDER_MENU_ITEM_SEPARATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR, DesktopFolderMenuItemSeparatorClass))

typedef struct _DesktopFolderMenuItemSeparator DesktopFolderMenuItemSeparator;
typedef struct _DesktopFolderMenuItemSeparatorClass DesktopFolderMenuItemSeparatorClass;
typedef struct _Block25Data Block25Data;

struct _DesktopFolderItemView {
	GtkEventBox parent_instance;
	DesktopFolderItemViewPrivate * priv;
};

struct _DesktopFolderItemViewClass {
	GtkEventBoxClass parent_class;
	void (*create_label) (DesktopFolderItemView* self, const gchar* slabel);
};

struct _DesktopFolderItemViewPrivate {
	gboolean flagModified;
	gboolean flagMoved;
	DesktopFolderItemManager* manager;
	GtkMenu* menu;
	gboolean hide_extension;
	gchar* hidden_extension;
	GtkBox* container;
	DesktopFolderEditableLabel* label;
	GtkImage* icon;
	gboolean flag_dragdrop_started;
	GdkDragContext* drag_context;
	gint offsetx;
	gint offsety;
	gint px;
	gint py;
	gint maxx;
	gint maxy;
	GdkPoint start_drag_point;
};

struct _DesktopFolderDragnDropDndViewIface {
	GTypeInterface parent_iface;
	GtkWidget* (*get_widget) (DesktopFolderDragnDropDndView* self);
	GtkApplicationWindow* (*get_application_window) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file) (DesktopFolderDragnDropDndView* self);
	GtkImage* (*get_image) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file_at) (DesktopFolderDragnDropDndView* self, gint x, gint y);
	gboolean (*is_folder) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_writable) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_target_location) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_recent_uri_scheme) (DesktopFolderDragnDropDndView* self);
	gchar* (*get_display_target_uri) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_end) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_motion) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_leave) (DesktopFolderDragnDropDndView* self);
	DesktopFolderDragnDropDndView** (*get_all_selected_views) (DesktopFolderDragnDropDndView* self, gint* result_length1);
};

struct _DesktopFolderFolderArrangementIface {
	GTypeInterface parent_iface;
	gboolean (*have_margin) (DesktopFolderFolderArrangement* self);
	gboolean (*can_drag) (DesktopFolderFolderArrangement* self);
	gint (*get_sensitivity) (DesktopFolderFolderArrangement* self);
	gboolean (*can_organize) (DesktopFolderFolderArrangement* self);
	gboolean (*force_organization) (DesktopFolderFolderArrangement* self);
	void (*start_drag) (DesktopFolderFolderArrangement* self, DesktopFolderItemView* view);
	void (*motion_drag) (DesktopFolderFolderArrangement* self, gint x, gint y);
	void (*end_drag) (DesktopFolderFolderArrangement* self);
};

struct _Block24Data {
	int _ref_count_;
	DesktopFolderItemView* self;
	gchar* path;
	gchar* info_path;
};

struct _Block25Data {
	int _ref_count_;
	DesktopFolderItemView* self;
	gboolean isdir;
	GtkMessageDialog* msg;
};

static gint DesktopFolderItemView_private_offset;
static gpointer desktop_folder_item_view_parent_class = NULL;
static GdkPixbuf* desktop_folder_item_view_LINK_PIXBUF;
static GdkPixbuf* desktop_folder_item_view_LINK_PIXBUF = NULL;
VALA_EXTERN gint desktop_folder_folder_arrangement_DEFAULT_EXTERNAL_MARGIN;

VALA_EXTERN GType desktop_folder_item_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderItemView, g_object_unref)
VALA_EXTERN GType desktop_folder_item_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderItemManager, g_object_unref)
VALA_EXTERN GType desktop_folder_editable_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderEditableLabel, g_object_unref)
VALA_EXTERN void desktop_folder_item_view_create_label (DesktopFolderItemView* self,
                                            const gchar* slabel);
VALA_EXTERN DesktopFolderItemView* desktop_folder_item_view_new (DesktopFolderItemManager* manager);
VALA_EXTERN DesktopFolderItemView* desktop_folder_item_view_construct (GType object_type,
                                                           DesktopFolderItemManager* manager);
static gboolean desktop_folder_item_view_on_enter (DesktopFolderItemView* self,
                                            GdkEventCrossing* eventCrossing);
static gboolean _desktop_folder_item_view_on_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                           GdkEventCrossing* event,
                                                                           gpointer self);
VALA_EXTERN gboolean desktop_folder_item_view_on_leave (DesktopFolderItemView* self,
                                            GdkEventCrossing* eventCrossing);
static gboolean _desktop_folder_item_view_on_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                           GdkEventCrossing* event,
                                                                           gpointer self);
static gboolean desktop_folder_item_view_on_press (DesktopFolderItemView* self,
                                            GdkEventButton* event);
static gboolean _desktop_folder_item_view_on_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean desktop_folder_item_view_on_release (DesktopFolderItemView* self,
                                              GdkEventButton* event);
static gboolean _desktop_folder_item_view_on_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                               GdkEventButton* event,
                                                                               gpointer self);
static gboolean desktop_folder_item_view_on_motion (DesktopFolderItemView* self,
                                             GdkEventMotion* event);
static gboolean _desktop_folder_item_view_on_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                             GdkEventMotion* event,
                                                                             gpointer self);
VALA_EXTERN void desktop_folder_item_view_refresh_icon (DesktopFolderItemView* self,
                                            const gchar* forced);
static gchar* desktop_folder_item_view_get_correct_label (DesktopFolderItemView* self,
                                                   const gchar* file_name);
VALA_EXTERN gchar* desktop_folder_item_manager_get_file_name (DesktopFolderItemManager* self);
static void desktop_folder_item_view_real_create_label (DesktopFolderItemView* self,
                                                 const gchar* slabel);
VALA_EXTERN DesktopFolderEditableLabel* desktop_folder_editable_label_new (const gchar* title_name);
VALA_EXTERN DesktopFolderEditableLabel* desktop_folder_editable_label_construct (GType object_type,
                                                                     const gchar* title_name);
static void desktop_folder_item_view_check_ellipse (DesktopFolderItemView* self);
static void ___lambda118_ (DesktopFolderItemView* self,
                    const gchar* new_name);
VALA_EXTERN gboolean desktop_folder_item_manager_rename (DesktopFolderItemManager* self,
                                             const gchar* new_name);
VALA_EXTERN void desktop_folder_editable_label_set_text (DesktopFolderEditableLabel* self,
                                             const gchar* value);
static void ____lambda118__desktop_folder_editable_label_changed (DesktopFolderEditableLabel* _sender,
                                                           const gchar* new_title,
                                                           gpointer self);
static void ___lambda119_ (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_folder_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderManager, g_object_unref)
VALA_EXTERN DesktopFolderFolderManager* desktop_folder_item_manager_get_folder (DesktopFolderItemManager* self);
VALA_EXTERN GType desktop_folder_folder_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderWindow, g_object_unref)
VALA_EXTERN DesktopFolderFolderWindow* desktop_folder_folder_manager_get_view (DesktopFolderFolderManager* self);
VALA_EXTERN void desktop_folder_folder_window_on_start_editing (DesktopFolderFolderWindow* self);
static void ____lambda119__desktop_folder_editable_label_on_start_editing (DesktopFolderEditableLabel* _sender,
                                                                    gpointer self);
static void ___lambda120_ (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_folder_window_on_end_editing (DesktopFolderFolderWindow* self);
static void ____lambda120__desktop_folder_editable_label_on_stop_editing (DesktopFolderEditableLabel* _sender,
                                                                   gpointer self);
VALA_EXTERN void desktop_folder_util_show_error_dialog (const gchar* title,
                                            const gchar* message);
VALA_EXTERN void desktop_folder_item_view_rename (DesktopFolderItemView* self,
                                      const gchar* new_name);
VALA_EXTERN void desktop_folder_item_view_refresh (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderApp, g_object_unref)
VALA_EXTERN DesktopFolderApp* desktop_folder_folder_manager_get_application (DesktopFolderFolderManager* self);
VALA_EXTERN gboolean desktop_folder_app_get_desktop_visibility (DesktopFolderApp* self);
VALA_EXTERN void desktop_folder_item_view_fade_in (DesktopFolderItemView* self);
static GtkImage* desktop_folder_item_view_calculate_icon (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_item_manager_is_link (DesktopFolderItemManager* self);
static GtkImage* desktop_folder_item_view_draw_link_mark_gicon (DesktopFolderItemView* self,
                                                         GIcon* gicon);
VALA_EXTERN void desktop_folder_item_view_force_opened_folder_icon (DesktopFolderItemView* self);
VALA_EXTERN GtkImage* desktop_folder_item_view_get_image (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_dragn_drop_dnd_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDragnDropDndView, g_object_unref)
VALA_EXTERN GFile* desktop_folder_dragn_drop_dnd_view_get_file (DesktopFolderDragnDropDndView* self);
VALA_EXTERN GType desktop_folder_item_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderItemSettings, g_object_unref)
VALA_EXTERN DesktopFolderItemSettings* desktop_folder_item_manager_get_settings (DesktopFolderItemManager* self);
VALA_EXTERN const gchar* desktop_folder_item_settings_get_icon (DesktopFolderItemSettings* self);
static GtkImage* desktop_folder_item_view_draw_link_mark_pixbuf (DesktopFolderItemView* self,
                                                          GdkPixbuf* pixbuf);
VALA_EXTERN gboolean desktop_folder_item_manager_check_exist_cached (DesktopFolderItemManager* self);
static GtkImage* desktop_folder_item_view_draw_not_exist_mark_pixbuf (DesktopFolderItemView* self,
                                                               GdkPixbuf* pixbuf);
VALA_EXTERN gboolean desktop_folder_item_manager_is_desktop_file (DesktopFolderItemManager* self);
VALA_EXTERN gchar* desktop_folder_item_manager_get_absolute_path (DesktopFolderItemManager* self);
VALA_EXTERN const gchar* desktop_folder_editable_label_get_text (DesktopFolderEditableLabel* self);
VALA_EXTERN void desktop_folder_editable_label_set_lines (DesktopFolderEditableLabel* self,
                                              gint n);
VALA_EXTERN void desktop_folder_editable_label_set_ellipsize (DesktopFolderEditableLabel* self,
                                                  PangoEllipsizeMode mode);
VALA_EXTERN gboolean desktop_folder_app_get_single_click (DesktopFolderApp* self);
static void desktop_folder_item_view_cancel_movement_and_start_drag_action (DesktopFolderItemView* self,
                                                                     GdkEvent* event);
VALA_EXTERN GType desktop_folder_dragn_drop_target_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeList* desktop_folder_folder_manager_get_selected_items (DesktopFolderFolderManager* self);
VALA_EXTERN GType desktop_folder_util_fx_animation_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void desktop_folder_util_gtk_animation_animate_move (GtkWidget* widget,
                                                     GdkPoint* to,
                                                     gdouble duration,
                                                     DesktopFolderUtilFxAnimationMode mode);
VALA_EXTERN void desktop_folder_item_settings_set_x (DesktopFolderItemSettings* self,
                                         gint value);
VALA_EXTERN void desktop_folder_item_settings_set_y (DesktopFolderItemSettings* self,
                                         gint value);
VALA_EXTERN void desktop_folder_item_manager_save_settings (DesktopFolderItemManager* self,
                                                DesktopFolderItemSettings* is);
VALA_EXTERN void desktop_folder_folder_window_on_item_moving (DesktopFolderFolderWindow* self,
                                                  gboolean moving);
VALA_EXTERN GType desktop_folder_desktop_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDesktopWindow, g_object_unref)
VALA_EXTERN void desktop_folder_item_manager_save_current_position (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_start_editing (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_editable_label_start_editing (DesktopFolderEditableLabel* self);
VALA_EXTERN void desktop_folder_item_view_select_only (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_folder_window_unselect_all (DesktopFolderFolderWindow* self);
VALA_EXTERN void desktop_folder_item_manager_select_only (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_select_add (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_select_add (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_unselect (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_unselect (DesktopFolderItemManager* self);
VALA_EXTERN gboolean desktop_folder_item_view_is_selected (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_item_manager_is_selected (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_fade_out (DesktopFolderItemView* self);
static void desktop_folder_item_view_on_double_click (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_folder_arrangement_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderArrangement, g_object_unref)
VALA_EXTERN DesktopFolderFolderArrangement* desktop_folder_folder_manager_get_arrangement (DesktopFolderFolderManager* self);
VALA_EXTERN gint desktop_folder_folder_arrangement_get_sensitivity (DesktopFolderFolderArrangement* self);
VALA_EXTERN GType desktop_folder_position_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderPositionSettings, g_object_unref)
VALA_EXTERN GType desktop_folder_folder_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderSettings, g_object_unref)
VALA_EXTERN DesktopFolderFolderSettings* desktop_folder_folder_manager_get_settings (DesktopFolderFolderManager* self);
VALA_EXTERN gint desktop_folder_folder_settings_get_arrangement_padding (DesktopFolderFolderSettings* self);
VALA_EXTERN gint desktop_folder_item_view_RoundToNearestMultiple (gint i,
                                                      gint m);
VALA_EXTERN gboolean desktop_folder_folder_arrangement_have_margin (DesktopFolderFolderArrangement* self);
VALA_EXTERN void desktop_folder_folder_window_move_item (DesktopFolderFolderWindow* self,
                                             DesktopFolderItemView* item,
                                             gint x,
                                             gint y);
VALA_EXTERN void desktop_folder_folder_arrangement_end_drag (DesktopFolderFolderArrangement* self);
VALA_EXTERN void desktop_folder_folder_arrangement_start_drag (DesktopFolderFolderArrangement* self,
                                                   DesktopFolderItemView* view);
VALA_EXTERN void desktop_folder_folder_arrangement_motion_drag (DesktopFolderFolderArrangement* self,
                                                    gint x,
                                                    gint y);
VALA_EXTERN DesktopFolderItemManager* desktop_folder_item_view_get_manager (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_item_view_is_dragdrop_started (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_on_drag_end (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_folder_arrangement_can_drag (DesktopFolderFolderArrangement* self);
VALA_EXTERN gboolean desktop_folder_folder_manager_are_items_locked (DesktopFolderFolderManager* self);
VALA_EXTERN gint desktop_folder_item_settings_get_x (DesktopFolderItemSettings* self);
VALA_EXTERN gint desktop_folder_item_settings_get_y (DesktopFolderItemSettings* self);
VALA_EXTERN GtkLabel* desktop_folder_editable_label_get_title_label (DesktopFolderEditableLabel* self);
static inline gint desktop_folder_item_view_RoundDownToMultiple (gint i,
                                                   gint m);
static void desktop_folder_item_view_show_popup (DesktopFolderItemView* self,
                                          GdkEventButton* event);
VALA_EXTERN void desktop_folder_item_view_execute (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_execute (DesktopFolderItemManager* self);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
VALA_EXTERN gboolean desktop_folder_item_manager_is_executable (DesktopFolderItemManager* self);
static void __lambda109_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
static void ___lambda109__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda110_ (Block24Data* _data24_,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_openwith (DesktopFolderItemManager* self,
                                           const gchar* filepath);
static void ___lambda110__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
VALA_EXTERN DesktopFolderMenuItemSeparator* desktop_folder_menu_item_separator_new (void);
VALA_EXTERN DesktopFolderMenuItemSeparator* desktop_folder_menu_item_separator_construct (GType object_type);
VALA_EXTERN GType desktop_folder_menu_item_separator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderMenuItemSeparator, g_object_unref)
static void __lambda111_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_cut (DesktopFolderItemManager* self);
static void ___lambda111__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda112_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_copy (DesktopFolderItemManager* self);
static void ___lambda112__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda113_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
static void ___lambda113__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda114_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_trash_selected (DesktopFolderItemManager* self);
static void ___lambda114__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda115_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
static void desktop_folder_item_view_change_icon (DesktopFolderItemView* self);
static void ___lambda115__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda116_ (Block24Data* _data24_,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_show_info (DesktopFolderItemManager* self,
                                            const gchar* filepath);
static void ___lambda116__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
VALA_EXTERN gboolean desktop_folder_dragn_drop_dnd_view_is_folder (DesktopFolderDragnDropDndView* self);
static void ___lambda117_ (Block24Data* _data24_,
                    GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_open_in_terminal (DesktopFolderItemManager* self,
                                                   const gchar* path);
static void ____lambda117__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
VALA_EXTERN void desktop_folder_item_view_cut (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_copy (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_trash (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_trash (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_delete_dialog (DesktopFolderItemView* self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void __lambda121_ (Block25Data* _data25_,
                   gint response_id);
static void ___lambda121__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
VALA_EXTERN GtkApplicationWindow* desktop_folder_dragn_drop_dnd_view_get_application_window (DesktopFolderDragnDropDndView* self);
VALA_EXTERN void desktop_folder_item_manager_change_icon (DesktopFolderItemManager* self,
                                              const gchar* filename);
VALA_EXTERN void desktop_folder_item_view_modify (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_get_bounding_box (DesktopFolderItemView* self,
                                                GdkRectangle* result);
VALA_EXTERN gboolean desktop_folder_editable_label_get_editing (DesktopFolderEditableLabel* self);
VALA_EXTERN gint desktop_folder_position_settings_get_x (DesktopFolderPositionSettings* self);
VALA_EXTERN gint desktop_folder_position_settings_get_y (DesktopFolderPositionSettings* self);
VALA_EXTERN GeeList* desktop_folder_folder_manager_get_items_at (DesktopFolderFolderManager* self,
                                                     GdkRectangle* rectangle);
static void desktop_folder_item_view_finalize (GObject * obj);
static GType desktop_folder_item_view_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drag_targets[2];

static inline gpointer
desktop_folder_item_view_get_instance_private (DesktopFolderItemView* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopFolderItemView_private_offset);
}

/**
     * @constructor
     * @param ItemManager manager the manager of this item view
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_desktop_folder_item_view_on_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                  GdkEventCrossing* event,
                                                                  gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_enter ((DesktopFolderItemView*) self, event);
	return result;
}

static gboolean
_desktop_folder_item_view_on_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                  GdkEventCrossing* event,
                                                                  gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_leave ((DesktopFolderItemView*) self, event);
	return result;
}

static gboolean
_desktop_folder_item_view_on_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_press ((DesktopFolderItemView*) self, event);
	return result;
}

static gboolean
_desktop_folder_item_view_on_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_release ((DesktopFolderItemView*) self, event);
	return result;
}

static gboolean
_desktop_folder_item_view_on_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                    GdkEventMotion* event,
                                                                    gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_motion ((DesktopFolderItemView*) self, event);
	return result;
}

DesktopFolderItemView*
desktop_folder_item_view_construct (GType object_type,
                                    DesktopFolderItemManager* manager)
{
	DesktopFolderItemView * self = NULL;
	DesktopFolderItemManager* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	gchar* slabel = NULL;
	DesktopFolderItemManager* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkBox* _tmp12_;
	g_return_val_if_fail (manager != NULL, NULL);
	self = (DesktopFolderItemView*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (manager);
	_g_object_unref0 (self->priv->manager);
	self->priv->manager = _tmp0_;
	gtk_widget_set_size_request ((GtkWidget*) self, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_HEIGHT);
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "df_item");
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp2_, "df_fadingwindow");
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp3_, "df_fadeout");
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) _desktop_folder_item_view_on_enter_gtk_widget_enter_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) _desktop_folder_item_view_on_leave_gtk_widget_leave_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) _desktop_folder_item_view_on_press_gtk_widget_button_press_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _desktop_folder_item_view_on_release_gtk_widget_button_release_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _desktop_folder_item_view_on_motion_gtk_widget_motion_notify_event, self, 0);
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->container);
	self->priv->container = _tmp4_;
	_tmp5_ = self->priv->container;
	g_object_set ((GtkWidget*) _tmp5_, "margin", 0, NULL);
	_tmp6_ = self->priv->container;
	gtk_widget_set_size_request ((GtkWidget*) _tmp6_, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_HEIGHT);
	desktop_folder_item_view_refresh_icon (self, NULL);
	_tmp7_ = self->priv->manager;
	_tmp8_ = desktop_folder_item_manager_get_file_name (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = desktop_folder_item_view_get_correct_label (self, _tmp9_);
	_tmp11_ = _tmp10_;
	_g_free0 (_tmp9_);
	slabel = _tmp11_;
	desktop_folder_item_view_create_label (self, slabel);
	_tmp12_ = self->priv->container;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
	_g_free0 (slabel);
	return self;
}

DesktopFolderItemView*
desktop_folder_item_view_new (DesktopFolderItemManager* manager)
{
	return desktop_folder_item_view_construct (DESKTOP_FOLDER_TYPE_ITEM_VIEW, manager);
}

/**
     * @name create_headerbar
     * @description create the header bar
     */
static void
___lambda118_ (DesktopFolderItemView* self,
               const gchar* new_name)
{
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (new_name != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = self->priv->hidden_extension;
	_tmp2_ = g_strconcat (new_name, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = desktop_folder_item_manager_rename (_tmp0_, _tmp3_);
	_g_free0 (_tmp3_);
	if (_tmp4_) {
		DesktopFolderEditableLabel* _tmp5_;
		_tmp5_ = self->priv->label;
		desktop_folder_editable_label_set_text (_tmp5_, new_name);
		desktop_folder_item_view_check_ellipse (self);
	}
}

static void
____lambda118__desktop_folder_editable_label_changed (DesktopFolderEditableLabel* _sender,
                                                      const gchar* new_title,
                                                      gpointer self)
{
	___lambda118_ ((DesktopFolderItemView*) self, new_title);
}

static void
___lambda119_ (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderWindow* _tmp3_;
	DesktopFolderFolderWindow* _tmp4_;
	_tmp0_ = self->priv->manager;
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = desktop_folder_folder_manager_get_view (_tmp2_);
	_tmp4_ = _tmp3_;
	desktop_folder_folder_window_on_start_editing (_tmp4_);
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
}

static void
____lambda119__desktop_folder_editable_label_on_start_editing (DesktopFolderEditableLabel* _sender,
                                                               gpointer self)
{
	___lambda119_ ((DesktopFolderItemView*) self);
}

static void
___lambda120_ (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderWindow* _tmp3_;
	DesktopFolderFolderWindow* _tmp4_;
	_tmp0_ = self->priv->manager;
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = desktop_folder_folder_manager_get_view (_tmp2_);
	_tmp4_ = _tmp3_;
	desktop_folder_folder_window_on_end_editing (_tmp4_);
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
}

static void
____lambda120__desktop_folder_editable_label_on_stop_editing (DesktopFolderEditableLabel* _sender,
                                                              gpointer self)
{
	___lambda120_ ((DesktopFolderItemView*) self);
}

static void
desktop_folder_item_view_real_create_label (DesktopFolderItemView* self,
                                            const gchar* slabel)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (slabel != NULL);
	{
		DesktopFolderEditableLabel* _tmp0_;
		GtkBox* _tmp1_;
		DesktopFolderEditableLabel* _tmp2_;
		DesktopFolderEditableLabel* _tmp3_;
		DesktopFolderEditableLabel* _tmp4_;
		DesktopFolderEditableLabel* _tmp5_;
		_tmp0_ = desktop_folder_editable_label_new (slabel);
		g_object_ref_sink (_tmp0_);
		_g_object_unref0 (self->priv->label);
		self->priv->label = _tmp0_;
		_tmp1_ = self->priv->container;
		_tmp2_ = self->priv->label;
		gtk_box_pack_end (_tmp1_, (GtkWidget*) _tmp2_, TRUE, TRUE, (guint) 0);
		desktop_folder_item_view_check_ellipse (self);
		_tmp3_ = self->priv->label;
		g_signal_connect_object (_tmp3_, "changed", (GCallback) ____lambda118__desktop_folder_editable_label_changed, self, 0);
		_tmp4_ = self->priv->label;
		g_signal_connect_object (_tmp4_, "on-start-editing", (GCallback) ____lambda119__desktop_folder_editable_label_on_start_editing, self, 0);
		_tmp5_ = self->priv->label;
		g_signal_connect_object (_tmp5_, "on-stop-editing", (GCallback) ____lambda120__desktop_folder_editable_label_on_stop_editing, self, 0);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = stderr;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		desktop_folder_util_show_error_dialog ("Error", _tmp10_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
desktop_folder_item_view_create_label (DesktopFolderItemView* self,
                                       const gchar* slabel)
{
	DesktopFolderItemViewClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = DESKTOP_FOLDER_ITEM_VIEW_GET_CLASS (self);
	if (_klass_->create_label) {
		_klass_->create_label (self, slabel);
	}
}

/**
     * @name rename
     * @description change the label of the item to the new label
     */
void
desktop_folder_item_view_rename (DesktopFolderItemView* self,
                                 const gchar* new_name)
{
	DesktopFolderEditableLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_name != NULL);
	_tmp0_ = self->priv->label;
	desktop_folder_editable_label_set_text (_tmp0_, new_name);
	desktop_folder_item_view_refresh_icon (self, NULL);
}

/**
     * @name refresh
     * @description refresh the window
     */
void
desktop_folder_item_view_refresh (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderApp* _tmp3_;
	DesktopFolderApp* _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = desktop_folder_folder_manager_get_application (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = desktop_folder_app_get_desktop_visibility (_tmp4_);
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	if (_tmp5_) {
		desktop_folder_item_view_fade_in (self);
		gtk_widget_show_all ((GtkWidget*) self);
	}
}

/**
     * @name refresh_icon
     * @description force to refresh the icon imagen shown
     */
void
desktop_folder_item_view_refresh_icon (DesktopFolderItemView* self,
                                       const gchar* forced)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GtkImage* newImage = NULL;
		GtkImage* _tmp7_;
		GtkImage* _tmp10_;
		GtkImage* _tmp11_;
		GtkImage* _tmp12_;
		GtkImage* _tmp13_;
		GtkStyleContext* _tmp14_;
		GtkBox* _tmp15_;
		GtkImage* _tmp16_;
		if (forced == NULL) {
			GtkImage* _tmp0_;
			_tmp0_ = desktop_folder_item_view_calculate_icon (self);
			_g_object_unref0 (newImage);
			newImage = _tmp0_;
		} else {
			GIcon* gicon = NULL;
			GIcon* _tmp1_;
			DesktopFolderItemManager* _tmp2_;
			_tmp1_ = g_icon_new_for_string ("folder-open", &_inner_error0_);
			gicon = _tmp1_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (newImage);
				goto __catch0_g_error;
			}
			_tmp2_ = self->priv->manager;
			if (desktop_folder_item_manager_is_link (_tmp2_)) {
				GIcon* _tmp3_;
				GtkImage* _tmp4_;
				_tmp3_ = gicon;
				_tmp4_ = desktop_folder_item_view_draw_link_mark_gicon (self, _tmp3_);
				_g_object_unref0 (newImage);
				newImage = _tmp4_;
			} else {
				GIcon* _tmp5_;
				GtkImage* _tmp6_;
				_tmp5_ = gicon;
				_tmp6_ = (GtkImage*) gtk_image_new_from_gicon (_tmp5_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
				g_object_ref_sink (_tmp6_);
				_g_object_unref0 (newImage);
				newImage = _tmp6_;
			}
			_g_object_unref0 (gicon);
		}
		_tmp7_ = self->priv->icon;
		if (_tmp7_ != NULL) {
			GtkBox* _tmp8_;
			GtkImage* _tmp9_;
			_tmp8_ = self->priv->container;
			_tmp9_ = self->priv->icon;
			gtk_container_remove ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
		}
		_tmp10_ = newImage;
		_tmp11_ = _g_object_ref0 (_tmp10_);
		_g_object_unref0 (self->priv->icon);
		self->priv->icon = _tmp11_;
		_tmp12_ = self->priv->icon;
		gtk_widget_set_size_request ((GtkWidget*) _tmp12_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH);
		_tmp13_ = self->priv->icon;
		_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
		gtk_style_context_add_class (_tmp14_, "df_icon");
		_tmp15_ = self->priv->container;
		_tmp16_ = self->priv->icon;
		gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
		desktop_folder_item_view_refresh (self);
		_g_object_unref0 (newImage);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = stderr;
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		fprintf (_tmp17_, "Error: %s\n", _tmp19_);
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		desktop_folder_util_show_error_dialog ("Error", _tmp21_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

/**
     * @name force_opened_folder_icon
     * @description put the folder-open icon over the item
     */
void
desktop_folder_item_view_force_opened_folder_icon (DesktopFolderItemView* self)
{
	g_return_if_fail (self != NULL);
	desktop_folder_item_view_refresh_icon (self, "folder-open");
}

/**
     * @return the image icon
     */
GtkImage*
desktop_folder_item_view_get_image (DesktopFolderItemView* self)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->icon;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
     * @name calculate_icon
     * @description calculate the icon image to show
     * @return Gtk.Image the image to be shown
     */
static GtkImage*
desktop_folder_item_view_calculate_icon (DesktopFolderItemView* self)
{
	GError* _inner_error0_ = NULL;
	GtkImage* result;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GtkImage* icon = NULL;
		GFileInfo* fileInfo = NULL;
		DesktopFolderItemManager* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
		gboolean _tmp5_ = FALSE;
		DesktopFolderItemManager* _tmp6_;
		DesktopFolderItemSettings* _tmp7_;
		DesktopFolderItemSettings* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gboolean _tmp11_;
		_tmp0_ = self->priv->manager;
		_tmp1_ = desktop_folder_dragn_drop_dnd_view_get_file ((DesktopFolderDragnDropDndView*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_file_query_info (_tmp2_, "standard::icon", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		fileInfo = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (icon);
			goto __catch0_g_error;
		}
		_tmp6_ = self->priv->manager;
		_tmp7_ = desktop_folder_item_manager_get_settings (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = desktop_folder_item_settings_get_icon (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = _tmp10_ != NULL;
		_g_object_unref0 (_tmp8_);
		if (_tmp11_) {
			DesktopFolderItemManager* _tmp12_;
			DesktopFolderItemSettings* _tmp13_;
			DesktopFolderItemSettings* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			_tmp12_ = self->priv->manager;
			_tmp13_ = desktop_folder_item_manager_get_settings (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = desktop_folder_item_settings_get_icon (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = strlen (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp5_ = _tmp18_ > 0;
			_g_object_unref0 (_tmp14_);
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			gint scale = 0;
			GdkPixbuf* custom = NULL;
			DesktopFolderItemManager* _tmp19_;
			DesktopFolderItemSettings* _tmp20_;
			DesktopFolderItemSettings* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			GdkPixbuf* _tmp24_;
			GdkPixbuf* _tmp25_;
			DesktopFolderItemManager* _tmp26_;
			scale = DESKTOP_FOLDER_ICON_SIZE;
			_tmp19_ = self->priv->manager;
			_tmp20_ = desktop_folder_item_manager_get_settings (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = desktop_folder_item_settings_get_icon (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = gdk_pixbuf_new_from_file_at_scale (_tmp23_, scale, scale, TRUE, &_inner_error0_);
			_tmp25_ = _tmp24_;
			_g_object_unref0 (_tmp21_);
			custom = _tmp25_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (fileInfo);
				_g_object_unref0 (icon);
				goto __catch0_g_error;
			}
			_tmp26_ = self->priv->manager;
			if (desktop_folder_item_manager_is_link (_tmp26_)) {
				GdkPixbuf* _tmp27_;
				GtkImage* _tmp28_;
				_tmp27_ = custom;
				_tmp28_ = desktop_folder_item_view_draw_link_mark_pixbuf (self, _tmp27_);
				_g_object_unref0 (icon);
				icon = _tmp28_;
			} else {
				GdkPixbuf* _tmp29_;
				GtkImage* _tmp30_;
				_tmp29_ = custom;
				_tmp30_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp29_);
				g_object_ref_sink (_tmp30_);
				_g_object_unref0 (icon);
				icon = _tmp30_;
			}
			_g_object_unref0 (custom);
		} else {
			DesktopFolderItemManager* _tmp31_;
			_tmp31_ = self->priv->manager;
			if (!desktop_folder_item_manager_check_exist_cached (_tmp31_)) {
				GThemedIcon* themed = NULL;
				GThemedIcon* _tmp32_;
				GtkIconInfo* info = NULL;
				GtkIconTheme* _tmp33_;
				GThemedIcon* _tmp34_;
				GtkIconInfo* _tmp35_;
				GdkPixbuf* pixbuf = NULL;
				GtkIconInfo* _tmp36_;
				GdkPixbuf* _tmp37_;
				GdkPixbuf* _tmp38_;
				gint _tmp39_;
				gint _tmp40_;
				GdkPixbuf* _tmp43_;
				GtkImage* _tmp44_;
				_tmp32_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("text-x-generic");
				themed = _tmp32_;
				_tmp33_ = gtk_icon_theme_get_default ();
				_tmp34_ = themed;
				_tmp35_ = gtk_icon_theme_lookup_by_gicon (_tmp33_, (GIcon*) _tmp34_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, 0);
				info = _tmp35_;
				_tmp36_ = info;
				_tmp37_ = gtk_icon_info_load_icon (_tmp36_, &_inner_error0_);
				pixbuf = _tmp37_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (info);
					_g_object_unref0 (themed);
					_g_object_unref0 (fileInfo);
					_g_object_unref0 (icon);
					goto __catch0_g_error;
				}
				_tmp38_ = pixbuf;
				_tmp39_ = gdk_pixbuf_get_height (_tmp38_);
				_tmp40_ = _tmp39_;
				if (_tmp40_ != DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH) {
					GdkPixbuf* _tmp41_;
					GdkPixbuf* _tmp42_;
					_tmp41_ = pixbuf;
					_tmp42_ = gdk_pixbuf_scale_simple (_tmp41_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, GDK_INTERP_BILINEAR);
					_g_object_unref0 (pixbuf);
					pixbuf = _tmp42_;
				}
				_tmp43_ = pixbuf;
				_tmp44_ = desktop_folder_item_view_draw_not_exist_mark_pixbuf (self, _tmp43_);
				_g_object_unref0 (icon);
				icon = _tmp44_;
				_g_object_unref0 (pixbuf);
				_g_object_unref0 (info);
				_g_object_unref0 (themed);
			} else {
				DesktopFolderItemManager* _tmp45_;
				_tmp45_ = self->priv->manager;
				if (desktop_folder_item_manager_is_desktop_file (_tmp45_)) {
					GDesktopAppInfo* desktopApp = NULL;
					DesktopFolderItemManager* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					GDesktopAppInfo* _tmp49_;
					GDesktopAppInfo* _tmp50_;
					GIcon* gicon = NULL;
					GDesktopAppInfo* _tmp51_;
					GIcon* _tmp52_;
					GIcon* _tmp53_;
					DesktopFolderItemManager* _tmp54_;
					_tmp46_ = self->priv->manager;
					_tmp47_ = desktop_folder_item_manager_get_absolute_path (_tmp46_);
					_tmp48_ = _tmp47_;
					_tmp49_ = g_desktop_app_info_new_from_filename (_tmp48_);
					_tmp50_ = _tmp49_;
					_g_free0 (_tmp48_);
					desktopApp = _tmp50_;
					_tmp51_ = desktopApp;
					_tmp52_ = g_app_info_get_icon ((GAppInfo*) _tmp51_);
					_tmp53_ = _g_object_ref0 (_tmp52_);
					gicon = _tmp53_;
					_tmp54_ = self->priv->manager;
					if (desktop_folder_item_manager_is_link (_tmp54_)) {
						GIcon* _tmp55_;
						GtkImage* _tmp56_;
						_tmp55_ = gicon;
						_tmp56_ = desktop_folder_item_view_draw_link_mark_gicon (self, _tmp55_);
						_g_object_unref0 (icon);
						icon = _tmp56_;
					} else {
						GThemedIcon* themed = NULL;
						GIcon* _tmp57_;
						gchar* _tmp58_;
						gchar* _tmp59_;
						GThemedIcon* _tmp60_;
						GThemedIcon* _tmp61_;
						GtkIconInfo* info = NULL;
						GtkIconTheme* _tmp62_;
						GThemedIcon* _tmp63_;
						GtkIconInfo* _tmp64_;
						GdkPixbuf* pixbuf = NULL;
						GtkIconInfo* _tmp65_;
						GdkPixbuf* _tmp77_;
						gint _tmp78_;
						gint _tmp79_;
						_tmp57_ = gicon;
						_tmp58_ = g_icon_to_string (_tmp57_);
						_tmp59_ = _tmp58_;
						_tmp60_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks (_tmp59_);
						_tmp61_ = _tmp60_;
						_g_free0 (_tmp59_);
						themed = _tmp61_;
						_tmp62_ = gtk_icon_theme_get_default ();
						_tmp63_ = themed;
						_tmp64_ = gtk_icon_theme_lookup_by_gicon (_tmp62_, (GIcon*) _tmp63_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, 0);
						info = _tmp64_;
						pixbuf = NULL;
						_tmp65_ = info;
						if (_tmp65_ == NULL) {
							GdkPixbuf* _tmp66_ = NULL;
							GIcon* _tmp67_;
							gchar* _tmp68_;
							gchar* _tmp69_;
							GdkPixbuf* _tmp70_;
							GdkPixbuf* _tmp71_;
							GdkPixbuf* _tmp72_;
							_tmp67_ = gicon;
							_tmp68_ = g_icon_to_string (_tmp67_);
							_tmp69_ = _tmp68_;
							_tmp70_ = gdk_pixbuf_new_from_file_at_scale (_tmp69_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, TRUE, &_inner_error0_);
							_tmp71_ = _tmp70_;
							_g_free0 (_tmp69_);
							_tmp66_ = _tmp71_;
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								_g_object_unref0 (pixbuf);
								_g_object_unref0 (info);
								_g_object_unref0 (themed);
								_g_object_unref0 (gicon);
								_g_object_unref0 (desktopApp);
								_g_object_unref0 (fileInfo);
								_g_object_unref0 (icon);
								goto __catch0_g_error;
							}
							_tmp72_ = _tmp66_;
							_tmp66_ = NULL;
							_g_object_unref0 (pixbuf);
							pixbuf = _tmp72_;
							_g_object_unref0 (_tmp66_);
						} else {
							GdkPixbuf* _tmp73_ = NULL;
							GtkIconInfo* _tmp74_;
							GdkPixbuf* _tmp75_;
							GdkPixbuf* _tmp76_;
							_tmp74_ = info;
							_tmp75_ = gtk_icon_info_load_icon (_tmp74_, &_inner_error0_);
							_tmp73_ = _tmp75_;
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								_g_object_unref0 (pixbuf);
								_g_object_unref0 (info);
								_g_object_unref0 (themed);
								_g_object_unref0 (gicon);
								_g_object_unref0 (desktopApp);
								_g_object_unref0 (fileInfo);
								_g_object_unref0 (icon);
								goto __catch0_g_error;
							}
							_tmp76_ = _tmp73_;
							_tmp73_ = NULL;
							_g_object_unref0 (pixbuf);
							pixbuf = _tmp76_;
							_g_object_unref0 (_tmp73_);
						}
						_tmp77_ = pixbuf;
						_tmp78_ = gdk_pixbuf_get_height (_tmp77_);
						_tmp79_ = _tmp78_;
						if (_tmp79_ != DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH) {
							GdkPixbuf* _tmp80_;
							GdkPixbuf* _tmp81_;
							GdkPixbuf* _tmp82_;
							GtkImage* _tmp83_;
							_tmp80_ = pixbuf;
							_tmp81_ = gdk_pixbuf_scale_simple (_tmp80_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, GDK_INTERP_BILINEAR);
							_g_object_unref0 (pixbuf);
							pixbuf = _tmp81_;
							_tmp82_ = pixbuf;
							_tmp83_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp82_);
							g_object_ref_sink (_tmp83_);
							_g_object_unref0 (icon);
							icon = _tmp83_;
						} else {
							GIcon* _tmp84_;
							GtkImage* _tmp85_;
							_tmp84_ = gicon;
							_tmp85_ = (GtkImage*) gtk_image_new_from_gicon (_tmp84_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
							g_object_ref_sink (_tmp85_);
							_g_object_unref0 (icon);
							icon = _tmp85_;
						}
						_g_object_unref0 (pixbuf);
						_g_object_unref0 (info);
						_g_object_unref0 (themed);
					}
					_g_object_unref0 (gicon);
					_g_object_unref0 (desktopApp);
				} else {
					GFileInfo* ctypeInfo = NULL;
					DesktopFolderItemManager* _tmp86_;
					GFile* _tmp87_;
					GFile* _tmp88_;
					GFileInfo* _tmp89_;
					GFileInfo* _tmp90_;
					gchar* contentType = NULL;
					GFileInfo* _tmp91_;
					const gchar* _tmp92_;
					gchar* _tmp93_;
					gchar* mimeType = NULL;
					const gchar* _tmp94_;
					gchar* _tmp95_;
					gboolean isImage = FALSE;
					const gchar* _tmp96_;
					gboolean _tmp97_ = FALSE;
					const gchar* _tmp98_;
					_tmp86_ = self->priv->manager;
					_tmp87_ = desktop_folder_dragn_drop_dnd_view_get_file ((DesktopFolderDragnDropDndView*) _tmp86_);
					_tmp88_ = _tmp87_;
					_tmp89_ = g_file_query_info (_tmp88_, "standard::content-type", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
					_tmp90_ = _tmp89_;
					_g_object_unref0 (_tmp88_);
					ctypeInfo = _tmp90_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (fileInfo);
						_g_object_unref0 (icon);
						goto __catch0_g_error;
					}
					_tmp91_ = ctypeInfo;
					_tmp92_ = g_file_info_get_content_type (_tmp91_);
					_tmp93_ = g_strdup (_tmp92_);
					contentType = _tmp93_;
					_tmp94_ = contentType;
					_tmp95_ = g_content_type_get_mime_type (_tmp94_);
					mimeType = _tmp95_;
					_tmp96_ = mimeType;
					isImage = g_content_type_is_a (_tmp96_, "image/*");
					_tmp98_ = mimeType;
					if (_tmp98_ != NULL) {
						_tmp97_ = isImage;
					} else {
						_tmp97_ = FALSE;
					}
					if (_tmp97_) {
						gint scale = 0;
						GdkPixbuf* custom = NULL;
						DesktopFolderItemManager* _tmp99_;
						GFile* _tmp100_;
						GFile* _tmp101_;
						gchar* _tmp102_;
						gchar* _tmp103_;
						GdkPixbuf* _tmp104_;
						GdkPixbuf* _tmp105_;
						GdkPixbuf* _tmp106_;
						GdkPixbuf* _tmp107_;
						DesktopFolderItemManager* _tmp108_;
						scale = DESKTOP_FOLDER_ICON_SIZE;
						_tmp99_ = self->priv->manager;
						_tmp100_ = desktop_folder_dragn_drop_dnd_view_get_file ((DesktopFolderDragnDropDndView*) _tmp99_);
						_tmp101_ = _tmp100_;
						_tmp102_ = g_file_get_path (_tmp101_);
						_tmp103_ = _tmp102_;
						_tmp104_ = gdk_pixbuf_new_from_file (_tmp103_, &_inner_error0_);
						_tmp105_ = _tmp104_;
						_g_free0 (_tmp103_);
						_g_object_unref0 (_tmp101_);
						custom = _tmp105_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_free0 (mimeType);
							_g_free0 (contentType);
							_g_object_unref0 (ctypeInfo);
							_g_object_unref0 (fileInfo);
							_g_object_unref0 (icon);
							goto __catch0_g_error;
						}
						_tmp106_ = custom;
						_tmp107_ = gdk_pixbuf_scale_simple (_tmp106_, scale, scale, GDK_INTERP_BILINEAR);
						_g_object_unref0 (custom);
						custom = _tmp107_;
						_tmp108_ = self->priv->manager;
						if (desktop_folder_item_manager_is_link (_tmp108_)) {
							GdkPixbuf* _tmp109_;
							GtkImage* _tmp110_;
							_tmp109_ = custom;
							_tmp110_ = desktop_folder_item_view_draw_link_mark_pixbuf (self, _tmp109_);
							_g_object_unref0 (icon);
							icon = _tmp110_;
						} else {
							GdkPixbuf* _tmp111_;
							GtkImage* _tmp112_;
							_tmp111_ = custom;
							_tmp112_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp111_);
							g_object_ref_sink (_tmp112_);
							_g_object_unref0 (icon);
							icon = _tmp112_;
						}
						_g_object_unref0 (custom);
					} else {
						GIcon* gicon = NULL;
						GFileInfo* _tmp113_;
						GIcon* _tmp114_;
						GIcon* _tmp115_;
						DesktopFolderItemManager* _tmp116_;
						_tmp113_ = fileInfo;
						_tmp114_ = g_file_info_get_icon (_tmp113_);
						_tmp115_ = _g_object_ref0 (_tmp114_);
						gicon = _tmp115_;
						_tmp116_ = self->priv->manager;
						if (desktop_folder_item_manager_is_link (_tmp116_)) {
							GIcon* _tmp117_;
							GtkImage* _tmp118_;
							_tmp117_ = gicon;
							_tmp118_ = desktop_folder_item_view_draw_link_mark_gicon (self, _tmp117_);
							_g_object_unref0 (icon);
							icon = _tmp118_;
						} else {
							GIcon* _tmp119_;
							GtkImage* _tmp120_;
							_tmp119_ = gicon;
							_tmp120_ = (GtkImage*) gtk_image_new_from_gicon (_tmp119_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
							g_object_ref_sink (_tmp120_);
							_g_object_unref0 (icon);
							icon = _tmp120_;
						}
						_g_object_unref0 (gicon);
					}
					_g_free0 (mimeType);
					_g_free0 (contentType);
					_g_object_unref0 (ctypeInfo);
				}
			}
		}
		result = icon;
		_g_object_unref0 (fileInfo);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		{
			FILE* _tmp121_;
			GError* _tmp122_;
			const gchar* _tmp123_;
			GtkImage* icon = NULL;
			GtkImage* _tmp124_;
			_tmp121_ = stderr;
			_tmp122_ = e;
			_tmp123_ = _tmp122_->message;
			fprintf (_tmp121_, "Error: %s\n", _tmp123_);
			_tmp124_ = (GtkImage*) gtk_image_new_from_icon_name ("image-x-generic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
			g_object_ref_sink (_tmp124_);
			_g_object_unref0 (icon);
			icon = _tmp124_;
			result = icon;
			_g_error_free0 (e);
			return result;
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* ee = NULL;
			FILE* _tmp125_;
			GError* _tmp126_;
			const gchar* _tmp127_;
			GError* _tmp128_;
			const gchar* _tmp129_;
			ee = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp125_ = stderr;
			_tmp126_ = ee;
			_tmp127_ = _tmp126_->message;
			fprintf (_tmp125_, "Error: %s\n", _tmp127_);
			_tmp128_ = ee;
			_tmp129_ = _tmp128_->message;
			desktop_folder_util_show_error_dialog ("Error", _tmp129_);
			_g_error_free0 (ee);
		}
		__finally1:
		_g_error_free0 (e);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

/**
     * @name draw_not_exist_mark_pixbuf
     * @description draw a CROSS mark to indicate that the file doesn't exist
     * @param pixbuf {Gdk.Pixbuf} the pixbuf to modify
     * @result {Gtk.Image} the image produced
     */
static GtkImage*
desktop_folder_item_view_draw_not_exist_mark_pixbuf (DesktopFolderItemView* self,
                                                     GdkPixbuf* pixbuf)
{
	GError* _inner_error0_ = NULL;
	GtkImage* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (pixbuf != NULL, NULL);
	{
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp0_;
		cairo_t* context = NULL;
		cairo_t* _tmp1_;
		GdkPixbuf* pixbuf2 = NULL;
		GdkPixbuf* _tmp2_;
		GtkImage* icon = NULL;
		GtkImage* _tmp3_;
		_tmp0_ = gdk_cairo_surface_create_from_pixbuf (pixbuf, 1, NULL);
		surface = _tmp0_;
		_tmp1_ = cairo_create (surface);
		context = _tmp1_;
		cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) 1);
		cairo_move_to (context, (gdouble) 0, (gdouble) 0);
		cairo_line_to (context, (gdouble) DESKTOP_FOLDER_ICON_SIZE, (gdouble) DESKTOP_FOLDER_ICON_SIZE);
		cairo_move_to (context, (gdouble) DESKTOP_FOLDER_ICON_SIZE, (gdouble) 0);
		cairo_line_to (context, (gdouble) 0, (gdouble) DESKTOP_FOLDER_ICON_SIZE);
		cairo_stroke (context);
		_tmp2_ = gdk_pixbuf_get_from_surface (surface, 0, 0, DESKTOP_FOLDER_ICON_SIZE, DESKTOP_FOLDER_ICON_SIZE);
		pixbuf2 = _tmp2_;
		_tmp3_ = (GtkImage*) gtk_image_new_from_pixbuf (pixbuf2);
		g_object_ref_sink (_tmp3_);
		icon = _tmp3_;
		result = icon;
		_g_object_unref0 (pixbuf2);
		_cairo_destroy0 (context);
		_cairo_surface_destroy0 (surface);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "Error: %s\n", _tmp6_);
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		desktop_folder_util_show_error_dialog ("Error", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

/**
     * @name draw_link_mark_gicon
     * @description draw a link mark over the image of an icon
     * @param gicon {GLib.Icon} the icon we want to modify and add the mark
     * @result {Gtk.Image} the image produced
     */
static GtkImage*
desktop_folder_item_view_draw_link_mark_gicon (DesktopFolderItemView* self,
                                               GIcon* gicon)
{
	gpointer _tmp16_;
	GtkImage* _tmp17_;
	GError* _inner_error0_ = NULL;
	GtkImage* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (gicon != NULL, NULL);
	{
		GtkIconTheme* theme = NULL;
		GtkIconTheme* _tmp0_;
		GtkIconTheme* _tmp1_;
		GtkIconInfo* iconInfo = NULL;
		GtkIconInfo* _tmp2_;
		GdkPixbuf* pixbuf = NULL;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkPixbuf* _tmp9_;
		GtkImage* _tmp10_;
		_tmp0_ = gtk_icon_theme_get_default ();
		_tmp1_ = _g_object_ref0 (_tmp0_);
		theme = _tmp1_;
		_tmp2_ = gtk_icon_theme_lookup_by_gicon (theme, gicon, DESKTOP_FOLDER_ICON_SIZE, 0);
		iconInfo = _tmp2_;
		_tmp3_ = gtk_icon_info_load_icon (iconInfo, &_inner_error0_);
		pixbuf = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (iconInfo);
			_g_object_unref0 (theme);
			goto __catch0_g_error;
		}
		_tmp4_ = pixbuf;
		_tmp5_ = gdk_pixbuf_get_height (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ != DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH) {
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
			_tmp7_ = pixbuf;
			_tmp8_ = gdk_pixbuf_scale_simple (_tmp7_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, GDK_INTERP_BILINEAR);
			_g_object_unref0 (pixbuf);
			pixbuf = _tmp8_;
		}
		_tmp9_ = pixbuf;
		_tmp10_ = desktop_folder_item_view_draw_link_mark_pixbuf (self, _tmp9_);
		result = _tmp10_;
		_g_object_unref0 (pixbuf);
		_g_object_unref0 (iconInfo);
		_g_object_unref0 (theme);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
		GError* _tmp14_;
		const gchar* _tmp15_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = stderr;
		_tmp12_ = e;
		_tmp13_ = _tmp12_->message;
		fprintf (_tmp11_, "Error: %s\n", _tmp13_);
		_tmp14_ = e;
		_tmp15_ = _tmp14_->message;
		desktop_folder_util_show_error_dialog ("Error", _tmp15_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp16_ = NULL;
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, gtk_image_get_type ()) ? ((GtkImage*) _tmp16_) : NULL);
	result = _tmp17_;
	return result;
}

/**
     * @name draw_link_mark_pixbuf
     * @description draw a link mark over a pixbuf
     * @param pixbuf {Gdk.Pixbuf} the pixbuf to modify
     * @result {Gtk.Image} the image produced
     */
static GtkImage*
desktop_folder_item_view_draw_link_mark_pixbuf (DesktopFolderItemView* self,
                                                GdkPixbuf* pixbuf)
{
	GError* _inner_error0_ = NULL;
	GtkImage* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (pixbuf != NULL, NULL);
	{
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp0_;
		cairo_t* context = NULL;
		cairo_t* _tmp1_;
		gint scale = 0;
		cairo_surface_t* links = NULL;
		GdkPixbuf* _tmp2_;
		cairo_surface_t* _tmp3_;
		GdkPixbuf* pixbuf2 = NULL;
		GdkPixbuf* _tmp4_;
		GtkImage* icon = NULL;
		GtkImage* _tmp5_;
		_tmp0_ = gdk_cairo_surface_create_from_pixbuf (pixbuf, 1, NULL);
		surface = _tmp0_;
		_tmp1_ = cairo_create (surface);
		context = _tmp1_;
		scale = DESKTOP_FOLDER_ICON_SIZE / 3;
		_tmp2_ = desktop_folder_item_view_LINK_PIXBUF;
		_tmp3_ = gdk_cairo_surface_create_from_pixbuf (_tmp2_, 1, NULL);
		links = _tmp3_;
		cairo_set_source_surface (context, links, (gdouble) (DESKTOP_FOLDER_ICON_SIZE - scale), (gdouble) (DESKTOP_FOLDER_ICON_SIZE - scale));
		cairo_paint (context);
		_tmp4_ = gdk_pixbuf_get_from_surface (surface, 0, 0, DESKTOP_FOLDER_ICON_SIZE, DESKTOP_FOLDER_ICON_SIZE);
		pixbuf2 = _tmp4_;
		_tmp5_ = (GtkImage*) gtk_image_new_from_pixbuf (pixbuf2);
		g_object_ref_sink (_tmp5_);
		icon = _tmp5_;
		result = icon;
		_g_object_unref0 (pixbuf2);
		_cairo_surface_destroy0 (links);
		_cairo_destroy0 (context);
		_cairo_surface_destroy0 (surface);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = stderr;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		desktop_folder_util_show_error_dialog ("Error", _tmp10_);
		_g_error_free0 (e);
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

/**
     * @name get_correct_label
     * @description return the correct label to be shown
     */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static gchar*
desktop_folder_item_view_get_correct_label (DesktopFolderItemView* self,
                                            const gchar* file_name)
{
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file_name != NULL, NULL);
	if (self->priv->hide_extension) {
		gint index = 0;
		gchar* _tmp2_;
		gchar* _tmp3_;
		index = string_index_of (file_name, ".", 0);
		if (index > 0) {
			gchar* _tmp0_;
			gchar* _tmp1_;
			_tmp0_ = string_substring (file_name, (glong) index, (glong) -1);
			_g_free0 (self->priv->hidden_extension);
			self->priv->hidden_extension = _tmp0_;
			_tmp1_ = string_substring (file_name, (glong) 0, (glong) index);
			result = _tmp1_;
			return result;
		}
		_tmp2_ = g_strdup ("");
		_g_free0 (self->priv->hidden_extension);
		self->priv->hidden_extension = _tmp2_;
		_tmp3_ = g_strdup (file_name);
		result = _tmp3_;
		return result;
	} else {
		gint index = 0;
		gchar* _tmp6_;
		gchar* _tmp7_;
		index = string_index_of (file_name, ".desktop", 0);
		if (index > 0) {
			gchar* _tmp4_;
			gchar* _tmp5_;
			self->priv->hide_extension = TRUE;
			_tmp4_ = string_substring (file_name, (glong) index, (glong) -1);
			_g_free0 (self->priv->hidden_extension);
			self->priv->hidden_extension = _tmp4_;
			_tmp5_ = string_substring (file_name, (glong) 0, (glong) index);
			result = _tmp5_;
			return result;
		}
		_tmp6_ = g_strdup ("");
		_g_free0 (self->priv->hidden_extension);
		self->priv->hidden_extension = _tmp6_;
		_tmp7_ = g_strdup (file_name);
		result = _tmp7_;
		return result;
	}
}

/**
     * @name check_ellipse
     * @description check if the ellipse should be shown
     * @param string name the name to be shown in order to calculate if the ellipse will be shown
     */
static void
desktop_folder_item_view_check_ellipse (DesktopFolderItemView* self)
{
	DesktopFolderEditableLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->label;
	_tmp1_ = desktop_folder_editable_label_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = strlen (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ > DESKTOP_FOLDER_ITEM_VIEW_MAX_CHARACTERS) {
		DesktopFolderEditableLabel* _tmp5_;
		DesktopFolderEditableLabel* _tmp6_;
		_tmp5_ = self->priv->label;
		desktop_folder_editable_label_set_lines (_tmp5_, 2);
		_tmp6_ = self->priv->label;
		desktop_folder_editable_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
	} else {
		DesktopFolderEditableLabel* _tmp7_;
		DesktopFolderEditableLabel* _tmp8_;
		_tmp7_ = self->priv->label;
		desktop_folder_editable_label_set_lines (_tmp7_, 1);
		_tmp8_ = self->priv->label;
		desktop_folder_editable_label_set_ellipsize (_tmp8_, PANGO_ELLIPSIZE_NONE);
	}
}

/**
     * @name on_enter
     * @description on_enter signal to highlight the icon
     * @param eventCrossing EventCrossing @see on_enter signal
     * @return bool @see the on_enter signal
     */
static gboolean
desktop_folder_item_view_on_enter (DesktopFolderItemView* self,
                                   GdkEventCrossing* eventCrossing)
{
	GtkStyleContext* _tmp0_;
	gboolean single_click = FALSE;
	DesktopFolderItemManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderManager* _tmp3_;
	DesktopFolderApp* _tmp4_;
	DesktopFolderApp* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (eventCrossing != NULL, FALSE);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "df_item_over");
	_tmp1_ = self->priv->manager;
	_tmp2_ = desktop_folder_item_manager_get_folder (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = desktop_folder_folder_manager_get_application (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = desktop_folder_app_get_single_click (_tmp5_);
	_g_object_unref0 (_tmp5_);
	_g_object_unref0 (_tmp3_);
	single_click = _tmp6_;
	if (single_click) {
		_tmp7_ = !self->priv->flagModified;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		GdkWindow* _tmp8_;
		GdkDisplay* _tmp9_;
		GdkCursor* _tmp10_;
		GdkCursor* _tmp11_;
		_tmp8_ = gtk_widget_get_window ((GtkWidget*) self);
		_tmp9_ = gdk_display_get_default ();
		_tmp10_ = gdk_cursor_new_from_name (_tmp9_, "pointer");
		_tmp11_ = _tmp10_;
		gdk_window_set_cursor (_tmp8_, _tmp11_);
		_g_object_unref0 (_tmp11_);
	}
	result = TRUE;
	return result;
}

/**
     * @name cancel_movement_and_start_drag_action
     * @description cancel the current icon movement and start a drag action instead
     */
static void
desktop_folder_item_view_cancel_movement_and_start_drag_action (DesktopFolderItemView* self,
                                                                GdkEvent* event)
{
	GtkTargetList* _tmp0_;
	GtkTargetList* _tmp1_;
	GdkDragContext* _tmp2_;
	GdkDragContext* _tmp3_;
	GeeList* selecteds = NULL;
	DesktopFolderItemManager* _tmp4_;
	DesktopFolderFolderManager* _tmp5_;
	DesktopFolderFolderManager* _tmp6_;
	GeeList* _tmp7_;
	GeeList* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	self->priv->flagModified = FALSE;
	_tmp0_ = gtk_target_list_new (DESKTOP_FOLDER_DRAGN_DROP_drag_targets, G_N_ELEMENTS (DESKTOP_FOLDER_DRAGN_DROP_drag_targets));
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_drag_begin_with_coordinates ((GtkWidget*) self, _tmp1_, DESKTOP_FOLDER_DRAGN_DROP_file_drag_actions, GDK_BUTTON_PRIMARY, event, -1, -1);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->drag_context);
	self->priv->drag_context = _tmp3_;
	_gtk_target_list_unref0 (_tmp1_);
	self->priv->flag_dragdrop_started = TRUE;
	_tmp4_ = self->priv->manager;
	_tmp5_ = desktop_folder_item_manager_get_folder (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = desktop_folder_folder_manager_get_selected_items (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp6_);
	selecteds = _tmp8_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				GeeList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				DesktopFolderItemView* selected = NULL;
				GeeList* _tmp14_;
				gpointer _tmp15_;
				DesktopFolderItemView* _tmp16_;
				DesktopFolderItemView* _tmp17_;
				GdkPoint _tmp18_;
				DesktopFolderItemSettings* settings = NULL;
				DesktopFolderItemView* _tmp19_;
				DesktopFolderItemManager* _tmp20_;
				DesktopFolderItemSettings* _tmp21_;
				DesktopFolderItemSettings* _tmp22_;
				DesktopFolderItemView* _tmp23_;
				GdkPoint _tmp24_;
				DesktopFolderItemSettings* _tmp25_;
				DesktopFolderItemView* _tmp26_;
				GdkPoint _tmp27_;
				DesktopFolderItemView* _tmp28_;
				DesktopFolderItemManager* _tmp29_;
				DesktopFolderItemSettings* _tmp30_;
				DesktopFolderItemView* _tmp31_;
				DesktopFolderItemManager* _tmp32_;
				DesktopFolderFolderManager* _tmp33_;
				DesktopFolderFolderManager* _tmp34_;
				DesktopFolderFolderWindow* _tmp35_;
				DesktopFolderFolderWindow* _tmp36_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp11_ = selecteds;
				_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
				_tmp13_ = _tmp12_;
				if (!(i < _tmp13_)) {
					break;
				}
				_tmp14_ = selecteds;
				_tmp15_ = gee_list_get (_tmp14_, i);
				selected = (DesktopFolderItemView*) _tmp15_;
				_tmp16_ = selected;
				_tmp17_ = selected;
				_tmp18_ = _tmp17_->priv->start_drag_point;
				desktop_folder_util_gtk_animation_animate_move ((GtkWidget*) _tmp16_, &_tmp18_, (gdouble) 500, DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK);
				_tmp19_ = selected;
				_tmp20_ = _tmp19_->priv->manager;
				_tmp21_ = desktop_folder_item_manager_get_settings (_tmp20_);
				settings = _tmp21_;
				_tmp22_ = settings;
				_tmp23_ = selected;
				_tmp24_ = _tmp23_->priv->start_drag_point;
				desktop_folder_item_settings_set_x (_tmp22_, _tmp24_.x);
				_tmp25_ = settings;
				_tmp26_ = selected;
				_tmp27_ = _tmp26_->priv->start_drag_point;
				desktop_folder_item_settings_set_y (_tmp25_, _tmp27_.y);
				_tmp28_ = selected;
				_tmp29_ = _tmp28_->priv->manager;
				_tmp30_ = settings;
				desktop_folder_item_manager_save_settings (_tmp29_, _tmp30_);
				_tmp31_ = selected;
				_tmp32_ = _tmp31_->priv->manager;
				_tmp33_ = desktop_folder_item_manager_get_folder (_tmp32_);
				_tmp34_ = _tmp33_;
				_tmp35_ = desktop_folder_folder_manager_get_view (_tmp34_);
				_tmp36_ = _tmp35_;
				desktop_folder_folder_window_on_item_moving (_tmp36_, FALSE);
				_g_object_unref0 (_tmp36_);
				_g_object_unref0 (_tmp34_);
				_g_object_unref0 (settings);
				_g_object_unref0 (selected);
			}
		}
	}
	_g_object_unref0 (selecteds);
}

/**
     * @name on_leave
     * @description on_leave signal to remove highlight of the icon
     * @param eventCrossing EventCrossing @see on_enter signal
     * @return bool @see the on_leave signal
     */
gboolean
desktop_folder_item_view_on_leave (DesktopFolderItemView* self,
                                   GdkEventCrossing* eventCrossing)
{
	GtkStyleContext* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_remove_class (_tmp0_, "df_item_over");
	if (self->priv->flagMoved) {
		gboolean _tmp1_ = FALSE;
		DesktopFolderItemManager* _tmp2_;
		DesktopFolderFolderManager* _tmp3_;
		DesktopFolderFolderManager* _tmp4_;
		DesktopFolderFolderWindow* _tmp5_;
		DesktopFolderFolderWindow* _tmp6_;
		gboolean _tmp7_;
		GtkAllocation allocation = {0};
		GtkAllocation _tmp8_ = {0};
		DesktopFolderFolderWindow* window = NULL;
		DesktopFolderItemManager* _tmp9_;
		DesktopFolderFolderManager* _tmp10_;
		DesktopFolderFolderManager* _tmp11_;
		DesktopFolderFolderWindow* _tmp12_;
		DesktopFolderFolderWindow* _tmp13_;
		gint window_width = 0;
		gint window_height = 0;
		DesktopFolderFolderWindow* _tmp14_;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		_tmp2_ = self->priv->manager;
		_tmp3_ = desktop_folder_item_manager_get_folder (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = desktop_folder_folder_manager_get_view (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = DESKTOP_FOLDER_IS_DESKTOP_WINDOW (_tmp6_);
		_g_object_unref0 (_tmp6_);
		_g_object_unref0 (_tmp4_);
		if (_tmp7_) {
			_tmp1_ = eventCrossing->y < ((gdouble) 0);
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			result = TRUE;
			return result;
		}
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp8_);
		allocation = _tmp8_;
		_tmp9_ = self->priv->manager;
		_tmp10_ = desktop_folder_item_manager_get_folder (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = desktop_folder_folder_manager_get_view (_tmp11_);
		_tmp13_ = _tmp12_;
		_g_object_unref0 (_tmp11_);
		window = _tmp13_;
		_tmp14_ = window;
		gtk_window_get_size ((GtkWindow*) _tmp14_, &_tmp15_, &_tmp16_);
		window_width = _tmp15_;
		window_height = _tmp16_;
		if (eventCrossing->detail == GDK_NOTIFY_NONLINEAR) {
			_tmp18_ = TRUE;
		} else {
			_tmp18_ = eventCrossing->detail == GDK_NOTIFY_NONLINEAR_VIRTUAL;
		}
		if (_tmp18_) {
			_tmp17_ = TRUE;
		} else {
			gboolean _tmp19_ = FALSE;
			DesktopFolderItemManager* _tmp20_;
			DesktopFolderFolderManager* _tmp21_;
			DesktopFolderFolderManager* _tmp22_;
			DesktopFolderFolderWindow* _tmp23_;
			DesktopFolderFolderWindow* _tmp24_;
			gboolean _tmp25_;
			_tmp20_ = self->priv->manager;
			_tmp21_ = desktop_folder_item_manager_get_folder (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = desktop_folder_folder_manager_get_view (_tmp22_);
			_tmp24_ = _tmp23_;
			_tmp25_ = !DESKTOP_FOLDER_IS_DESKTOP_WINDOW (_tmp24_);
			_g_object_unref0 (_tmp24_);
			_g_object_unref0 (_tmp22_);
			if (_tmp25_) {
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_ = FALSE;
				gboolean _tmp28_ = FALSE;
				GtkAllocation _tmp29_;
				_tmp29_ = allocation;
				if (_tmp29_.x < 0) {
					_tmp28_ = TRUE;
				} else {
					GtkAllocation _tmp30_;
					_tmp30_ = allocation;
					_tmp28_ = _tmp30_.y < 0;
				}
				if (_tmp28_) {
					_tmp27_ = TRUE;
				} else {
					GtkAllocation _tmp31_;
					_tmp31_ = allocation;
					_tmp27_ = _tmp31_.x > (window_width - DESKTOP_FOLDER_ICON_DEFAULT_WIDTH);
				}
				if (_tmp27_) {
					_tmp26_ = TRUE;
				} else {
					GtkAllocation _tmp32_;
					_tmp32_ = allocation;
					_tmp26_ = _tmp32_.y > (window_height - DESKTOP_FOLDER_ICON_DEFAULT_WIDTH);
				}
				_tmp19_ = _tmp26_;
			} else {
				_tmp19_ = FALSE;
			}
			_tmp17_ = _tmp19_;
		}
		if (_tmp17_) {
			desktop_folder_item_view_cancel_movement_and_start_drag_action (self, (GdkEvent*) eventCrossing);
		}
		_g_object_unref0 (window);
	} else {
		if (self->priv->flagModified) {
			DesktopFolderItemManager* _tmp33_;
			_tmp33_ = self->priv->manager;
			desktop_folder_item_manager_save_current_position (_tmp33_);
			self->priv->flagModified = FALSE;
		}
	}
	result = TRUE;
	return result;
}

/**
     * @name start_editing
     * @description action of rename the item selected by the user
     * @param string new_name the new name for this item
     */
void
desktop_folder_item_view_start_editing (DesktopFolderItemView* self)
{
	DesktopFolderEditableLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->label;
	desktop_folder_editable_label_start_editing (_tmp0_);
}

/**
     * @name select
     * @description the user select the icon
     */
void
desktop_folder_item_view_select_only (DesktopFolderItemView* self)
{
	GtkWindow* window = NULL;
	GtkWidget* _tmp0_;
	GtkWindow* _tmp1_;
	DesktopFolderItemManager* _tmp2_;
	GtkStyleContext* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow));
	window = _tmp1_;
	desktop_folder_folder_window_unselect_all (G_TYPE_CHECK_INSTANCE_CAST (window, DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow));
	_tmp2_ = self->priv->manager;
	desktop_folder_item_manager_select_only (_tmp2_);
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp3_, "df_selected");
	_g_object_unref0 (window);
}

void
desktop_folder_item_view_select_add (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	GtkStyleContext* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_select_add (_tmp0_);
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "df_selected");
}

/**
     * @name unselect
     * @description unselect the icon
     */
void
desktop_folder_item_view_unselect (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	GtkStyleContext* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_unselect (_tmp0_);
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_remove_class (_tmp1_, "df_selected");
}

/**
     * @name is_selected
     * @description check whether the item is selected or not
     * @return bool true->is selected
     */
gboolean
desktop_folder_item_view_is_selected (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->manager;
	result = desktop_folder_item_manager_is_selected (_tmp0_);
	return result;
}

/**
     * @name fade_in
     * @description fade the view in. does not call show
     */
void
desktop_folder_item_view_fade_in (DesktopFolderItemView* self)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_remove_class (_tmp0_, "df_fadeout");
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "df_fadein");
}

/**
     * @name fade_out
     * @description fade the view out. does not call hide
     */
void
desktop_folder_item_view_fade_out (DesktopFolderItemView* self)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_remove_class (_tmp0_, "df_fadein");
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "df_fadeout");
}

/**
     * @name on_release
     * @description the release button event
     * @param EventButton event the event produced
     * @return bool @see on_release signal
     */
static gboolean
desktop_folder_item_view_on_release (DesktopFolderItemView* self,
                                     GdkEventButton* event)
{
	GdkModifierType mods = 0U;
	gboolean control_pressed = FALSE;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkCursor* _tmp2_;
	GdkCursor* _tmp3_;
	DesktopFolderItemManager* _tmp4_;
	DesktopFolderFolderManager* _tmp5_;
	DesktopFolderFolderManager* _tmp6_;
	DesktopFolderFolderWindow* _tmp7_;
	DesktopFolderFolderWindow* _tmp8_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	mods = event->state & gtk_accelerator_get_default_mod_mask ();
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
	self->priv->flag_dragdrop_started = FALSE;
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = gdk_display_get_default ();
	_tmp2_ = gdk_cursor_new_from_name (_tmp1_, "default");
	_tmp3_ = _tmp2_;
	gdk_window_set_cursor (_tmp0_, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->manager;
	_tmp5_ = desktop_folder_item_manager_get_folder (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = desktop_folder_folder_manager_get_view (_tmp6_);
	_tmp8_ = _tmp7_;
	desktop_folder_folder_window_on_item_moving (_tmp8_, FALSE);
	_g_object_unref0 (_tmp8_);
	_g_object_unref0 (_tmp6_);
	if (!self->priv->flagMoved) {
		gboolean single_click = FALSE;
		DesktopFolderItemManager* _tmp9_;
		DesktopFolderFolderManager* _tmp10_;
		DesktopFolderFolderManager* _tmp11_;
		DesktopFolderApp* _tmp12_;
		DesktopFolderApp* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		_tmp9_ = self->priv->manager;
		_tmp10_ = desktop_folder_item_manager_get_folder (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = desktop_folder_folder_manager_get_application (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = desktop_folder_app_get_single_click (_tmp13_);
		_g_object_unref0 (_tmp13_);
		_g_object_unref0 (_tmp11_);
		single_click = _tmp14_;
		if (single_click) {
			_tmp17_ = !control_pressed;
		} else {
			_tmp17_ = FALSE;
		}
		if (_tmp17_) {
			_tmp16_ = event->type == GDK_BUTTON_RELEASE;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			_tmp15_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			desktop_folder_item_view_on_double_click (self);
		}
	} else {
		GtkAllocation allocation = {0};
		GtkAllocation _tmp18_ = {0};
		gint x = 0;
		GtkAllocation _tmp19_;
		gint y = 0;
		GtkAllocation _tmp20_;
		DesktopFolderFolderArrangement* arrangement = NULL;
		DesktopFolderItemManager* _tmp21_;
		DesktopFolderFolderManager* _tmp22_;
		DesktopFolderFolderManager* _tmp23_;
		DesktopFolderFolderArrangement* _tmp24_;
		DesktopFolderFolderArrangement* _tmp25_;
		gint sensitivity = 0;
		DesktopFolderFolderArrangement* _tmp26_;
		gint padding = 0;
		DesktopFolderItemManager* _tmp27_;
		DesktopFolderFolderManager* _tmp28_;
		DesktopFolderFolderManager* _tmp29_;
		DesktopFolderFolderSettings* _tmp30_;
		DesktopFolderFolderSettings* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		DesktopFolderItemManager* _tmp35_;
		DesktopFolderFolderManager* _tmp36_;
		DesktopFolderFolderManager* _tmp37_;
		DesktopFolderFolderArrangement* _tmp38_;
		DesktopFolderFolderArrangement* _tmp39_;
		gboolean _tmp40_;
		GtkWindow* window = NULL;
		GtkWidget* _tmp41_;
		GtkWindow* _tmp42_;
		GtkWindow* _tmp43_;
		gint diff_x = 0;
		GtkAllocation _tmp44_;
		gint diff_y = 0;
		GtkAllocation _tmp45_;
		DesktopFolderItemManager* _tmp46_;
		DesktopFolderFolderManager* _tmp47_;
		DesktopFolderFolderManager* _tmp48_;
		DesktopFolderFolderArrangement* _tmp49_;
		DesktopFolderFolderArrangement* _tmp50_;
		DesktopFolderItemSettings* my_settings = NULL;
		DesktopFolderItemManager* _tmp51_;
		DesktopFolderItemSettings* _tmp52_;
		DesktopFolderItemSettings* _tmp53_;
		DesktopFolderItemSettings* _tmp54_;
		DesktopFolderItemManager* _tmp55_;
		DesktopFolderItemSettings* _tmp56_;
		GeeList* selecteds = NULL;
		DesktopFolderItemManager* _tmp57_;
		DesktopFolderFolderManager* _tmp58_;
		DesktopFolderFolderManager* _tmp59_;
		GeeList* _tmp60_;
		GeeList* _tmp61_;
		self->priv->flagMoved = FALSE;
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp18_);
		allocation = _tmp18_;
		_tmp19_ = allocation;
		x = _tmp19_.x;
		_tmp20_ = allocation;
		y = _tmp20_.y;
		_tmp21_ = self->priv->manager;
		_tmp22_ = desktop_folder_item_manager_get_folder (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = desktop_folder_folder_manager_get_arrangement (_tmp23_);
		_tmp25_ = _tmp24_;
		_g_object_unref0 (_tmp23_);
		arrangement = _tmp25_;
		_tmp26_ = arrangement;
		sensitivity = desktop_folder_folder_arrangement_get_sensitivity (_tmp26_);
		_tmp27_ = self->priv->manager;
		_tmp28_ = desktop_folder_item_manager_get_folder (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = desktop_folder_folder_manager_get_settings (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = desktop_folder_folder_settings_get_arrangement_padding (_tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = _tmp33_;
		_g_object_unref0 (_tmp31_);
		_g_object_unref0 (_tmp29_);
		padding = _tmp34_;
		x = desktop_folder_item_view_RoundToNearestMultiple (MAX (MIN (x, self->priv->maxx), 0), sensitivity + padding);
		y = desktop_folder_item_view_RoundToNearestMultiple (MAX (MIN (y, self->priv->maxy), 0), sensitivity + padding);
		_tmp35_ = self->priv->manager;
		_tmp36_ = desktop_folder_item_manager_get_folder (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = desktop_folder_folder_manager_get_arrangement (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = desktop_folder_folder_arrangement_have_margin (_tmp39_);
		_g_object_unref0 (_tmp39_);
		_g_object_unref0 (_tmp37_);
		if (_tmp40_) {
			x = x + desktop_folder_folder_arrangement_DEFAULT_EXTERNAL_MARGIN;
		}
		_tmp41_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_window_get_type (), GtkWindow));
		window = _tmp42_;
		_tmp43_ = window;
		desktop_folder_folder_window_move_item (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow), self, x, y);
		_tmp44_ = allocation;
		diff_x = _tmp44_.x - x;
		_tmp45_ = allocation;
		diff_y = _tmp45_.y - y;
		_tmp46_ = self->priv->manager;
		_tmp47_ = desktop_folder_item_manager_get_folder (_tmp46_);
		_tmp48_ = _tmp47_;
		_tmp49_ = desktop_folder_folder_manager_get_arrangement (_tmp48_);
		_tmp50_ = _tmp49_;
		desktop_folder_folder_arrangement_end_drag (_tmp50_);
		_g_object_unref0 (_tmp50_);
		_g_object_unref0 (_tmp48_);
		_tmp51_ = self->priv->manager;
		_tmp52_ = desktop_folder_item_manager_get_settings (_tmp51_);
		my_settings = _tmp52_;
		_tmp53_ = my_settings;
		desktop_folder_item_settings_set_x (_tmp53_, x);
		_tmp54_ = my_settings;
		desktop_folder_item_settings_set_y (_tmp54_, y);
		_tmp55_ = self->priv->manager;
		_tmp56_ = my_settings;
		desktop_folder_item_manager_save_settings (_tmp55_, _tmp56_);
		_tmp57_ = self->priv->manager;
		_tmp58_ = desktop_folder_item_manager_get_folder (_tmp57_);
		_tmp59_ = _tmp58_;
		_tmp60_ = desktop_folder_folder_manager_get_selected_items (_tmp59_);
		_tmp61_ = _tmp60_;
		_g_object_unref0 (_tmp59_);
		selecteds = _tmp61_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp62_ = FALSE;
				_tmp62_ = TRUE;
				while (TRUE) {
					GeeList* _tmp64_;
					gint _tmp65_;
					gint _tmp66_;
					DesktopFolderItemView* selected = NULL;
					GeeList* _tmp67_;
					gpointer _tmp68_;
					DesktopFolderItemView* _tmp69_;
					if (!_tmp62_) {
						gint _tmp63_;
						_tmp63_ = i;
						i = _tmp63_ + 1;
					}
					_tmp62_ = FALSE;
					_tmp64_ = selecteds;
					_tmp65_ = gee_collection_get_size ((GeeCollection*) _tmp64_);
					_tmp66_ = _tmp65_;
					if (!(i < _tmp66_)) {
						break;
					}
					_tmp67_ = selecteds;
					_tmp68_ = gee_list_get (_tmp67_, i);
					selected = (DesktopFolderItemView*) _tmp68_;
					_tmp69_ = selected;
					if (_tmp69_ != self) {
						GtkAllocation allocation_selected = {0};
						DesktopFolderItemView* _tmp70_;
						GtkAllocation _tmp71_ = {0};
						gint sel_x = 0;
						GtkAllocation _tmp72_;
						gint sel_y = 0;
						GtkAllocation _tmp73_;
						GtkWindow* _tmp74_;
						DesktopFolderItemView* _tmp75_;
						DesktopFolderItemManager* _tmp76_;
						DesktopFolderFolderManager* _tmp77_;
						DesktopFolderFolderManager* _tmp78_;
						DesktopFolderFolderArrangement* _tmp79_;
						DesktopFolderFolderArrangement* _tmp80_;
						DesktopFolderItemView* _tmp81_;
						DesktopFolderItemManager* _tmp82_;
						DesktopFolderFolderManager* _tmp83_;
						DesktopFolderFolderManager* _tmp84_;
						DesktopFolderFolderArrangement* _tmp85_;
						DesktopFolderFolderArrangement* _tmp86_;
						DesktopFolderItemManager* _tmp87_;
						DesktopFolderFolderManager* _tmp88_;
						DesktopFolderFolderManager* _tmp89_;
						DesktopFolderFolderArrangement* _tmp90_;
						DesktopFolderFolderArrangement* _tmp91_;
						DesktopFolderItemSettings* sel_settings = NULL;
						DesktopFolderItemView* _tmp92_;
						DesktopFolderItemManager* _tmp93_;
						DesktopFolderItemSettings* _tmp94_;
						DesktopFolderItemSettings* _tmp95_;
						DesktopFolderItemSettings* _tmp96_;
						DesktopFolderItemView* _tmp97_;
						DesktopFolderItemManager* _tmp98_;
						DesktopFolderItemSettings* _tmp99_;
						_tmp70_ = selected;
						gtk_widget_get_allocation ((GtkWidget*) _tmp70_, &_tmp71_);
						allocation_selected = _tmp71_;
						_tmp72_ = allocation_selected;
						sel_x = _tmp72_.x - diff_x;
						_tmp73_ = allocation_selected;
						sel_y = _tmp73_.y - diff_y;
						_tmp74_ = window;
						_tmp75_ = selected;
						desktop_folder_folder_window_move_item (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow), _tmp75_, sel_x, sel_y);
						_tmp76_ = self->priv->manager;
						_tmp77_ = desktop_folder_item_manager_get_folder (_tmp76_);
						_tmp78_ = _tmp77_;
						_tmp79_ = desktop_folder_folder_manager_get_arrangement (_tmp78_);
						_tmp80_ = _tmp79_;
						_tmp81_ = selected;
						desktop_folder_folder_arrangement_start_drag (_tmp80_, _tmp81_);
						_g_object_unref0 (_tmp80_);
						_g_object_unref0 (_tmp78_);
						_tmp82_ = self->priv->manager;
						_tmp83_ = desktop_folder_item_manager_get_folder (_tmp82_);
						_tmp84_ = _tmp83_;
						_tmp85_ = desktop_folder_folder_manager_get_arrangement (_tmp84_);
						_tmp86_ = _tmp85_;
						desktop_folder_folder_arrangement_motion_drag (_tmp86_, sel_x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X, sel_y);
						_g_object_unref0 (_tmp86_);
						_g_object_unref0 (_tmp84_);
						_tmp87_ = self->priv->manager;
						_tmp88_ = desktop_folder_item_manager_get_folder (_tmp87_);
						_tmp89_ = _tmp88_;
						_tmp90_ = desktop_folder_folder_manager_get_arrangement (_tmp89_);
						_tmp91_ = _tmp90_;
						desktop_folder_folder_arrangement_end_drag (_tmp91_);
						_g_object_unref0 (_tmp91_);
						_g_object_unref0 (_tmp89_);
						_tmp92_ = selected;
						_tmp93_ = _tmp92_->priv->manager;
						_tmp94_ = desktop_folder_item_manager_get_settings (_tmp93_);
						sel_settings = _tmp94_;
						_tmp95_ = sel_settings;
						desktop_folder_item_settings_set_x (_tmp95_, sel_x);
						_tmp96_ = sel_settings;
						desktop_folder_item_settings_set_y (_tmp96_, sel_y);
						_tmp97_ = selected;
						_tmp98_ = _tmp97_->priv->manager;
						_tmp99_ = sel_settings;
						desktop_folder_item_manager_save_settings (_tmp98_, _tmp99_);
						_g_object_unref0 (sel_settings);
					}
					_g_object_unref0 (selected);
				}
			}
		}
		_g_object_unref0 (selecteds);
		_g_object_unref0 (my_settings);
		_g_object_unref0 (window);
		_g_object_unref0 (arrangement);
	}
	result = FALSE;
	return result;
}

/**
     * @name get_manager
     * @description return the manager of this view
     * @return {ItemManager} the manager
     */
DesktopFolderItemManager*
desktop_folder_item_view_get_manager (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderItemManager* _tmp1_;
	DesktopFolderItemManager* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
     * @name is_dragdrop_started
     * @description return whether the item has started a drag drop event
     * @return true -> yes, it was started, false otherwise
     */
gboolean
desktop_folder_item_view_is_dragdrop_started (DesktopFolderItemView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->flag_dragdrop_started;
	return result;
}

/**
     * @name on_drag_end
     * @description drag end event
     */
void
desktop_folder_item_view_on_drag_end (DesktopFolderItemView* self)
{
	g_return_if_fail (self != NULL);
	self->priv->flag_dragdrop_started = FALSE;
}

/**
     * @name on_press
     * @description the mouse press event captured
     * @param EventButton event the event produced
     * @return bool @see on_press signal
     */
static gboolean
desktop_folder_item_view_on_press (DesktopFolderItemView* self,
                                   GdkEventButton* event)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderWindow* _tmp3_;
	DesktopFolderFolderWindow* _tmp4_;
	GdkWindow* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkCursor* _tmp7_;
	GdkCursor* _tmp8_;
	GdkModifierType mods = 0U;
	gboolean control_pressed = FALSE;
	gboolean shift_pressed = FALSE;
	gboolean can_drag = FALSE;
	DesktopFolderItemManager* _tmp9_;
	DesktopFolderFolderManager* _tmp10_;
	DesktopFolderFolderManager* _tmp11_;
	DesktopFolderFolderArrangement* _tmp12_;
	DesktopFolderFolderArrangement* _tmp13_;
	gboolean _tmp14_;
	gboolean locked = FALSE;
	DesktopFolderItemManager* _tmp15_;
	DesktopFolderFolderManager* _tmp16_;
	DesktopFolderFolderManager* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->manager;
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = desktop_folder_folder_manager_get_view (_tmp2_);
	_tmp4_ = _tmp3_;
	gtk_window_present ((GtkWindow*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	_tmp5_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp6_ = gdk_display_get_default ();
	_tmp7_ = gdk_cursor_new_from_name (_tmp6_, "grabbing");
	_tmp8_ = _tmp7_;
	gdk_window_set_cursor (_tmp5_, _tmp8_);
	_g_object_unref0 (_tmp8_);
	mods = event->state & gtk_accelerator_get_default_mod_mask ();
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
	shift_pressed = (mods & GDK_SHIFT_MASK) != 0;
	_tmp9_ = self->priv->manager;
	_tmp10_ = desktop_folder_item_manager_get_folder (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = desktop_folder_folder_manager_get_arrangement (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = desktop_folder_folder_arrangement_can_drag (_tmp13_);
	_g_object_unref0 (_tmp13_);
	_g_object_unref0 (_tmp11_);
	can_drag = _tmp14_;
	_tmp15_ = self->priv->manager;
	_tmp16_ = desktop_folder_item_manager_get_folder (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = desktop_folder_folder_manager_are_items_locked (_tmp17_);
	_g_object_unref0 (_tmp17_);
	locked = _tmp18_;
	if (event->type == GDK_BUTTON_PRESS) {
		_tmp21_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
		if (control_pressed) {
			_tmp23_ = TRUE;
		} else {
			_tmp23_ = !can_drag;
		}
		if (_tmp23_) {
			_tmp22_ = TRUE;
		} else {
			_tmp22_ = locked;
		}
		_tmp20_ = _tmp22_;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		_tmp19_ = desktop_folder_item_view_is_selected (self);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		self->priv->flag_dragdrop_started = TRUE;
		result = FALSE;
		return result;
	}
	if (event->type == GDK_BUTTON_PRESS) {
		_tmp25_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		gboolean _tmp26_ = FALSE;
		if (control_pressed) {
			_tmp26_ = TRUE;
		} else {
			_tmp26_ = shift_pressed;
		}
		_tmp24_ = _tmp26_;
	} else {
		_tmp24_ = FALSE;
	}
	if (_tmp24_) {
		if (!desktop_folder_item_view_is_selected (self)) {
			desktop_folder_item_view_select_add (self);
		} else {
			desktop_folder_item_view_unselect (self);
		}
		result = FALSE;
		return result;
	}
	if (event->type == GDK_BUTTON_PRESS) {
		_tmp27_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
	} else {
		_tmp27_ = FALSE;
	}
	if (_tmp27_) {
		gboolean _tmp28_ = FALSE;
		DesktopFolderItemManager* _tmp29_;
		DesktopFolderFolderManager* _tmp30_;
		DesktopFolderFolderManager* _tmp31_;
		gboolean _tmp32_;
		if (!desktop_folder_item_view_is_selected (self)) {
			desktop_folder_item_view_select_only (self);
		}
		self->priv->flagMoved = FALSE;
		_tmp29_ = self->priv->manager;
		_tmp30_ = desktop_folder_item_manager_get_folder (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = !desktop_folder_folder_manager_are_items_locked (_tmp31_);
		_g_object_unref0 (_tmp31_);
		if (_tmp32_) {
			DesktopFolderItemManager* _tmp33_;
			DesktopFolderFolderManager* _tmp34_;
			DesktopFolderFolderManager* _tmp35_;
			DesktopFolderFolderArrangement* _tmp36_;
			DesktopFolderFolderArrangement* _tmp37_;
			_tmp33_ = self->priv->manager;
			_tmp34_ = desktop_folder_item_manager_get_folder (_tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = desktop_folder_folder_manager_get_arrangement (_tmp35_);
			_tmp37_ = _tmp36_;
			_tmp28_ = desktop_folder_folder_arrangement_can_drag (_tmp37_);
			_g_object_unref0 (_tmp37_);
			_g_object_unref0 (_tmp35_);
		} else {
			_tmp28_ = FALSE;
		}
		if (_tmp28_) {
			GeeList* selecteds = NULL;
			DesktopFolderItemManager* _tmp38_;
			DesktopFolderFolderManager* _tmp39_;
			DesktopFolderFolderManager* _tmp40_;
			GeeList* _tmp41_;
			GeeList* _tmp42_;
			GtkWidget* p = NULL;
			GtkContainer* _tmp64_;
			GtkContainer* _tmp65_;
			GtkWidget* _tmp66_;
			GtkWidget* _tmp67_;
			GdkWindow* _tmp68_;
			gint _tmp69_ = 0;
			gint _tmp70_ = 0;
			GdkWindow* _tmp71_;
			DesktopFolderEditableLabel* _tmp72_;
			GtkLabel* _tmp73_;
			GtkLabel* _tmp74_;
			GdkWindow* _tmp75_;
			DesktopFolderItemManager* _tmp81_;
			DesktopFolderFolderManager* _tmp82_;
			DesktopFolderFolderManager* _tmp83_;
			DesktopFolderFolderArrangement* _tmp84_;
			DesktopFolderFolderArrangement* _tmp85_;
			GtkAllocation pAllocation = {0};
			GtkWidget* _tmp86_;
			GtkAllocation _tmp87_ = {0};
			GtkAllocation thisAllocation = {0};
			GtkAllocation _tmp88_ = {0};
			GtkAllocation _tmp89_;
			GtkAllocation _tmp90_;
			DesktopFolderItemManager* _tmp91_;
			DesktopFolderFolderManager* _tmp92_;
			DesktopFolderFolderManager* _tmp93_;
			DesktopFolderFolderArrangement* _tmp94_;
			DesktopFolderFolderArrangement* _tmp95_;
			GtkAllocation _tmp96_;
			GtkAllocation _tmp97_;
			DesktopFolderItemManager* _tmp98_;
			DesktopFolderFolderManager* _tmp99_;
			DesktopFolderFolderManager* _tmp100_;
			DesktopFolderFolderArrangement* _tmp101_;
			DesktopFolderFolderArrangement* _tmp102_;
			_tmp38_ = self->priv->manager;
			_tmp39_ = desktop_folder_item_manager_get_folder (_tmp38_);
			_tmp40_ = _tmp39_;
			_tmp41_ = desktop_folder_folder_manager_get_selected_items (_tmp40_);
			_tmp42_ = _tmp41_;
			_g_object_unref0 (_tmp40_);
			selecteds = _tmp42_;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp43_ = FALSE;
					_tmp43_ = TRUE;
					while (TRUE) {
						GeeList* _tmp45_;
						gint _tmp46_;
						gint _tmp47_;
						DesktopFolderItemView* selected = NULL;
						GeeList* _tmp48_;
						gpointer _tmp49_;
						DesktopFolderItemView* _tmp50_;
						DesktopFolderItemView* _tmp51_;
						DesktopFolderItemManager* _tmp52_;
						DesktopFolderItemSettings* _tmp53_;
						DesktopFolderItemSettings* _tmp54_;
						gint _tmp55_;
						gint _tmp56_;
						DesktopFolderItemView* _tmp57_;
						DesktopFolderItemView* _tmp58_;
						DesktopFolderItemManager* _tmp59_;
						DesktopFolderItemSettings* _tmp60_;
						DesktopFolderItemSettings* _tmp61_;
						gint _tmp62_;
						gint _tmp63_;
						if (!_tmp43_) {
							gint _tmp44_;
							_tmp44_ = i;
							i = _tmp44_ + 1;
						}
						_tmp43_ = FALSE;
						_tmp45_ = selecteds;
						_tmp46_ = gee_collection_get_size ((GeeCollection*) _tmp45_);
						_tmp47_ = _tmp46_;
						if (!(i < _tmp47_)) {
							break;
						}
						_tmp48_ = selecteds;
						_tmp49_ = gee_list_get (_tmp48_, i);
						selected = (DesktopFolderItemView*) _tmp49_;
						_tmp50_ = selected;
						_tmp51_ = selected;
						_tmp52_ = _tmp51_->priv->manager;
						_tmp53_ = desktop_folder_item_manager_get_settings (_tmp52_);
						_tmp54_ = _tmp53_;
						_tmp55_ = desktop_folder_item_settings_get_x (_tmp54_);
						_tmp56_ = _tmp55_;
						_tmp50_->priv->start_drag_point.x = _tmp56_;
						_g_object_unref0 (_tmp54_);
						_tmp57_ = selected;
						_tmp58_ = selected;
						_tmp59_ = _tmp58_->priv->manager;
						_tmp60_ = desktop_folder_item_manager_get_settings (_tmp59_);
						_tmp61_ = _tmp60_;
						_tmp62_ = desktop_folder_item_settings_get_y (_tmp61_);
						_tmp63_ = _tmp62_;
						_tmp57_->priv->start_drag_point.y = _tmp63_;
						_g_object_unref0 (_tmp61_);
						_g_object_unref0 (selected);
					}
				}
			}
			_tmp64_ = gtk_widget_get_parent ((GtkWidget*) self);
			_tmp65_ = _tmp64_;
			_tmp66_ = _g_object_ref0 ((GtkWidget*) _tmp65_);
			p = _tmp66_;
			_tmp67_ = p;
			_tmp68_ = gtk_widget_get_window (_tmp67_);
			gdk_window_get_position (_tmp68_, &_tmp69_, &_tmp70_);
			self->priv->offsetx = _tmp69_;
			self->priv->offsety = _tmp70_;
			self->priv->offsetx = self->priv->offsetx + ((((gint) event->x) + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X) + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X);
			self->priv->offsety = self->priv->offsety + (((gint) event->y) + DESKTOP_FOLDER_ITEM_VIEW_PADDING_Y);
			_tmp71_ = event->window;
			_tmp72_ = self->priv->label;
			_tmp73_ = desktop_folder_editable_label_get_title_label (_tmp72_);
			_tmp74_ = _tmp73_;
			_tmp75_ = gtk_widget_get_window ((GtkWidget*) _tmp74_);
			if (_tmp71_ == _tmp75_) {
				gint my_x = 0;
				gint my_y = 0;
				DesktopFolderEditableLabel* _tmp76_;
				GtkLabel* _tmp77_;
				GtkLabel* _tmp78_;
				gint _tmp79_ = 0;
				gint _tmp80_ = 0;
				my_x = 0;
				my_y = 0;
				_tmp76_ = self->priv->label;
				_tmp77_ = desktop_folder_editable_label_get_title_label (_tmp76_);
				_tmp78_ = _tmp77_;
				gtk_widget_translate_coordinates ((GtkWidget*) self, (GtkWidget*) _tmp78_, (gint) event->x, (gint) event->y, &_tmp79_, &_tmp80_);
				my_x = _tmp79_;
				my_y = _tmp80_;
				self->priv->offsety = self->priv->offsety - my_y;
			}
			_tmp81_ = self->priv->manager;
			_tmp82_ = desktop_folder_item_manager_get_folder (_tmp81_);
			_tmp83_ = _tmp82_;
			_tmp84_ = desktop_folder_folder_manager_get_arrangement (_tmp83_);
			_tmp85_ = _tmp84_;
			desktop_folder_folder_arrangement_start_drag (_tmp85_, self);
			_g_object_unref0 (_tmp85_);
			_g_object_unref0 (_tmp83_);
			_tmp86_ = p;
			gtk_widget_get_allocation (_tmp86_, &_tmp87_);
			pAllocation = _tmp87_;
			gtk_widget_get_allocation ((GtkWidget*) self, &_tmp88_);
			thisAllocation = _tmp88_;
			_tmp89_ = pAllocation;
			_tmp90_ = thisAllocation;
			_tmp91_ = self->priv->manager;
			_tmp92_ = desktop_folder_item_manager_get_folder (_tmp91_);
			_tmp93_ = _tmp92_;
			_tmp94_ = desktop_folder_folder_manager_get_arrangement (_tmp93_);
			_tmp95_ = _tmp94_;
			self->priv->maxx = desktop_folder_item_view_RoundDownToMultiple (_tmp89_.width - _tmp90_.width, desktop_folder_folder_arrangement_get_sensitivity (_tmp95_));
			_g_object_unref0 (_tmp95_);
			_g_object_unref0 (_tmp93_);
			_tmp96_ = pAllocation;
			_tmp97_ = thisAllocation;
			_tmp98_ = self->priv->manager;
			_tmp99_ = desktop_folder_item_manager_get_folder (_tmp98_);
			_tmp100_ = _tmp99_;
			_tmp101_ = desktop_folder_folder_manager_get_arrangement (_tmp100_);
			_tmp102_ = _tmp101_;
			self->priv->maxy = desktop_folder_item_view_RoundDownToMultiple (_tmp96_.height - _tmp97_.height, desktop_folder_folder_arrangement_get_sensitivity (_tmp102_));
			_g_object_unref0 (_tmp102_);
			_g_object_unref0 (_tmp100_);
			_g_object_unref0 (p);
			_g_object_unref0 (selecteds);
		} else {
			result = TRUE;
			return result;
		}
	} else {
		if (event->type == GDK_2BUTTON_PRESS) {
			if (!desktop_folder_item_view_is_selected (self)) {
				desktop_folder_item_view_select_only (self);
			}
			desktop_folder_item_view_on_double_click (self);
		} else {
			gboolean _tmp103_ = FALSE;
			if (event->type == GDK_BUTTON_PRESS) {
				_tmp103_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
			} else {
				_tmp103_ = FALSE;
			}
			if (_tmp103_) {
				if (!desktop_folder_item_view_is_selected (self)) {
					desktop_folder_item_view_select_only (self);
				}
				desktop_folder_item_view_show_popup (self, event);
			}
		}
	}
	result = TRUE;
	return result;
}

/**
     * @name on_double_click
     * @description double click event captured
     */
static void
desktop_folder_item_view_on_double_click (DesktopFolderItemView* self)
{
	g_return_if_fail (self != NULL);
	desktop_folder_item_view_execute (self);
}

/**
     * @name execute
     * @description execute the action associated with the item
     */
void
desktop_folder_item_view_execute (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_execute (_tmp0_);
}

/**
     * @name show_popup
     * @description show the context popup for this item
     * @param EventButton event the event button that originates this context menu
     */
static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
	g_atomic_int_inc (&_data24_->_ref_count_);
	return _data24_;
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
		DesktopFolderItemView* self;
		self = _data24_->self;
		_g_free0 (_data24_->info_path);
		_g_free0 (_data24_->path);
		_g_object_unref0 (self);
		g_slice_free (Block24Data, _data24_);
	}
}

static void
__lambda109_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_execute (_tmp0_);
}

static void
___lambda109__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda109_ ((DesktopFolderItemView*) self, _sender);
}

static void
__lambda110_ (Block24Data* _data24_,
              GtkMenuItem* item)
{
	DesktopFolderItemView* self;
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
	self = _data24_->self;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = _data24_->path;
	desktop_folder_item_manager_openwith (_tmp0_, _tmp1_);
}

static void
___lambda110__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda110_ (self, _sender);
}

static void
__lambda111_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_cut (_tmp0_);
}

static void
___lambda111__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda111_ ((DesktopFolderItemView*) self, _sender);
}

static void
__lambda112_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_copy (_tmp0_);
}

static void
___lambda112__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda112_ ((DesktopFolderItemView*) self, _sender);
}

static void
__lambda113_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderEditableLabel* _tmp0_;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->label;
	desktop_folder_editable_label_start_editing (_tmp0_);
}

static void
___lambda113__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda113_ ((DesktopFolderItemView*) self, _sender);
}

static void
__lambda114_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_trash_selected (_tmp0_);
}

static void
___lambda114__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda114_ ((DesktopFolderItemView*) self, _sender);
}

static void
__lambda115_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	g_return_if_fail (item != NULL);
	desktop_folder_item_view_change_icon (self);
}

static void
___lambda115__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda115_ ((DesktopFolderItemView*) self, _sender);
}

static void
__lambda116_ (Block24Data* _data24_,
              GtkMenuItem* item)
{
	DesktopFolderItemView* self;
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
	self = _data24_->self;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = _data24_->info_path;
	desktop_folder_item_manager_show_info (_tmp0_, _tmp1_);
}

static void
___lambda116__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	__lambda116_ (self, _sender);
}

static void
___lambda117_ (Block24Data* _data24_,
               GtkMenuItem* item)
{
	DesktopFolderItemView* self;
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
	self = _data24_->self;
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = _data24_->path;
	desktop_folder_item_manager_open_in_terminal (_tmp0_, _tmp1_);
}

static void
____lambda117__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
	___lambda117_ (self, _sender);
}

static void
desktop_folder_item_view_show_popup (DesktopFolderItemView* self,
                                     GdkEventButton* event)
{
	Block24Data* _data24_;
	GtkMenu* _tmp0_;
	gchar* label = NULL;
	gchar* _tmp1_;
	DesktopFolderItemManager* _tmp2_;
	GtkMenuItem* item = NULL;
	const gchar* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	DesktopFolderItemManager* _tmp11_;
	gchar* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenuItem* _tmp16_;
	DesktopFolderMenuItemSeparator* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenu* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenu* _tmp24_;
	GtkMenuItem* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenuItem* _tmp28_;
	GtkMenu* _tmp29_;
	GtkMenuItem* _tmp30_;
	DesktopFolderMenuItemSeparator* _tmp31_;
	GtkMenuItem* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenuItem* _tmp34_;
	GtkMenuItem* _tmp35_;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GtkMenu* _tmp38_;
	GtkMenuItem* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenuItem* _tmp41_;
	GtkMenuItem* _tmp42_;
	GtkMenu* _tmp43_;
	GtkMenuItem* _tmp44_;
	GtkMenuItem* _tmp45_;
	GtkMenuItem* _tmp46_;
	GtkMenuItem* _tmp47_;
	GtkMenu* _tmp48_;
	GtkMenuItem* _tmp49_;
	DesktopFolderMenuItemSeparator* _tmp50_;
	GtkMenuItem* _tmp51_;
	GtkMenu* _tmp52_;
	GtkMenuItem* _tmp53_;
	GtkMenuItem* _tmp54_;
	DesktopFolderItemManager* _tmp55_;
	gchar* _tmp56_;
	GtkMenuItem* _tmp57_;
	GtkMenuItem* _tmp58_;
	GtkMenu* _tmp59_;
	GtkMenuItem* _tmp60_;
	DesktopFolderItemManager* _tmp61_;
	GtkMenu* _tmp71_;
	GtkMenu* _tmp72_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	_data24_ = g_slice_new0 (Block24Data);
	_data24_->_ref_count_ = 1;
	_data24_->self = g_object_ref (self);
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->menu);
	self->priv->menu = _tmp0_;
	_tmp1_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN);
	label = _tmp1_;
	_tmp2_ = self->priv->manager;
	if (desktop_folder_item_manager_is_executable (_tmp2_)) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_MENU_EXECUTE);
		_g_free0 (label);
		label = _tmp3_;
	}
	_tmp4_ = label;
	_tmp5_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp4_);
	g_object_ref_sink (_tmp5_);
	item = _tmp5_;
	_tmp6_ = item;
	g_signal_connect_object (_tmp6_, "activate", (GCallback) ___lambda109__gtk_menu_item_activate, self, 0);
	_tmp7_ = item;
	gtk_widget_show ((GtkWidget*) _tmp7_);
	_tmp8_ = self->priv->menu;
	_tmp9_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, _tmp9_);
	_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN_WITH);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (item);
	item = _tmp10_;
	_tmp11_ = self->priv->manager;
	_tmp12_ = desktop_folder_item_manager_get_absolute_path (_tmp11_);
	_data24_->path = _tmp12_;
	_tmp13_ = item;
	g_signal_connect_data (_tmp13_, "activate", (GCallback) ___lambda110__gtk_menu_item_activate, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
	_tmp14_ = item;
	gtk_widget_show ((GtkWidget*) _tmp14_);
	_tmp15_ = self->priv->menu;
	_tmp16_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp15_, _tmp16_);
	_tmp17_ = desktop_folder_menu_item_separator_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (item);
	item = (GtkMenuItem*) _tmp17_;
	_tmp18_ = item;
	gtk_widget_show ((GtkWidget*) _tmp18_);
	_tmp19_ = self->priv->menu;
	_tmp20_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, _tmp20_);
	_tmp21_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_CUT);
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (item);
	item = _tmp21_;
	_tmp22_ = item;
	g_signal_connect_object (_tmp22_, "activate", (GCallback) ___lambda111__gtk_menu_item_activate, self, 0);
	_tmp23_ = item;
	gtk_widget_show ((GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->menu;
	_tmp25_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, _tmp25_);
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_COPY);
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (item);
	item = _tmp26_;
	_tmp27_ = item;
	g_signal_connect_object (_tmp27_, "activate", (GCallback) ___lambda112__gtk_menu_item_activate, self, 0);
	_tmp28_ = item;
	gtk_widget_show ((GtkWidget*) _tmp28_);
	_tmp29_ = self->priv->menu;
	_tmp30_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp29_, _tmp30_);
	_tmp31_ = desktop_folder_menu_item_separator_new ();
	g_object_ref_sink (_tmp31_);
	_g_object_unref0 (item);
	item = (GtkMenuItem*) _tmp31_;
	_tmp32_ = item;
	gtk_widget_show ((GtkWidget*) _tmp32_);
	_tmp33_ = self->priv->menu;
	_tmp34_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp33_, _tmp34_);
	_tmp35_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_RENAME);
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (item);
	item = _tmp35_;
	_tmp36_ = item;
	g_signal_connect_object (_tmp36_, "activate", (GCallback) ___lambda113__gtk_menu_item_activate, self, 0);
	_tmp37_ = item;
	gtk_widget_show ((GtkWidget*) _tmp37_);
	_tmp38_ = self->priv->menu;
	_tmp39_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp38_, _tmp39_);
	_tmp40_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_TRASH);
	g_object_ref_sink (_tmp40_);
	_g_object_unref0 (item);
	item = _tmp40_;
	_tmp41_ = item;
	g_signal_connect_object (_tmp41_, "activate", (GCallback) ___lambda114__gtk_menu_item_activate, self, 0);
	_tmp42_ = item;
	gtk_widget_show ((GtkWidget*) _tmp42_);
	_tmp43_ = self->priv->menu;
	_tmp44_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp43_, _tmp44_);
	_tmp45_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_CHANGEICON);
	g_object_ref_sink (_tmp45_);
	_g_object_unref0 (item);
	item = _tmp45_;
	_tmp46_ = item;
	g_signal_connect_object (_tmp46_, "activate", (GCallback) ___lambda115__gtk_menu_item_activate, self, 0);
	_tmp47_ = item;
	gtk_widget_show ((GtkWidget*) _tmp47_);
	_tmp48_ = self->priv->menu;
	_tmp49_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp48_, _tmp49_);
	_tmp50_ = desktop_folder_menu_item_separator_new ();
	g_object_ref_sink (_tmp50_);
	_g_object_unref0 (item);
	item = (GtkMenuItem*) _tmp50_;
	_tmp51_ = item;
	gtk_widget_show ((GtkWidget*) _tmp51_);
	_tmp52_ = self->priv->menu;
	_tmp53_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp52_, _tmp53_);
	_tmp54_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILEINFO);
	g_object_ref_sink (_tmp54_);
	_g_object_unref0 (item);
	item = _tmp54_;
	_tmp55_ = self->priv->manager;
	_tmp56_ = desktop_folder_item_manager_get_absolute_path (_tmp55_);
	_data24_->info_path = _tmp56_;
	_tmp57_ = item;
	g_signal_connect_data (_tmp57_, "activate", (GCallback) ___lambda116__gtk_menu_item_activate, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
	_tmp58_ = item;
	gtk_widget_show ((GtkWidget*) _tmp58_);
	_tmp59_ = self->priv->menu;
	_tmp60_ = item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp59_, _tmp60_);
	_tmp61_ = self->priv->manager;
	if (desktop_folder_dragn_drop_dnd_view_is_folder ((DesktopFolderDragnDropDndView*) _tmp61_)) {
		DesktopFolderMenuItemSeparator* _tmp62_;
		GtkMenuItem* _tmp63_;
		GtkMenu* _tmp64_;
		GtkMenuItem* _tmp65_;
		GtkMenuItem* _tmp66_;
		GtkMenuItem* _tmp67_;
		GtkMenuItem* _tmp68_;
		GtkMenu* _tmp69_;
		GtkMenuItem* _tmp70_;
		_tmp62_ = desktop_folder_menu_item_separator_new ();
		g_object_ref_sink (_tmp62_);
		_g_object_unref0 (item);
		item = (GtkMenuItem*) _tmp62_;
		_tmp63_ = item;
		gtk_widget_show ((GtkWidget*) _tmp63_);
		_tmp64_ = self->priv->menu;
		_tmp65_ = item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp64_, _tmp65_);
		_tmp66_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_OPEN_IN_TERMINAL);
		g_object_ref_sink (_tmp66_);
		_g_object_unref0 (item);
		item = _tmp66_;
		_tmp67_ = item;
		g_signal_connect_data (_tmp67_, "activate", (GCallback) ____lambda117__gtk_menu_item_activate, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
		_tmp68_ = item;
		gtk_widget_show ((GtkWidget*) _tmp68_);
		_tmp69_ = self->priv->menu;
		_tmp70_ = item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp69_, _tmp70_);
	}
	_tmp71_ = self->priv->menu;
	gtk_widget_show_all ((GtkWidget*) _tmp71_);
	_tmp72_ = self->priv->menu;
	gtk_menu_popup_at_pointer (_tmp72_, NULL);
	_g_object_unref0 (item);
	_g_free0 (label);
	block24_data_unref (_data24_);
	_data24_ = NULL;
}

/**
     * @name cut
     * @description cut the file to the clipboard
     */
void
desktop_folder_item_view_cut (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_cut (_tmp0_);
}

/**
     * @name copy
     * @description copy the file to the clipboard
     */
void
desktop_folder_item_view_copy (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_copy (_tmp0_);
}

/**
     * @name copy
     * @description copy the file to the clipboard
     */
void
desktop_folder_item_view_trash (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	desktop_folder_item_manager_trash (_tmp0_);
}

/**
     * @name delete_dialog
     * @description the user wants to delete the item. It should be confirmed before the deletion occurs
     */
static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
	g_atomic_int_inc (&_data25_->_ref_count_);
	return _data25_;
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
		DesktopFolderItemView* self;
		self = _data25_->self;
		_g_object_unref0 (_data25_->msg);
		_g_object_unref0 (self);
		g_slice_free (Block25Data, _data25_);
	}
}

static void
__lambda121_ (Block25Data* _data25_,
              gint response_id)
{
	DesktopFolderItemView* self;
	self = _data25_->self;
	switch (response_id) {
		case GTK_RESPONSE_OK:
		{
			gtk_widget_destroy ((GtkWidget*) _data25_->msg);
			if (_data25_->isdir) {
				DesktopFolderItemManager* _tmp0_;
				_tmp0_ = self->priv->manager;
				desktop_folder_item_manager_trash (_tmp0_);
				break;
			} else {
				DesktopFolderItemManager* _tmp1_;
				_tmp1_ = self->priv->manager;
				desktop_folder_item_manager_trash (_tmp1_);
			}
			break;
		}
		default:
		{
			gtk_widget_destroy ((GtkWidget*) _data25_->msg);
			break;
		}
	}
}

static void
___lambda121__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
	__lambda121_ (self, response_id);
}

void
desktop_folder_item_view_delete_dialog (DesktopFolderItemView* self)
{
	Block25Data* _data25_;
	gchar* message = NULL;
	gchar* _tmp0_;
	GtkWindow* window = NULL;
	GtkWidget* _tmp1_;
	GtkWindow* _tmp2_;
	DesktopFolderItemManager* _tmp3_;
	DesktopFolderItemManager* _tmp5_;
	GtkWindow* _tmp7_;
	const gchar* _tmp8_;
	GtkMessageDialog* _tmp9_;
	g_return_if_fail (self != NULL);
	_data25_ = g_slice_new0 (Block25Data);
	_data25_->_ref_count_ = 1;
	_data25_->self = g_object_ref (self);
	_tmp0_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_DELETE_FOLDER_MESSAGE);
	message = _tmp0_;
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
	window = _tmp2_;
	_tmp3_ = self->priv->manager;
	_data25_->isdir = desktop_folder_dragn_drop_dnd_view_is_folder ((DesktopFolderDragnDropDndView*) _tmp3_);
	if (!_data25_->isdir) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_DELETE_FILE_MESSAGE);
		_g_free0 (message);
		message = _tmp4_;
	}
	_tmp5_ = self->priv->manager;
	if (desktop_folder_item_manager_is_link (_tmp5_)) {
		gchar* _tmp6_;
		_tmp6_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_DELETE_LINK_MESSAGE);
		_g_free0 (message);
		message = _tmp6_;
	}
	_tmp7_ = window;
	_tmp8_ = message;
	_tmp9_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp7_, GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK_CANCEL, "%s", _tmp8_);
	g_object_ref_sink (_tmp9_);
	_data25_->msg = _tmp9_;
	g_object_set (_data25_->msg, "use-markup", TRUE, NULL);
	g_signal_connect_data ((GtkDialog*) _data25_->msg, "response", (GCallback) ___lambda121__gtk_dialog_response, block25_data_ref (_data25_), (GClosureNotify) block25_data_unref, 0);
	gtk_widget_show ((GtkWidget*) _data25_->msg);
	_g_object_unref0 (window);
	_g_free0 (message);
	block25_data_unref (_data25_);
	_data25_ = NULL;
}

/**
     * @name change_icon
     * @description change the icon of an executable item
     */
static void
desktop_folder_item_view_change_icon (DesktopFolderItemView* self)
{
	GtkFileChooserDialog* chooser = NULL;
	DesktopFolderItemManager* _tmp0_;
	GtkApplicationWindow* _tmp1_;
	GtkApplicationWindow* _tmp2_;
	GtkFileChooserDialog* _tmp3_;
	GtkFileChooserDialog* _tmp4_;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* _tmp6_;
	GtkFileFilter* _tmp7_;
	GtkFileFilter* _tmp8_;
	GtkFileFilter* _tmp9_;
	GtkFileFilter* _tmp10_;
	GtkFileFilter* _tmp11_;
	GtkFileFilter* _tmp12_;
	GtkFileFilter* _tmp13_;
	GtkFileFilter* _tmp14_;
	GtkFileFilter* _tmp15_;
	GtkFileFilter* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileChooserDialog* _tmp18_;
	GtkFileFilter* _tmp19_;
	GtkFileFilter* _tmp20_;
	GtkFileChooserDialog* _tmp21_;
	GtkFileChooserDialog* _tmp26_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = desktop_folder_dragn_drop_dnd_view_get_application_window ((DesktopFolderDragnDropDndView*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (DESKTOP_FOLDER_LANG_ITEM_CHANGEICON_MESSAGE, (GtkWindow*) _tmp2_, GTK_FILE_CHOOSER_ACTION_OPEN, DESKTOP_FOLDER_LANG_DIALOG_CANCEL, GTK_RESPONSE_CANCEL, DESKTOP_FOLDER_LANG_DIALOG_SELECT, GTK_RESPONSE_ACCEPT, NULL);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	chooser = _tmp4_;
	_tmp5_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp5_);
	filter = _tmp5_;
	_tmp6_ = filter;
	gtk_buildable_set_name ((GtkBuildable*) _tmp6_, "Images");
	_tmp7_ = filter;
	gtk_file_filter_add_mime_type (_tmp7_, "image");
	_tmp8_ = filter;
	gtk_file_filter_add_mime_type (_tmp8_, "image/png");
	_tmp9_ = filter;
	gtk_file_filter_add_mime_type (_tmp9_, "image/jpeg");
	_tmp10_ = filter;
	gtk_file_filter_add_mime_type (_tmp10_, "image/gif");
	_tmp11_ = filter;
	gtk_file_filter_add_mime_type (_tmp11_, "image/svg+xml");
	_tmp12_ = filter;
	gtk_file_filter_add_pattern (_tmp12_, "*.png");
	_tmp13_ = filter;
	gtk_file_filter_add_pattern (_tmp13_, "*.jpg");
	_tmp14_ = filter;
	gtk_file_filter_add_pattern (_tmp14_, "*.svg");
	_tmp15_ = filter;
	gtk_file_filter_add_pattern (_tmp15_, "*.gif");
	_tmp16_ = filter;
	gtk_file_filter_add_pattern (_tmp16_, "*.tif");
	_tmp17_ = filter;
	gtk_file_filter_add_pattern (_tmp17_, "*.xpm");
	_tmp18_ = chooser;
	_tmp19_ = filter;
	_tmp20_ = _g_object_ref0 (_tmp19_);
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp18_, _tmp20_);
	_tmp21_ = chooser;
	if (gtk_dialog_run ((GtkDialog*) _tmp21_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		gchar* filename = NULL;
		GtkFileChooserDialog* _tmp22_;
		gchar* _tmp23_;
		DesktopFolderItemManager* _tmp24_;
		const gchar* _tmp25_;
		_tmp22_ = chooser;
		_tmp23_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp22_);
		filename = _tmp23_;
		_tmp24_ = self->priv->manager;
		_tmp25_ = filename;
		desktop_folder_item_manager_change_icon (_tmp24_, _tmp25_);
		_g_free0 (filename);
	}
	_tmp26_ = chooser;
	g_signal_emit_by_name ((GtkDialog*) _tmp26_, "close");
	_g_object_unref0 (filter);
	_g_object_unref0 (chooser);
}

/**
     * @name modify
     * @description raise the flat modify
     */
void
desktop_folder_item_view_modify (DesktopFolderItemView* self)
{
	g_return_if_fail (self != NULL);
	self->priv->flagModified = TRUE;
}

void
desktop_folder_item_view_get_bounding_box (DesktopFolderItemView* self,
                                           GdkRectangle* result)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	g_return_if_fail (self != NULL);
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
	allocation = _tmp0_;
	_tmp1_ = allocation;
	allocation.y = _tmp1_.y + DESKTOP_FOLDER_ITEM_VIEW_PADDING_Y;
	_tmp2_ = allocation;
	allocation.x = _tmp2_.x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X;
	*result = allocation;
	return;
}

/**
     * @name on_motion
     * @description the on_motion event captured to allow the movement of the icon
     * @param EventMotion event @see the on_motion signal
     * @return bool @see the on_motion signal
     */
static gboolean
desktop_folder_item_view_on_motion (DesktopFolderItemView* self,
                                    GdkEventMotion* event)
{
	gboolean _tmp0_ = FALSE;
	DesktopFolderItemManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderManager* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = self->priv->manager;
	_tmp2_ = desktop_folder_item_manager_get_folder (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = !desktop_folder_folder_manager_are_items_locked (_tmp3_);
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		DesktopFolderItemManager* _tmp5_;
		DesktopFolderFolderManager* _tmp6_;
		DesktopFolderFolderManager* _tmp7_;
		DesktopFolderFolderArrangement* _tmp8_;
		DesktopFolderFolderArrangement* _tmp9_;
		_tmp5_ = self->priv->manager;
		_tmp6_ = desktop_folder_item_manager_get_folder (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = desktop_folder_folder_manager_get_arrangement (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp0_ = desktop_folder_folder_arrangement_can_drag (_tmp9_);
		_g_object_unref0 (_tmp9_);
		_g_object_unref0 (_tmp7_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		DesktopFolderEditableLabel* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		GdkModifierType mods = 0U;
		gboolean control_pressed = FALSE;
		gint x = 0;
		gint y = 0;
		DesktopFolderFolderSettings* folder_settings = NULL;
		DesktopFolderItemManager* _tmp18_;
		DesktopFolderFolderManager* _tmp19_;
		DesktopFolderFolderManager* _tmp20_;
		DesktopFolderFolderSettings* _tmp21_;
		DesktopFolderFolderSettings* _tmp22_;
		DesktopFolderFolderSettings* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		DesktopFolderFolderSettings* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		GdkRectangle icon_rectangle = {0};
		gint qwidth = 0;
		GeeList* ims = NULL;
		DesktopFolderItemManager* _tmp29_;
		DesktopFolderFolderManager* _tmp30_;
		DesktopFolderFolderManager* _tmp31_;
		GdkRectangle _tmp32_;
		GeeList* _tmp33_;
		GeeList* _tmp34_;
		gboolean _tmp50_ = FALSE;
		_tmp10_ = self->priv->label;
		_tmp11_ = desktop_folder_editable_label_get_editing (_tmp10_);
		_tmp12_ = _tmp11_;
		if (_tmp12_) {
			result = FALSE;
			return result;
		}
		mods = event->state & gtk_accelerator_get_default_mod_mask ();
		control_pressed = (mods & GDK_CONTROL_MASK) != 0;
		if (control_pressed) {
			result = FALSE;
			return result;
		}
		self->priv->flagModified = TRUE;
		if (!self->priv->flagMoved) {
			DesktopFolderItemManager* _tmp13_;
			DesktopFolderFolderManager* _tmp14_;
			DesktopFolderFolderManager* _tmp15_;
			DesktopFolderFolderWindow* _tmp16_;
			DesktopFolderFolderWindow* _tmp17_;
			_tmp13_ = self->priv->manager;
			_tmp14_ = desktop_folder_item_manager_get_folder (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = desktop_folder_folder_manager_get_view (_tmp15_);
			_tmp17_ = _tmp16_;
			desktop_folder_folder_window_on_item_moving (_tmp17_, TRUE);
			_g_object_unref0 (_tmp17_);
			_g_object_unref0 (_tmp15_);
			self->priv->flagMoved = TRUE;
		}
		x = ((gint) event->x_root) - self->priv->offsetx;
		y = ((gint) event->y_root) - self->priv->offsety;
		_tmp18_ = self->priv->manager;
		_tmp19_ = desktop_folder_item_manager_get_folder (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = desktop_folder_folder_manager_get_settings (_tmp20_);
		_tmp22_ = _tmp21_;
		_g_object_unref0 (_tmp20_);
		folder_settings = _tmp22_;
		_tmp23_ = folder_settings;
		_tmp24_ = desktop_folder_position_settings_get_x ((DesktopFolderPositionSettings*) _tmp23_);
		_tmp25_ = _tmp24_;
		x = (x - _tmp25_) + DESKTOP_FOLDER_WINDOW_DECORATION_MARGIN;
		_tmp26_ = folder_settings;
		_tmp27_ = desktop_folder_position_settings_get_y ((DesktopFolderPositionSettings*) _tmp26_);
		_tmp28_ = _tmp27_;
		y = (y - _tmp28_) + DESKTOP_FOLDER_WINDOW_DECORATION_MARGIN;
		memset (&icon_rectangle, 0, sizeof (GdkRectangle));
		qwidth = DESKTOP_FOLDER_ICON_DEFAULT_WIDTH / 2;
		icon_rectangle.x = x + qwidth;
		icon_rectangle.y = y + qwidth;
		icon_rectangle.width = DESKTOP_FOLDER_ICON_DEFAULT_WIDTH - qwidth;
		icon_rectangle.height = DESKTOP_FOLDER_ICON_DEFAULT_WIDTH - qwidth;
		_tmp29_ = self->priv->manager;
		_tmp30_ = desktop_folder_item_manager_get_folder (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = icon_rectangle;
		_tmp33_ = desktop_folder_folder_manager_get_items_at (_tmp31_, &_tmp32_);
		_tmp34_ = _tmp33_;
		_g_object_unref0 (_tmp31_);
		ims = _tmp34_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp35_ = FALSE;
				_tmp35_ = TRUE;
				while (TRUE) {
					GeeList* _tmp37_;
					gint _tmp38_;
					gint _tmp39_;
					DesktopFolderItemManager* im = NULL;
					GeeList* _tmp40_;
					gpointer _tmp41_;
					gboolean _tmp42_ = FALSE;
					gboolean _tmp43_ = FALSE;
					gboolean _tmp44_ = FALSE;
					DesktopFolderItemManager* _tmp45_;
					if (!_tmp35_) {
						gint _tmp36_;
						_tmp36_ = i;
						i = _tmp36_ + 1;
					}
					_tmp35_ = FALSE;
					_tmp37_ = ims;
					_tmp38_ = gee_collection_get_size ((GeeCollection*) _tmp37_);
					_tmp39_ = _tmp38_;
					if (!(i < _tmp39_)) {
						break;
					}
					_tmp40_ = ims;
					_tmp41_ = gee_list_get (_tmp40_, i);
					im = (DesktopFolderItemManager*) _tmp41_;
					_tmp45_ = im;
					if (_tmp45_ != NULL) {
						DesktopFolderItemManager* _tmp46_;
						DesktopFolderItemManager* _tmp47_;
						_tmp46_ = im;
						_tmp47_ = self->priv->manager;
						_tmp44_ = _tmp46_ != _tmp47_;
					} else {
						_tmp44_ = FALSE;
					}
					if (_tmp44_) {
						DesktopFolderItemManager* _tmp48_;
						_tmp48_ = im;
						_tmp43_ = desktop_folder_dragn_drop_dnd_view_is_folder ((DesktopFolderDragnDropDndView*) _tmp48_);
					} else {
						_tmp43_ = FALSE;
					}
					if (_tmp43_) {
						DesktopFolderItemManager* _tmp49_;
						_tmp49_ = im;
						_tmp42_ = !desktop_folder_item_manager_is_selected (_tmp49_);
					} else {
						_tmp42_ = FALSE;
					}
					if (_tmp42_) {
						desktop_folder_item_view_cancel_movement_and_start_drag_action (self, (GdkEvent*) event);
						_g_object_unref0 (im);
						break;
					}
					_g_object_unref0 (im);
				}
			}
		}
		if (x != self->priv->px) {
			_tmp50_ = TRUE;
		} else {
			_tmp50_ = y != self->priv->py;
		}
		if (_tmp50_) {
			GtkAllocation allocation0 = {0};
			GtkAllocation _tmp51_ = {0};
			DesktopFolderFolderWindow* window = NULL;
			DesktopFolderItemManager* _tmp52_;
			DesktopFolderFolderManager* _tmp53_;
			DesktopFolderFolderManager* _tmp54_;
			DesktopFolderFolderWindow* _tmp55_;
			DesktopFolderFolderWindow* _tmp56_;
			DesktopFolderFolderWindow* _tmp57_;
			gint diff_x = 0;
			GtkAllocation _tmp58_;
			gint diff_y = 0;
			GtkAllocation _tmp59_;
			GeeList* selecteds = NULL;
			DesktopFolderItemManager* _tmp60_;
			DesktopFolderFolderManager* _tmp61_;
			DesktopFolderFolderManager* _tmp62_;
			GeeList* _tmp63_;
			GeeList* _tmp64_;
			DesktopFolderItemManager* _tmp79_;
			DesktopFolderFolderManager* _tmp80_;
			DesktopFolderFolderManager* _tmp81_;
			DesktopFolderFolderArrangement* _tmp82_;
			DesktopFolderFolderArrangement* _tmp83_;
			self->priv->px = x;
			self->priv->py = y;
			gtk_widget_get_allocation ((GtkWidget*) self, &_tmp51_);
			allocation0 = _tmp51_;
			_tmp52_ = self->priv->manager;
			_tmp53_ = desktop_folder_item_manager_get_folder (_tmp52_);
			_tmp54_ = _tmp53_;
			_tmp55_ = desktop_folder_folder_manager_get_view (_tmp54_);
			_tmp56_ = _tmp55_;
			_g_object_unref0 (_tmp54_);
			window = _tmp56_;
			_tmp57_ = window;
			desktop_folder_folder_window_move_item (_tmp57_, self, x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X, y);
			_tmp58_ = allocation0;
			diff_x = _tmp58_.x - (x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X);
			_tmp59_ = allocation0;
			diff_y = _tmp59_.y - y;
			_tmp60_ = self->priv->manager;
			_tmp61_ = desktop_folder_item_manager_get_folder (_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp63_ = desktop_folder_folder_manager_get_selected_items (_tmp62_);
			_tmp64_ = _tmp63_;
			_g_object_unref0 (_tmp62_);
			selecteds = _tmp64_;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp65_ = FALSE;
					_tmp65_ = TRUE;
					while (TRUE) {
						GeeList* _tmp67_;
						gint _tmp68_;
						gint _tmp69_;
						DesktopFolderItemView* selected = NULL;
						GeeList* _tmp70_;
						gpointer _tmp71_;
						DesktopFolderItemView* _tmp72_;
						if (!_tmp65_) {
							gint _tmp66_;
							_tmp66_ = i;
							i = _tmp66_ + 1;
						}
						_tmp65_ = FALSE;
						_tmp67_ = selecteds;
						_tmp68_ = gee_collection_get_size ((GeeCollection*) _tmp67_);
						_tmp69_ = _tmp68_;
						if (!(i < _tmp69_)) {
							break;
						}
						_tmp70_ = selecteds;
						_tmp71_ = gee_list_get (_tmp70_, i);
						selected = (DesktopFolderItemView*) _tmp71_;
						_tmp72_ = selected;
						if (_tmp72_ != self) {
							GtkAllocation allocation = {0};
							DesktopFolderItemView* _tmp73_;
							GtkAllocation _tmp74_ = {0};
							DesktopFolderFolderWindow* _tmp75_;
							DesktopFolderItemView* _tmp76_;
							GtkAllocation _tmp77_;
							GtkAllocation _tmp78_;
							_tmp73_ = selected;
							gtk_widget_get_allocation ((GtkWidget*) _tmp73_, &_tmp74_);
							allocation = _tmp74_;
							_tmp75_ = window;
							_tmp76_ = selected;
							_tmp77_ = allocation;
							_tmp78_ = allocation;
							desktop_folder_folder_window_move_item (_tmp75_, _tmp76_, _tmp77_.x - diff_x, _tmp78_.y - diff_y);
						}
						_g_object_unref0 (selected);
					}
				}
			}
			_tmp79_ = self->priv->manager;
			_tmp80_ = desktop_folder_item_manager_get_folder (_tmp79_);
			_tmp81_ = _tmp80_;
			_tmp82_ = desktop_folder_folder_manager_get_arrangement (_tmp81_);
			_tmp83_ = _tmp82_;
			desktop_folder_folder_arrangement_motion_drag (_tmp83_, x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X, y);
			_g_object_unref0 (_tmp83_);
			_g_object_unref0 (_tmp81_);
			_g_object_unref0 (selecteds);
			_g_object_unref0 (window);
		}
		result = TRUE;
		_g_object_unref0 (ims);
		_g_object_unref0 (folder_settings);
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

/**
     * @name RoundDownToMultiple
     * @description util function for the movement of icons
     */
static inline gint
desktop_folder_item_view_RoundDownToMultiple (gint i,
                                              gint m)
{
	gint result;
	result = (i / m) * m;
	return result;
}

/**
     * @name RoundToNearestMultiple
     * @description util function for the movement of icons
     */
gint
desktop_folder_item_view_RoundToNearestMultiple (gint i,
                                                 gint m)
{
	gint result;
	if (((gdouble) (i % m)) > (((gdouble) m) / 2.0)) {
		result = ((i / m) + 1) * m;
		return result;
	}
	result = (i / m) * m;
	return result;
}

static void
desktop_folder_item_view_class_init (DesktopFolderItemViewClass * klass,
                                     gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
	desktop_folder_item_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DesktopFolderItemView_private_offset);
	((DesktopFolderItemViewClass *) klass)->create_label = (void (*) (DesktopFolderItemView*, const gchar*)) desktop_folder_item_view_real_create_label;
	G_OBJECT_CLASS (klass)->finalize = desktop_folder_item_view_finalize;
	{
		gint scale = 0;
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
		scale = DESKTOP_FOLDER_ICON_SIZE / 3;
		_tmp1_ = gdk_pixbuf_new_from_resource ("/com/github/spheras/desktopfolder/link.svg", &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (desktop_folder_item_view_LINK_PIXBUF);
		desktop_folder_item_view_LINK_PIXBUF = _tmp2_;
		_tmp3_ = desktop_folder_item_view_LINK_PIXBUF;
		_tmp4_ = gdk_pixbuf_scale_simple (_tmp3_, scale, scale, GDK_INTERP_BILINEAR);
		_g_object_unref0 (desktop_folder_item_view_LINK_PIXBUF);
		desktop_folder_item_view_LINK_PIXBUF = _tmp4_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		fprintf (_tmp5_, "Error: %s\n", _tmp7_);
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		desktop_folder_util_show_error_dialog ("Error", _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
}

static void
desktop_folder_item_view_instance_init (DesktopFolderItemView * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
	self->priv = desktop_folder_item_view_get_instance_private (self);
	self->priv->flagModified = FALSE;
	self->priv->flagMoved = FALSE;
	self->priv->menu = NULL;
	self->priv->hide_extension = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->hidden_extension = _tmp0_;
	self->priv->icon = NULL;
	self->priv->flag_dragdrop_started = FALSE;
	memset (&self->priv->start_drag_point, 0, sizeof (GdkPoint));
}

static void
desktop_folder_item_view_finalize (GObject * obj)
{
	DesktopFolderItemView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemView);
	_g_object_unref0 (self->priv->manager);
	_g_object_unref0 (self->priv->menu);
	_g_free0 (self->priv->hidden_extension);
	_g_object_unref0 (self->priv->container);
	_g_object_unref0 (self->priv->label);
	_g_object_unref0 (self->priv->icon);
	_g_object_unref0 (self->priv->drag_context);
	G_OBJECT_CLASS (desktop_folder_item_view_parent_class)->finalize (obj);
}

static GType
desktop_folder_item_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderItemViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_item_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderItemView), 0, (GInstanceInitFunc) desktop_folder_item_view_instance_init, NULL };
	GType desktop_folder_item_view_type_id;
	desktop_folder_item_view_type_id = g_type_register_static (gtk_event_box_get_type (), "DesktopFolderItemView", &g_define_type_info, 0);
	DesktopFolderItemView_private_offset = g_type_add_instance_private (desktop_folder_item_view_type_id, sizeof (DesktopFolderItemViewPrivate));
	return desktop_folder_item_view_type_id;
}

GType
desktop_folder_item_view_get_type (void)
{
	static volatile gsize desktop_folder_item_view_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_item_view_type_id__once)) {
		GType desktop_folder_item_view_type_id;
		desktop_folder_item_view_type_id = desktop_folder_item_view_get_type_once ();
		g_once_init_leave (&desktop_folder_item_view_type_id__once, desktop_folder_item_view_type_id);
	}
	return desktop_folder_item_view_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

